VERSION 5.00
Begin VB.Form frmCommands 
   Caption         =   "Commands"
   ClientHeight    =   3750
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6975
   Icon            =   "frmCommands.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   3750
   ScaleWidth      =   6975
   WindowState     =   2  'Maximized
   Begin VB.TextBox txtAccess 
      Alignment       =   2  'Center
      Enabled         =   0   'False
      Height          =   255
      Left            =   6600
      MaxLength       =   1
      TabIndex        =   2
      Text            =   "0"
      ToolTipText     =   "Minimum access required to run the command."
      Top             =   0
      Width           =   375
   End
   Begin VB.TextBox txtCommandName 
      Enabled         =   0   'False
      Height          =   255
      Left            =   2520
      TabIndex        =   1
      Text            =   "No Command Selected"
      ToolTipText     =   "Name of the current command."
      Top             =   0
      Width           =   4095
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   0
      TabIndex        =   4
      ToolTipText     =   "Add a new command."
      Top             =   3360
      Width           =   1575
   End
   Begin VB.CommandButton cmdDel 
      Caption         =   "Remove"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5400
      TabIndex        =   5
      ToolTipText     =   "Remove the selected command."
      Top             =   3360
      Width           =   1575
   End
   Begin VB.TextBox txtCommand 
      Enabled         =   0   'False
      Height          =   2985
      Left            =   2520
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      ToolTipText     =   "Code to execute when command is called."
      Top             =   360
      Width           =   4455
   End
   Begin VB.ListBox lstCommands 
      Height          =   3345
      IntegralHeight  =   0   'False
      ItemData        =   "frmCommands.frx":0442
      Left            =   0
      List            =   "frmCommands.frx":0444
      TabIndex        =   0
      ToolTipText     =   "List of command names."
      Top             =   0
      Width           =   2415
   End
   Begin VB.ListBox lstAcs 
      BackColor       =   &H00000000&
      ForeColor       =   &H000000FF&
      Height          =   270
      IntegralHeight  =   0   'False
      ItemData        =   "frmCommands.frx":0446
      Left            =   1680
      List            =   "frmCommands.frx":0448
      TabIndex        =   7
      Top             =   3480
      Visible         =   0   'False
      Width           =   135
   End
   Begin VB.ListBox lstCode 
      BackColor       =   &H00000000&
      ForeColor       =   &H000000FF&
      Height          =   270
      IntegralHeight  =   0   'False
      ItemData        =   "frmCommands.frx":044A
      Left            =   1920
      List            =   "frmCommands.frx":044C
      TabIndex        =   6
      Top             =   3480
      Visible         =   0   'False
      Width           =   135
   End
End
Attribute VB_Name = "frmCommands"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub cmdAdd_Click()
    lstCommands.AddItem "New Command"
    lstCommands.Selected(lstCommands.ListCount - 1) = True
    lstCode.AddItem vbNullString
    lstAcs.AddItem "0"
    txtCommand.Text = vbNullString
    txtAccess.Text = "0"
    txtCommandName.Text = "Untitled"
    txtCommandName.SetFocus
End Sub
Private Sub cmdDel_Click()
    If lstCommands.SelCount > 0 Then
        Dim I As Integer
        For I = 0 To lstCommands.ListCount - 1
            If lstCommands.Selected(I) = True Then
                lstCommands.RemoveItem (I)
                lstAcs.RemoveItem (I)
                lstCode.RemoveItem (I)
                If lstCommands.ListCount > 0 Then
                    If I = 0 Then I = 1
                    lstCommands.Selected(I - 1) = True
                    lstCommands_Click
                Else
                    txtAccess = "0"
                    txtAccess.Enabled = False
                    txtCommand = vbNullString
                    txtCommand.Enabled = False
                    txtCommandName = "No Command Selected"
                    txtCommandName.Enabled = False
                End If
                Exit Sub
            End If
        Next I
    Else
        Beep
    End If
End Sub
Private Sub Form_Resize()
    On Error Resume Next
    lstCommands.Move 0, 0, lstCommands.Width, Me.ScaleHeight - cmdAdd.Height - 100
    txtCommandName.Move lstCommands.Width + 100, 0, Me.ScaleWidth - txtCommandName.Left - txtAccess.Width
    txtAccess.Move txtCommandName.Left + txtCommandName.Width, txtCommandName.Top
    txtCommand.Move txtCommandName.Left, txtCommandName.Height + 100, Me.ScaleWidth - txtCommand.Left, Me.ScaleHeight - txtCommand.Top - cmdAdd.Height - 100
    cmdAdd.Move 0, lstCommands.Height + 100
    cmdDel.Move Me.ScaleWidth - cmdDel.Width, cmdAdd.Top
End Sub
Private Sub lstCommands_Click()
    Dim I As Integer
    For I = 0 To lstCommands.ListCount - 1
        If lstCommands.Selected(I) = True Then
            txtCommand.Enabled = True
            txtAccess.Enabled = True
            txtCommandName.Enabled = True
            txtCommand.Text = lstCode.List(I)
            txtAccess.Text = lstAcs.List(I)
            txtCommandName = lstCommands.Text
            Exit Sub
        End If
    Next I
    txtCommand.Enabled = False
    txtAccess.Enabled = False
    txtCommandName.Enabled = False
End Sub
Private Sub lstCommands_KeyUp(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyDelete Then
        cmdDel_Click
    ElseIf KeyCode = vbKeyInsert Then
        cmdAdd_Click
    End If
End Sub
Private Sub txtAccess_Change()
    If lstCommands.ListCount > 0 Then
        Dim I As Integer
        For I = 0 To lstCommands.ListCount - 1
            If lstCommands.Selected(I) = True Then
                lstAcs.List(I) = Val(txtAccess.Text)
                txtAccess.Text = Val(txtAccess.Text)
                Exit Sub
            End If
        Next I
    Else
        Beep
        txtAccess.Text = "0"
    End If
End Sub
Private Sub txtCommand_Change()
    If lstCommands.ListCount > 0 Then
        Dim I As Integer
        For I = 0 To lstCommands.ListCount - 1
            If lstCommands.Selected(I) = True Then
                lstCode.List(I) = txtCommand.Text
                Exit Sub
            End If
        Next I
    Else
        Beep
        txtCommand.Text = vbNullString
    End If
End Sub
Private Sub txtCommandName_Change()
    txtCommandName = Replace(txtCommandName, " ", vbNullString)
    Dim I As Integer
    For I = 0 To lstCommands.ListCount - 1
        If lstCommands.Selected(I) = True Then lstCommands.List(I) = txtCommandName.Text
    Next I
    If txtCommandName = vbNullString Then
        txtCommandName = "Untitled"
        Beep
        txtCommandName.SelStart = 0
        txtCommandName.SelLength = Len(txtCommandName)
    End If
End Sub
