VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmGreet 
   Caption         =   "Greetings"
   ClientHeight    =   4065
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7065
   Icon            =   "frmGreet.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   4065
   ScaleWidth      =   7065
   WindowState     =   2  'Maximized
   Begin VB.CommandButton cmdRemoveGreet 
      Caption         =   "Remove"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5760
      TabIndex        =   3
      ToolTipText     =   "Remove the selected Personal Greeting."
      Top             =   3615
      Width           =   1215
   End
   Begin VB.CommandButton cmdAddGreet 
      Caption         =   "Add"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4920
      TabIndex        =   2
      ToolTipText     =   "Add a new Personal Greeting."
      Top             =   3600
      Width           =   735
   End
   Begin VB.TextBox txtUserGreet 
      Height          =   285
      Left            =   0
      MaxLength       =   250
      TabIndex        =   0
      ToolTipText     =   "Name of a user to greet."
      Top             =   3720
      Width           =   2295
   End
   Begin VB.TextBox txtGreetGreet 
      Height          =   285
      Left            =   2400
      MaxLength       =   250
      TabIndex        =   1
      ToolTipText     =   "Message to display when the user enters the channel."
      Top             =   3720
      Width           =   2295
   End
   Begin MSComctlLib.ListView lvGreet 
      Height          =   3255
      Left            =   0
      TabIndex        =   4
      ToolTipText     =   "List of users to greet."
      Top             =   0
      Width           =   6975
      _ExtentX        =   12303
      _ExtentY        =   5741
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   0   'False
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Arial"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   2
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "User"
         Object.Width           =   6068
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Greeting"
         Object.Width           =   6068
      EndProperty
   End
   Begin VB.Label lblUserGreet 
      AutoSize        =   -1  'True
      BackColor       =   &H80000012&
      BackStyle       =   0  'Transparent
      Caption         =   "User To Greet:"
      ForeColor       =   &H80000008&
      Height          =   210
      Left            =   0
      TabIndex        =   5
      Top             =   3360
      UseMnemonic     =   0   'False
      Width           =   1065
   End
   Begin VB.Label lblGreetGreet 
      AutoSize        =   -1  'True
      BackColor       =   &H80000012&
      BackStyle       =   0  'Transparent
      Caption         =   "Greeting:"
      ForeColor       =   &H80000008&
      Height          =   210
      Left            =   2400
      TabIndex        =   6
      Top             =   3360
      UseMnemonic     =   0   'False
      Width           =   660
   End
End
Attribute VB_Name = "frmGreet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub cmdAddGreet_Click()
    If LenB(txtUserGreet.Text) <> 0 And LenB(txtGreetGreet.Text) <> 0 Then
        If lvGreet.ListItems.Count > 0 Then
            Dim I As Integer
            For I = 1 To lvGreet.ListItems.Count
                If Trim$(LCase$(lvGreet.ListItems(I).Text)) = Trim$(LCase$(txtUserGreet.Text)) Then
                    MsgBox txtUserGreet.Text & " already exists on the Personal Greet list!", vbExclamation
                    txtUserGreet.SetFocus
                    Exit Sub
                End If
            Next I
        End If
        lvGreet.ListItems.Add , , txtUserGreet.Text
        lvGreet.FindItem(txtUserGreet, lvwText, , lvwWhole).SubItems(1) = txtGreetGreet.Text
        lvGreet.FindItem(txtUserGreet, lvwText, , lvwWhole).Selected = True
        txtUserGreet.Text = vbNullString
        txtGreetGreet.Text = vbNullString
        txtUserGreet.SetFocus
    Else
        If LenB(txtGreetGreet.Text) = 0 Then txtGreetGreet.SetFocus
        If LenB(txtUserGreet.Text) = 0 Then txtUserGreet.SetFocus
        Beep
    End If
End Sub
Private Sub cmdRemoveGreet_Click()
    If lvGreet.ListItems.Count > 0 Then
        lvGreet.ListItems.Remove (lvGreet.SelectedItem.Index)
        If lvGreet.ListItems.Count > 0 Then lvGreet.ListItems(lvGreet.ListItems.Count).Selected = True
    Else
        Beep
    End If
    txtUserGreet.SetFocus
End Sub
Private Sub lvGreet_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    lvGreet.SortKey = ColumnHeader.Index - 1
    If lvGreet.SortOrder = lvwAscending Then
        lvGreet.SortOrder = lvwDescending
    Else
        lvGreet.SortOrder = lvwAscending
    End If
    lvGreet.Sorted = True
End Sub
Private Sub lvGreet_DblClick()
    txtUserGreet.Text = lvGreet.SelectedItem.Text
    txtGreetGreet.Text = lvGreet.SelectedItem.SubItems(1)
    lvGreet.ListItems.Remove (lvGreet.SelectedItem.Index)
End Sub
Private Sub lvGreet_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyDelete Then
        cmdRemoveGreet_Click
    ElseIf KeyCode = vbKeyInsert Then
        cmdAddGreet_Click
    End If
End Sub
Private Sub txtUserGreet_GotFocus()
    txtUserGreet.SelStart = 0
    txtUserGreet.SelLength = Len(txtUserGreet)
End Sub
Private Sub txtUserGreet_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
        KeyAscii = 0
        If txtUserGreet.Text = vbNullString Then
            txtUserGreet.SetFocus
        Else
            cmdAddGreet_Click
        End If
    ElseIf KeyAscii > 64 And KeyAscii < 91 Then
        'A-Z
    ElseIf KeyAscii > 96 And KeyAscii < 123 Then
        'a-z
    ElseIf KeyAscii > 47 And KeyAscii < 58 Then
        '0-9
    ElseIf KeyAscii = 40 Or KeyAscii = 41 Or KeyAscii = 91 Or KeyAscii = 93 Or KeyAscii = 95 Or KeyAscii = 45 Or KeyAscii = 46 Or KeyAscii = 64 Then
        'Symbols
    ElseIf KeyAscii = vbKeyBack Or KeyAscii = 26 Or KeyAscii = 24 Or KeyAscii = 3 Or KeyAscii = 22 Then
        'allowed others
    Else
        Beep
        KeyAscii = 0
    End If
End Sub
Private Sub txtGreetGreet_GotFocus()
    txtGreetGreet.SelStart = 0
    txtGreetGreet.SelLength = Len(txtGreetGreet)
End Sub
Private Sub txtGreetGreet_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
        cmdAddGreet_Click
        KeyAscii = 0
    End If
End Sub
Private Sub Form_Resize()
    On Error Resume Next
    lvGreet.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight - txtUserGreet.Height - lblUserGreet.Height - 200
    lblUserGreet.Move 0, lvGreet.Height + 100
    lblGreetGreet.Move (Me.ScaleWidth - cmdAddGreet.Width - cmdRemoveGreet.Width - 200) / 2, lblUserGreet.Top
    txtUserGreet.Move 0, lblUserGreet.Top + lblUserGreet.Height + 100, lblGreetGreet.Left - 100
    txtGreetGreet.Move lblGreetGreet.Left, txtUserGreet.Top, txtUserGreet.Width
    cmdAddGreet.Move txtGreetGreet.Left + txtGreetGreet.Width + 100, lblUserGreet.Top + lblUserGreet.Height
    cmdRemoveGreet.Move cmdAddGreet.Left + cmdAddGreet.Width + 100, cmdAddGreet.Top
End Sub
