VERSION 5.00
Begin VB.Form frmPermaSquelch 
   Caption         =   "PermaSquelch"
   ClientHeight    =   3825
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6765
   Icon            =   "frmPermaSquelch.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   3825
   ScaleWidth      =   6765
   WindowState     =   2  'Maximized
   Begin VB.CommandButton cmdAddSquelch 
      Caption         =   "Add"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4680
      TabIndex        =   1
      ToolTipText     =   "Add a new user to the PermaSquelch List."
      Top             =   3360
      Width           =   735
   End
   Begin VB.CommandButton cmdRemoveSquelch 
      Caption         =   "Remove"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5520
      TabIndex        =   2
      ToolTipText     =   "Remove the selected user from the PermaSquelch List."
      Top             =   3360
      Width           =   1215
   End
   Begin VB.TextBox txtSquelch 
      Height          =   315
      Left            =   0
      TabIndex        =   0
      ToolTipText     =   "Name of a user to add to the PermaSquelch List."
      Top             =   3360
      Width           =   4575
   End
   Begin VB.ListBox lstSquelch 
      Height          =   3180
      IntegralHeight  =   0   'False
      ItemData        =   "frmPermaSquelch.frx":0442
      Left            =   0
      List            =   "frmPermaSquelch.frx":0444
      TabIndex        =   3
      ToolTipText     =   "List of PermaSquelched users."
      Top             =   0
      Width           =   6735
   End
End
Attribute VB_Name = "frmPermaSquelch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub cmdAddSquelch_Click()
    If txtSquelch.Text <> vbNullString Then
        Dim I As Integer
        If lstSquelch.ListCount > 0 Then
            For I = 0 To lstSquelch.ListCount - 1
                If Trim$(LCase$(lstSquelch.List(I))) = Trim$(LCase$(txtSquelch.Text)) Then
                    MsgBox txtSquelch.Text & " already exists on the Ban list!", vbExclamation
                    txtSquelch.SetFocus
                    Exit Sub
                End If
            Next I
        End If
        lstSquelch.AddItem txtSquelch.Text
        txtSquelch.Text = vbNullString
        txtSquelch.SetFocus
    Else
        Beep
        txtSquelch.SetFocus
    End If
End Sub
Private Sub cmdRemoveSquelch_Click()
    If lstSquelch.ListCount > 0 Then
        Dim I As Integer
        For I = 0 To lstSquelch.ListCount - 1
            If lstSquelch.Selected(I) = True Then
                lstSquelch.RemoveItem (I)
                Exit For
            End If
        Next I
    Else
        Beep
    End If
    txtSquelch.SetFocus
End Sub
Private Sub Form_Resize()
    On Error Resume Next
    lstSquelch.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight - txtSquelch.Height - 100
    txtSquelch.Move 0, lstSquelch.Height + 100, Me.ScaleWidth - cmdAddSquelch.Width - cmdRemoveSquelch.Width - 200
    cmdAddSquelch.Move txtSquelch.Width + 100, txtSquelch.Top, cmdAddSquelch.Width, txtSquelch.Height
    cmdRemoveSquelch.Move txtSquelch.Width + cmdAddSquelch.Width + 200, txtSquelch.Top, cmdRemoveSquelch.Width, txtSquelch.Height
End Sub
Private Sub lstSquelch_DblClick()
    If lstSquelch.ListIndex > -1 Then
        txtSquelch.Text = lstSquelch.Text
        lstSquelch.RemoveItem lstSquelch.ListIndex
    Else
        Beep
    End If
End Sub
Private Sub lstSquelch_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyDelete Then
        cmdRemoveSquelch_Click
    ElseIf KeyAscii = vbKeyInsert Then
        cmdAddSquelch_Click
    End If
End Sub
Private Sub txtSquelch_GotFocus()
    txtSquelch.SelStart = 0
    txtSquelch.SelLength = Len(txtSquelch)
End Sub
Private Sub txtSquelch_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
        cmdAddSquelch_Click
        KeyAscii = 0
    ElseIf KeyAscii > 64 And KeyAscii < 91 Then
        'A-Z
    ElseIf KeyAscii > 96 And KeyAscii < 123 Then
        'a-z
    ElseIf KeyAscii > 47 And KeyAscii < 58 Then
        '0-9
    ElseIf KeyAscii = 40 Or KeyAscii = 41 Or KeyAscii = 91 Or KeyAscii = 93 Or KeyAscii = 95 Or KeyAscii = 45 Or KeyAscii = 46 Or KeyAscii = 64 Then
        'Symbols
    ElseIf KeyAscii = vbKeyBack Or KeyAscii = 26 Or KeyAscii = 24 Or KeyAscii = 3 Or KeyAscii = 22 Then
        'allowed others
    Else
        Beep
        KeyAscii = 0
    End If
End Sub

