VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.MDIForm mdiMain 
   BackColor       =   &H8000000C&
   Caption         =   "Ripple Chat Bot Document Reader"
   ClientHeight    =   5865
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   10740
   Icon            =   "mdiMain.frx":0000
   LinkTopic       =   "MDIForm1"
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrUpdate 
      Interval        =   150
      Left            =   1920
      Top             =   2040
   End
   Begin MSComctlLib.StatusBar sbBar 
      Align           =   2  'Align Bottom
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   5610
      Width           =   10740
      _ExtentX        =   18944
      _ExtentY        =   450
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   3
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            AutoSize        =   1
            Object.Width           =   16678
            MinWidth        =   3528
            Text            =   "No Document Open"
            TextSave        =   "No Document Open"
         EndProperty
         BeginProperty Panel2 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            Style           =   1
            Alignment       =   1
            AutoSize        =   2
            Enabled         =   0   'False
            Object.Width           =   900
            MinWidth        =   2
            TextSave        =   "CAPS"
         EndProperty
         BeginProperty Panel3 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            Style           =   2
            Alignment       =   1
            AutoSize        =   2
            Enabled         =   0   'False
            Object.Width           =   820
            MinWidth        =   2
            TextSave        =   "NUM"
         EndProperty
      EndProperty
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuSave 
         Caption         =   "&Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuSpace1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
         Shortcut        =   ^Q
      End
   End
   Begin VB.Menu mnuWindows 
      Caption         =   "Windows"
      WindowList      =   -1  'True
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuAbout 
         Caption         =   "About"
         Shortcut        =   ^{F1}
      End
   End
End
Attribute VB_Name = "mdiMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'RCB Document Viewer
'Andrew Sachen
' 11111010111 RealityRipple Software
'
'Program Created-June 9, 2006
'Program Last Modified-January 22,2007
Option Explicit
Dim cdlCustom As New cCommonDialog
Private Declare Sub SHChangeNotify Lib "shell32.dll" (ByVal wEventId As Long, ByVal uFlags As Long, dwItem1 As Any, dwItem2 As Any)
Const SHCNE_ASSOCCHANGED = &H8000000
Const SHCNF_IDLIST = &H0&
Private Type CustomCmd
    cmdName As String
    cmdAccess As Double
    cmdCode As String
End Type
Private Sub MDIForm_Load()
    Dim sKeyName As String
    Dim sKeyValue As String
    sKeyName = "RCB"
    sKeyValue = "Ripple Chat Bot Document"
    regCreate_A_Key HKEY_CLASSES_ROOT, sKeyName
    regCreate_Key_Value HKEY_CLASSES_ROOT, sKeyName, "", sKeyValue
    sKeyValue = """" & App.Path & "\RCBdoc.exe"" %1"
    regCreate_A_Key HKEY_CLASSES_ROOT, sKeyName
    regCreate_Key_Value HKEY_CLASSES_ROOT, sKeyName & "\shell\open\command", "", sKeyValue
    sKeyValue = App.Path & "\RCBdoc.exe, 0"
    regCreate_A_Key HKEY_CLASSES_ROOT, sKeyName
    regCreate_Key_Value HKEY_CLASSES_ROOT, sKeyName & "\DefaultIcon", "", sKeyValue
    sKeyName = ".rcb"
    sKeyValue = "RCB"
    regCreate_A_Key HKEY_CLASSES_ROOT, sKeyName
    regCreate_Key_Value HKEY_CLASSES_ROOT, sKeyName, "", sKeyValue
    SHChangeNotify SHCNE_ASSOCCHANGED, SHCNF_IDLIST, 0, 0
    If Command <> vbNullString Then
        If InStrRev(Command, "\") > 0 Then
            Dim TmpName As String
            TmpName = Mid$(Command, InStrRev(Command, "\") + 1)
            OpenFile TmpName, Command
        End If
    End If
End Sub
Private Sub mnuAbout_Click()
    frmAbout.Show , Me
End Sub
Private Sub mnuExit_Click()
    Unload Me
End Sub
Private Sub mnuFile_Click()
    On Error GoTo NoForm
    Dim tmp As String
    tmp = mdiMain.ActiveForm.Name
    mnuSave.Enabled = True
    Exit Sub
NoForm:
    mnuSave.Enabled = False
End Sub
Private Sub OpenFile(fName As String, fPath As String)
    Dim nFile As Integer, tmp As String, I As Integer
    nFile = FreeFile
    Select Case LCase$(fName)
        Case "channels.rcb"
            'Channel List
            Dim NewChan As New frmChannels
            NewChan.Show
            NewChan.Caption = fPath
            Open fPath For Input As #nFile
            I = 0
            Do Until EOF(nFile)
                Line Input #nFile, tmp
                NewChan.txtChannel(I).Text = tmp
                I = I + 1
                If I > 11 Then Exit Do
            Loop
            Close #nFile
        Case "cmds.rcb"
            'Command List
            Dim NewCmd As New frmCommands
            NewCmd.Show
            NewCmd.Caption = fPath
            Dim tmpc As CustomCmd
            Open fPath For Input As #nFile
            Do Until EOF(nFile)
                Line Input #nFile, tmpc.cmdName
                Dim acs As String
                Line Input #nFile, acs
                tmpc.cmdAccess = Val(acs)
                Line Input #nFile, tmpc.cmdCode
                tmpc.cmdCode = Replace(tmpc.cmdCode, "& ", vbCrLf)
                If LenB(tmpc.cmdName) <> 0 Then
                    NewCmd.lstCommands.AddItem tmpc.cmdName
                    NewCmd.lstAcs.AddItem tmpc.cmdAccess
                    NewCmd.lstCode.AddItem tmpc.cmdCode
                End If
            Loop
            Close #nFile
        Case "greet.rcb"
            'Custom Greeting List
            Dim NewGreet As New frmGreet
            NewGreet.Show
            NewGreet.Caption = fPath
            Open fPath For Input As #nFile
            Dim UserGreet As String, GreetGreet As String
            Do Until EOF(nFile)
                Line Input #nFile, UserGreet
                Line Input #nFile, GreetGreet
                If LenB(UserGreet) <> 0 Then
                    NewGreet.lvGreet.ListItems.Add , , UserGreet
                    NewGreet.lvGreet.ListItems(NewGreet.lvGreet.ListItems.Count).SubItems(1) = GreetGreet
                End If
            Loop
            Close #nFile
        Case "mail.rcb"
            'Mail
            Dim NewMail As New frmMail
            NewMail.Show
            NewMail.Caption = fPath
            Open fPath For Input As #nFile
            Do Until EOF(nFile)
                Dim TmpMsg As Messages
                Line Input #nFile, TmpMsg.To
                Line Input #nFile, TmpMsg.From
                Line Input #nFile, TmpMsg.Date
                Line Input #nFile, TmpMsg.Message
                ReDim Preserve msgList(I) As Messages
                NewMail.cmbMail.AddItem TmpMsg.Date & " (" & TmpMsg.From & " > " & TmpMsg.To & ")"
                msgList(I).From = TmpMsg.From
                msgList(I).To = TmpMsg.To
                msgList(I).Date = TmpMsg.Date
                msgList(I).Message = TmpMsg.Message
                I = I + 1
            Loop
            NewMail.cmbMail.Text = NewMail.cmbMail.List(0)
            Close #nFile
        Case "ps.rcb", "ts.rcb"
            'Permasquelch List
            Dim NewSquelch As New frmPermaSquelch
            NewSquelch.Show
            NewSquelch.Caption = fPath
            Open fPath For Input As #nFile
            Do Until EOF(nFile)
                Line Input #nFile, tmp
                NewSquelch.lstSquelch.AddItem tmp
            Loop
            Close #nFile
        Case "quotes.rcb"
            'Quotes List
            Dim NewQuote As New frmQuotes
            NewQuote.Show
            NewQuote.Caption = fPath
            Open fPath For Input As #nFile
            Do Until EOF(nFile)
                Line Input #nFile, tmp
                NewQuote.lstQuotes.AddItem tmp
            Loop
            Close #nFile
        Case "resp.rcb"
            'Auto-Response List
            Dim NewResp As New frmResp
            NewResp.Show
            NewResp.Caption = fPath
            Open fPath For Input As #nFile
            Dim Say As String, Respond As String, Sensitive As String
            Do Until EOF(nFile)
                Line Input #nFile, Say
                Line Input #nFile, Respond
                Line Input #nFile, Sensitive
                If LenB(Say) <> 0 Then
                    NewResp.lvRespond.ListItems.Add , , Say
                    NewResp.lvRespond.ListItems(NewResp.lvRespond.ListItems.Count).SubItems(1) = Respond
                    If Sensitive = "True" Then
                        NewResp.lvRespond.ListItems(NewResp.lvRespond.ListItems.Count).Checked = True
                    Else
                        NewResp.lvRespond.ListItems(NewResp.lvRespond.ListItems.Count).Checked = False
                    End If
                End If
            Loop
            Close #nFile
        Case "users.rcb"
            'User List
            Dim NewUser As New frmUsers
            NewUser.Show
            NewUser.Caption = fPath
            Open fPath For Input As #nFile
            Dim User As String, Access As String, Tag As String
            Do Until EOF(nFile)
                Line Input #nFile, User
                Line Input #nFile, Access
                Line Input #nFile, Tag
                If LenB(User) <> 0 Then
                    NewUser.lvUsers.ListItems.Add , , User
                    NewUser.lvUsers.ListItems(NewUser.lvUsers.ListItems.Count).SubItems(1) = Access
                    NewUser.lvUsers.ListItems(NewUser.lvUsers.ListItems.Count).SubItems(2) = Tag
                End If
            Loop
            Close #nFile
        Case Else
            'Generic File
            Dim NewFile As New frmGeneric
            NewFile.Show
            NewFile.Caption = fPath
            Open fPath For Input As #nFile
            Do Until EOF(nFile)
                Line Input #nFile, tmp
                NewFile.txtEditor.Text = NewFile.txtEditor.Text & tmp & vbNewLine
            Loop
            Close #nFile
    End Select
End Sub
Private Sub mnuOpen_Click()
    On Error GoTo Cancel
    cdlCustom.CancelError = True
    cdlCustom.Filter = "Ripple Chat Bot Document (*.rcb)|*.rcb|All Files (*.*)|*.*"
    cdlCustom.FileName = App.Path & "\file.rcb"
    cdlCustom.ShowOpen
    OpenFile cdlCustom.FileTitle, cdlCustom.FileName
    Exit Sub
Cancel:
    'Donothing
End Sub
Private Sub mnuSave_Click()
    'On Error GoTo NoForm
    Dim FormName As String, nFile As Integer, tmp As String, I As Integer
    FormName = mdiMain.ActiveForm.Name
    mnuSave.Enabled = True
    Debug.Print FormName
    nFile = FreeFile
    Select Case FormName
        Case "frmChannels"
            'Channel List
            Open mdiMain.ActiveForm.Caption For Output As #nFile
            For I = 0 To 11
                Print #nFile, ActiveForm.txtChannel(I).Text
            Next I
            Close #nFile
        Case "frmCommands"
            'Command List
            Open mdiMain.ActiveForm.Caption For Output As #nFile
            For I = 0 To ActiveForm.lstCommands.ListCount - 1
                Dim TmpCode As String
                TmpCode = ActiveForm.lstCode.List(I)
                TmpCode = Replace(TmpCode, vbCrLf, "& ")
                Print #nFile, ActiveForm.lstCommands.List(I)
                Print #nFile, ActiveForm.lstAcs.List(I)
                Print #nFile, TmpCode
            Next I
            Close #nFile
        Case "frmGreet"
            'Custom Greeting List
            Open mdiMain.ActiveForm.Caption For Output As #nFile
            Dim UserGreet As String, GreetGreet As String
            For I = 1 To ActiveForm.lvGreet.ListItems.Count
                UserGreet = ActiveForm.lvGreet.ListItems(I).Text
                GreetGreet = ActiveForm.lvGreet.ListItems(I).SubItems(1)
                If LenB(UserGreet) <> 0 And LenB(GreetGreet) <> 0 Then
                    Print #nFile, UserGreet
                    Print #nFile, GreetGreet
                End If
            Next I
            Close #nFile
            Case "frmMail"
            'Mail
        Case "frmPermaSquelch"
            'Permasquelch List
            Open mdiMain.ActiveForm.Caption For Output As #nFile
            For I = 0 To ActiveForm.lstSquelch.ListCount - 1
                Print #nFile, ActiveForm.lstSquelch.List(I)
            Next I
            Close #nFile
        Case "frmQuotes"
            'Quotes List
            Open mdiMain.ActiveForm.Caption For Output As #nFile
            For I = 0 To ActiveForm.lstQuotes.ListCount - 1
                Print #nFile, ActiveForm.lstQuotes.List(I)
            Next I
            Close #nFile
        Case "frmResp"
            'Auto-Response List
            Open mdiMain.ActiveForm.Caption For Output As #nFile
            Dim UserText As String, BotRespond As String, Sensitive As String
            For I = 1 To ActiveForm.lvRespond.ListItems.Count
                UserText = ActiveForm.lvRespond.ListItems(I).Text
                BotRespond = ActiveForm.lvRespond.ListItems(I).SubItems(1)
                Sensitive = ActiveForm.lvRespond.ListItems(I).Checked
                If LenB(UserText) <> 0 And LenB(BotRespond) <> 0 Then
                    Print #nFile, UserText
                    Print #nFile, BotRespond
                    Print #nFile, Sensitive
                End If
            Next I
            Close #nFile
        Case "frmUsers"
            'User List
            Open mdiMain.ActiveForm.Caption For Output As #nFile
            For I = 1 To ActiveForm.lvUsers.ListItems.Count
                If LenB(Trim$(ActiveForm.lvUsers.ListItems.Item(I).Text)) <> 0 Then
                    Print #nFile, Trim$(ActiveForm.lvUsers.ListItems.Item(I))
                    Print #nFile, Trim$(ActiveForm.lvUsers.ListItems.Item(I).SubItems(1))
                    Print #nFile, Trim$(ActiveForm.lvUsers.ListItems.Item(I).SubItems(2))
                End If
            Next I
            Close #nFile
        Case Else
            'Generic File
            Open mdiMain.ActiveForm.Caption For Output As #nFile
            For I = 1 To Len(mdiMain.ActiveForm.txtEditor)
                Print #nFile, Mid$(mdiMain.ActiveForm.txtEditor, I, 1);
            Next I
            Close #nFile
    End Select
    Exit Sub
NoForm:
    mnuSave.Enabled = False
End Sub
Private Sub tmrUpdate_Timer()
    On Error GoTo NoForm
    Dim tmp As String
    tmp = mdiMain.ActiveForm.Caption
    mdiMain.sbBar.Panels(1).Text = tmp
    mnuSave.Enabled = True
    Exit Sub
NoForm:
    mnuSave.Enabled = False
    mdiMain.sbBar.Panels(1).Text = "No Document Open"
End Sub
