Attribute VB_Name = "modBNCSutil"
Option Explicit
Private Type sockaddr_in
    sin_family  As Integer
    sin_port    As Integer
    sin_addr    As Long
    sin_zero    As String * 8
End Type
Private Declare Function getpeername Lib "ws2_32.dll" (ByVal s As Long, Name As sockaddr_in, namelen As Long) As Long
Private Declare Function bncsutil_getVersionString Lib "bncsutil.dll" (ByVal OutBuf As String) As Long
Private Declare Sub hashPassword Lib "bncsutil.dll" (ByVal Password As String, ByVal outBuffer As String)
Private Declare Sub doubleHashPassword Lib "bncsutil.dll" (ByVal Password As String, ByVal ClientToken As Long, ByVal ServerToken As Long, ByVal outBuffer As String)
Public Declare Sub nls_free Lib "bncsutil.dll" (ByVal NLS As Long)
Public Declare Sub nls_get_A Lib "bncsutil.dll" (ByVal NLS As Long, ByVal Out As String)
Public Declare Sub nls_get_M1 Lib "bncsutil.dll" (ByVal NLS As Long, ByVal Out As String, ByVal B As String, ByVal Salt As String)
Public Declare Sub calcHashBuf Lib "bncsutil.dll" (ByVal Data As String, ByVal Length As Long, ByVal Hash As String)
Public Declare Function kd_init Lib "bncsutil.dll" () As Long
Public Declare Function kd_free Lib "bncsutil.dll" (ByVal decoder As Long) As Long
Public Declare Function kd_val1 Lib "bncsutil.dll" (ByVal decoder As Long) As Long
Public Declare Function kd_val2 Lib "bncsutil.dll" (ByVal decoder As Long) As Long
Public Declare Function kd_product Lib "bncsutil.dll" (ByVal decoder As Long) As Long
Public Declare Function kd_isValid Lib "bncsutil.dll" (ByVal decoder As Long) As Long
Public Declare Function kd_getHash Lib "bncsutil.dll" (ByVal decoder As Long, ByVal Out As String) As Long
Public Declare Function kd_create Lib "bncsutil.dll" (ByVal CDKey As String, ByVal keyLength As Long) As Long
Public Declare Function kd_calculateHash Lib "bncsutil.dll" (ByVal decoder As Long, ByVal ClientToken As Long, ByVal ServerToken As Long) As Long
Public Declare Function nls_init Lib "bncsutil.dll" (ByVal Username As String, ByVal Password As String) As Long
Public Declare Function nls_check_signature Lib "bncsutil.dll" (ByVal Address As Long, ByVal Signature As String) As Long
Public Declare Function nls_account_create Lib "bncsutil.dll" (ByVal NLS As Long, ByVal Buffer As String, ByVal buflen As Long) As Long
Public Declare Function nls_check_M2 Lib "bncsutil.dll" (ByVal NLS As Long, ByVal M2 As String, ByVal B As String, ByVal Salt As String) As Long
Public Declare Function nls_account_change_proof Lib "bncsutil.dll" (ByVal NLS As Long, ByVal Buffer As String, ByVal NewPassword As String, ByVal B As String, ByVal Salt As String) As Long
Public Function bncsutil_getVersion() As String
Dim s As String * 12
Dim Length As Long
    Length = bncsutil_getVersionString(s)
    bncsutil_getVersion = Left$(s, Length)
End Function
Public Function bncsutil_doubleHashPassword(Password As String, ByVal ClientToken As Long, ByVal ServerToken As Long) As String
Dim Hash As String * 20
    On Error GoTo Erred
    doubleHashPassword Password, ClientToken, ServerToken, Hash
    bncsutil_doubleHashPassword = Hash
Exit Function
Erred:
    ErrorHandler "BNCSutil", "DoubleHashPassword"
    Resume Next
End Function
Public Function bncsutil_hashPassword(Password As String) As String
Dim Hash As String * 20
    On Error GoTo Erred
    hashPassword Password, Hash
    bncsutil_hashPassword = Hash
Exit Function
Erred:
    ErrorHandler "BNCSutil", "HashPassword"
    Resume Next
End Function
Public Function nls_check_wsBNet_signature(ByVal wsBnetHandle As Long, ServerSignature As String) As Boolean
Dim addr    As sockaddr_in
Dim addrlen As Long
    On Error GoTo Erred
    addrlen = 16
    If (getpeername(wsBnetHandle, addr, addrlen) = -1) Then
        nls_check_wsBNet_signature = False
    Else
        nls_check_wsBNet_signature = (nls_check_signature(addr.sin_addr, ServerSignature))
    End If
    Exit Function
Erred:
    ErrorHandler "BNCSutil", "nlsCheckwsBNetSignature"
    Resume Next
End Function
