Attribute VB_Name = "modFunctions"
Option Explicit
Private hConnection                  As Long
Private hOpen                        As Long
Private Const MAXPNAMELEN            As Integer = 32
Private Const MM_ANISOTROPIC         As Integer = 8
Private Const EM_GETLINECOUNT        As Long = &HBA
Private Const EM_SETSEL              As Long = &HB1
Private Const EM_REPLACESEL          As Long = &HC2
Private Const EM_LINEINDEX           As Long = &HBB
Private Type LARGE_INTEGER
    lowpart                          As Long
    highpart                         As Long
End Type
Private Type MEMORYSTATUS
    dwLength                         As Long
    dwMemoryLoad                     As Long
    dwTotalPhys                      As Long
    dwAvailPhys                      As Long
    dwTotalPageFile                  As Long
    dwAvailPageFile                  As Long
    dwTotalVirtual                   As Long
    dwAvailVirtual                   As Long
End Type
Private Type OSVERSIONINFO
    dwOSVersionInfoSize              As Long
    dwMajorVersion                   As Long
    dwMinorVersion                   As Long
    dwBuildNumber                    As Long
    dwPlatformID                     As Long
    szCSDVersion                     As String * 128
End Type
Private Type OSVERSIONINFOEX
    dwOSVersionInfoSize              As Long
    dwMajorVersion                   As Long
    dwMinorVersion                   As Long
    dwBuildNumber                    As Long
    dwPlatformID                     As Long
    szCSDVersion                     As String * 128
    dwServicePackMajor               As Integer
    dwServicePackMinor               As Integer
    wSuiteMask                       As Integer
    wProductType                     As Byte
    wReserved                        As Byte
End Type
Private Type BITMAP
    bmType                           As Long
    bmWidth                          As Long
    bmHeight                         As Long
    bmWidthBytes                     As Long
    bmPlanes                         As Integer
    bmBitsPixel                      As Integer
    bmBits                           As Long
End Type
Private Type WAVEOUTCAPS
    wMid                             As Integer
    wPid                             As Integer
    vDriverVersion                   As Long
    szPname                          As String * MAXPNAMELEN
    dwFormats                        As Long
    wChannels                        As Integer
    dwSupport                        As Long
End Type
Private Type Size
    cx                               As Long
    cy                               As Long
End Type
Private Type VS_FIXEDFILEINFO
   dwSignature                       As Long
   dwStrucVersionl                   As Integer
   dwStrucVersionh                   As Integer
   dwFileVersionMSl                  As Integer
   dwFileVersionMSh                  As Integer
   dwFileVersionLSl                  As Integer
   dwFileVersionLSh                  As Integer
   dwProductVersionMSl               As Integer
   dwProductVersionMSh               As Integer
   dwProductVersionLSl               As Integer
   dwProductVersionLSh               As Integer
End Type
Private Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYSTATUS)
Private Declare Sub GetLocalTime Lib "kernel32" (lpSystemTime As SYSTEMTIME)
Private Declare Sub GetSystemTime Lib "kernel32" (lpSystemTime As SYSTEMTIME)
Private Declare Function GetFileVersionInfoA Lib "Version.dll" (ByVal lptstrFilename As String, ByVal dwhandle As Long, ByVal dwlen As Long, lpData As Any) As Long
Private Declare Function GetFileVersionInfoSizeA Lib "Version.dll" (ByVal lptstrFilename As String, lpdwHandle As Long) As Long
Private Declare Function VerQueryValueA Lib "Version.dll" (pBlock As Any, ByVal lpSubBlock As String, lplpBuffer As Any, puLen As Long) As Long
Private Declare Function waveOutGetNumDevs Lib "winmm.dll" () As Long
Private Declare Function waveOutGetDevCapsA Lib "winmm.dll" (ByVal uDeviceID As Long, lpCaps As WAVEOUTCAPS, ByVal uSize As Long) As Long
Private Declare Function GetObjectA Lib "gdi32" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function GetDiskFreeSpaceExA Lib "kernel32" (ByVal lpRootPathName As String, lpFreeBytesAvailableToCaller As LARGE_INTEGER, lpTotalNumberOfBytes As LARGE_INTEGER, lpTotalNumberOfFreeBytes As LARGE_INTEGER) As Long
Private Declare Function GetVersionExA Lib "kernel32" (lpVersionInformation As OSVERSIONINFOEX) As Long
Private Declare Function GetPrivateProfileStringA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileStringA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Function ShellExecuteA Lib "shell32.dll" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Function GetWindowTextA Lib "user32" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetLocaleInfoA Lib "kernel32" (ByVal locale As Long, ByVal LCType As Long, ByVal lpLCData As String, ByVal cchData As Long) As Long
Private Declare Function GetComputerNameA Lib "kernel32" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function GetUserNameA Lib "advapi32.dll" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function PathCompactPathA Lib "shlwapi" (ByVal hDC As Long, ByVal lpszPath As String, ByVal dx As Long) As Long
Private Declare Function GetMenu Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetMenuItemID Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Private Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Private Declare Function SetMenuItemBitmaps Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal hBitmapUnchecked As Long, ByVal hBitmapChecked As Long) As Long
Private Declare Function CreateMetaFileA Lib "gdi32" (ByVal lpString As String) As Long
Private Declare Function CloseMetaFile Lib "gdi32" (ByVal hDCMF As Long) As Long
Private Declare Function DeleteMetaFile Lib "gdi32" (ByVal hMF As Long) As Long
Private Declare Function SetMapMode Lib "gdi32" (ByVal hDC As Long, ByVal nMapMode As Long) As Long
Private Declare Function SetWindowExtEx Lib "gdi32" (ByVal hDC As Long, ByVal nX As Long, ByVal nY As Long, lpSize As Size) As Long
Private Declare Function SetWindowOrgEx Lib "gdi32" (ByVal hDC As Long, ByVal nX As Long, ByVal nY As Long, lpPoint As POINTAPI) As Long
Private Declare Function SaveDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function RestoreDC Lib "gdi32" (ByVal hDC As Long, ByVal nSavedDC As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Private Declare Function GetDriveTypeA Lib "kernel32" (ByVal nDrive As String) As Long
Private Declare Function GetVolumeInformationA Lib "kernel32.dll" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Integer, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long
Private Declare Function GetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Private Declare Function SetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Private Declare Function GetActiveWindow Lib "user32" () As Long
Private Declare Function GetSystemDirectoryA Lib "kernel32" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function LoadCursorA Lib "user32" (ByVal hInstance As Long, ByVal lpCursorName As Long) As Long
Private Declare Function SetCursor Lib "user32" (ByVal hCursor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SystemTimeToFileTime Lib "kernel32" (lpSystemTime As SYSTEMTIME, lpFileTime As FILETIME) As Long
Private Declare Function GetTimeZoneInformation Lib "kernel32" (tzs As TIME_ZONE_INFORMATION) As Long
Private Declare Function GetWindowLongA Lib "user32" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLongA Lib "user32" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Sub RtlMoveMemory Lib "kernel32" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Declare Function CreateFileA Lib "kernel32" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal NoSecurity As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Public Declare Function GetTickCount Lib "kernel32" () As Long
Public Declare Function FindWindowExA Lib "user32" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Public Declare Function PostMessageA Lib "user32" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SendMessageA Lib "user32" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function FindWindowA Lib "user32" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function FlashWindow Lib "user32" (ByVal hwnd As Long, ByVal bInvert As Long) As Long
Public Declare Function GetTempPathA Lib "kernel32" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Public Function BigMod(ByVal dblNumber As Double, ByVal Modulator As Double) As Double
    On Error GoTo Erred
    If InStr(1, dblNumber / Modulator, ".") > 0 Then
        BigMod = dblNumber - (Left(dblNumber / Modulator, InStr(1, dblNumber / Modulator, ".") - 1) * Modulator)
    Else
        BigMod = dblNumber - ((dblNumber / Modulator) * Modulator)
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "BigMod"
    Resume Next
End Function
Public Function ByteSize(ByVal InBytes As Variant) As String
    On Error GoTo Erred
    If InBytes > 1024 Then
        If InBytes / 1024 > 1024 Then
            If InBytes / 1024 / 1024 > 1024 Then
                If InBytes / 1024 / 1024 / 1024 > 1024 Then
                    ByteSize = Format$((InBytes) / 1024 / 1024 / 1024 / 1024, "0.0#") & " TB"
                Else
                    ByteSize = Format$((InBytes) / 1024 / 1024 / 1024, "0.0#") & " GB"
                End If
            Else
                ByteSize = Format$((InBytes) / 1024 / 1024, "0.0#") & " MB"
            End If
        Else
            ByteSize = Format$((InBytes) / 1024, "0.0#") & " KB"
        End If
    Else
        ByteSize = (InBytes) & " B"
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "ByteSize"
    Resume Next
End Function
Public Sub Canadize(ByRef strMessage As String)
    If Right$(strMessage, 1) = "." Or Right$(strMessage, 1) = "?" Or Right$(strMessage, 1) = "!" Then strMessage = Left$(strMessage, Len(strMessage) - 1)
    strMessage = strMessage & ", eh?"
    strMessage = Replace$(strMessage, "house", "igloo", , , vbTextCompare)
    strMessage = Replace$(strMessage, "ou", "oo", , , vbTextCompare)
End Sub
Public Sub Fudd(ByRef strMessage As String)
    strMessage = Replace$(strMessage, "er", "aw", , , vbTextCompare)
    strMessage = Replace$(strMessage, "r", "w", , , vbTextCompare)
    strMessage = Replace$(strMessage, "l", "w", , , vbTextCompare)
End Sub
Public Function CDLegal(ByVal CDKey As String) As String
Dim Key       As String
Dim I         As Integer
    Key = Trim$(UCase$(CDKey))
    For I = 1 To 255
        If I >= vbKey0 And I <= vbKey9 Then
            
        ElseIf I >= vbKeyA And I <= vbKeyZ Then
            
        Else
            Key = Replace$(Key, Chr$(I), "")
        End If
    Next I
    CDLegal = Key
End Function
Public Function CDKeys(ByVal Client As GameType, Optional ByVal CDKey As String) As String
Dim DialogBox As New frmCDKeys
Dim Key       As String
    On Error GoTo Erred
    If LenB(CDKey) > 0 Then Key = CDLegal(CDKey)
    If Client = STAR Then
        DialogBox.pctSTAR.Visible = True
        If LenB(Key) > 0 Then
            DialogBox.Caption = "Edit STAR CD Key"
            DialogBox.lblTitle.Caption = "Edit CDKey for Starcraft:"
            DialogBox.txtSTAR1 = Left$(Key, 4)
            DialogBox.txtSTAR2 = Mid$(Key, 5, 5)
            DialogBox.txtSTAR3 = Right$(Key, 4)
        Else
            DialogBox.Caption = "New STAR CD Key"
            DialogBox.lblTitle.Caption = "Enter new CDKey for Starcraft:"
        End If
    ElseIf Client = SEXP Then
        DialogBox.pctSTAR.Visible = True
        If LenB(Key) > 0 Then
            DialogBox.Caption = "Edit SEXP CD Key"
            DialogBox.lblTitle.Caption = "Edit CDKey for Brood War:"
            DialogBox.txtSTAR1 = Left$(Key, 4)
            DialogBox.txtSTAR2 = Mid$(Key, 5, 5)
            DialogBox.txtSTAR3 = Right$(Key, 4)
        Else
            DialogBox.Caption = "New SEXP CD Key"
            DialogBox.lblTitle.Caption = "Enter new CDKey for Brood War:"
        End If
    ElseIf Client = JSTR Then
        DialogBox.pctSTAR.Visible = True
        If LenB(Key) > 0 Then
            DialogBox.Caption = "Edit JSTR CD Key"
            DialogBox.lblTitle.Caption = "Edit CDKey for Japanese Starcraft:"
            DialogBox.txtSTAR1 = Left$(Key, 4)
            DialogBox.txtSTAR2 = Mid$(Key, 5, 5)
            DialogBox.txtSTAR3 = Right$(Key, 4)
        Else
            DialogBox.Caption = "New JSTR CD Key"
            DialogBox.lblTitle.Caption = "Enter new CDKey for Japanese Starcraft:"
        End If
    ElseIf Client = D2DV Then
        DialogBox.pctD2DV.Visible = True
        If LenB(Key) > 0 Then
            DialogBox.Caption = "Edit D2DV CD Key"
            DialogBox.lblTitle.Caption = "Edit CDKey for Diablo II:"
            DialogBox.txtD2DV1 = Left$(Key, 4)
            DialogBox.txtD2DV2 = Mid$(Key, 5, 4)
            DialogBox.txtD2DV3 = Mid$(Key, 9, 4)
            DialogBox.txtD2DV4 = Right$(Key, 4)
        Else
            DialogBox.Caption = "New D2DV CD Key"
            DialogBox.lblTitle.Caption = "Enter new CDKey for Diablo II:"
        End If
    ElseIf Client = D2XP Then
        DialogBox.pctD2DV.Visible = True
        If LenB(Key) > 0 Then
            DialogBox.Caption = "Edit D2XP EXP Key"
            DialogBox.lblTitle.Caption = "Edit EXPKey for Diablo II:"
            DialogBox.txtD2DV1 = Left$(Key, 4)
            DialogBox.txtD2DV2 = Mid$(Key, 5, 4)
            DialogBox.txtD2DV3 = Mid$(Key, 9, 4)
            DialogBox.txtD2DV4 = Right$(Key, 4)
        Else
            DialogBox.Caption = "New D2XP EXP Key"
            DialogBox.lblTitle.Caption = "Enter new EXPKey for Diablo II:"
        End If
    ElseIf Client = W2BN Then
        DialogBox.Caption = "New W2BN CD Key"
        DialogBox.lblTitle.Caption = "Enter new CDKey for Warcraft II:"
        DialogBox.pctW2BN.Visible = True
        If LenB(Key) > 0 Then
            DialogBox.txtW2BN1 = Left$(Key, 4)
            DialogBox.txtW2BN2 = Mid$(Key, 5, 4)
            DialogBox.txtW2BN3 = Mid$(Key, 9, 4)
            DialogBox.txtW2BN4 = Right$(Key, 4)
        End If
    ElseIf Client = WAR3 Then
        DialogBox.pctWAR3.Visible = True
        If LenB(Key) > 0 Then
            DialogBox.Caption = "Edit WAR3 CD Key"
            DialogBox.lblTitle.Caption = "Edit CDKey for Warcraft III:"
            DialogBox.txtWAR31 = Left$(Key, 6)
            DialogBox.txtWAR32 = Mid$(Key, 7, 4)
            DialogBox.txtWAR33 = Mid$(Key, 11, 6)
            DialogBox.txtWAR34 = Mid$(Key, 17, 4)
            DialogBox.txtWAR35 = Right$(Key, 6)
        Else
            DialogBox.Caption = "New WAR3 CD Key"
            DialogBox.lblTitle.Caption = "Enter new CDKey for Warcraft III:"
        End If
    ElseIf Client = W3XP Then
        DialogBox.pctWAR3.Visible = True
        If LenB(Key) > 0 Then
            DialogBox.Caption = "Edit W3XP EXP Key"
            DialogBox.lblTitle.Caption = "Edit EXPKey for Warcraft III:"
            DialogBox.txtWAR31 = Left$(Key, 6)
            DialogBox.txtWAR32 = Mid$(Key, 7, 4)
            DialogBox.txtWAR33 = Mid$(Key, 11, 6)
            DialogBox.txtWAR34 = Mid$(Key, 17, 4)
            DialogBox.txtWAR35 = Right$(Key, 6)
        Else
            DialogBox.Caption = "New W3XP EXP Key"
            DialogBox.lblTitle.Caption = "Enter new EXPKey for Warcraft III:"
        End If
    End If
    DialogBox.Show vbModal, frmMain
    Do Until DialogBox.CDKey <> vbNullString
        DoEvents
    Loop
    If DialogBox.CDKey = "Cancel" Then
        CDKeys = vbNullString
    Else
        CDKeys = DialogBox.CDKey
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "MessageBox"
    Resume Next
End Function
Public Sub ChangeOBJColor(ByRef obj As Long, ByVal BGColor As Long, ByVal FGColor As Long)
    On Error GoTo Erred
    SendMessageA obj, &H2000 + 1, 0, ByVal BGColor
    SendMessageA obj, &H400 + 9, 0, ByVal FGColor
Exit Sub
Erred:
    ErrorHandler "Functions", "ChangeOBJColor"
    Resume Next
End Sub
Private Function CLargeInt(ByVal Lo As Long, ByVal Hi As Long) As Double
Dim dblLo As Double
Dim dblHi As Double
    On Error GoTo Erred
    If Lo < 0 Then
        dblLo = 2 ^ 32 + Lo
    Else
        dblLo = Lo
    End If
    If Hi < 0 Then
        dblHi = 2 ^ 32 + Hi
    Else
        dblHi = Hi
    End If
    CLargeInt = dblLo + dblHi * 2 ^ 32
Exit Function
Erred:
    ErrorHandler "Functions", "CLargeInt"
    Resume Next
End Function
Public Function ClanRanking(ByVal Rank As Byte) As String
    Select Case Rank
        Case 0
            ClanRanking = "New Peon"
        Case 1
            ClanRanking = "Peon"
        Case 2
            ClanRanking = "Grunt"
        Case 3
            ClanRanking = "Shaman"
        Case 4
            ClanRanking = "Chieftain"
        Case Else
            ClanRanking = "Unknown [" & Rank & "]"
    End Select
End Function
Public Function strClanTag(ByVal ClanTag As Long) As String
Dim RealTag As String
Dim Result  As Long
Dim P       As New clsPacket
    RealTag = StrReverse(P.CreateDWORD(ClanTag))
    RealTag = Replace$(RealTag, Chr$(0), "")
    strClanTag = RealTag
End Function
Public Function Colorize(ByVal strMessage As String) As String
Dim I        As Integer
Dim TmpU     As String
Dim RndColor As Integer
    Randomize
    For I = 1 To Len(strMessage)
        RndColor = Int(Rnd * 13)
        Select Case RndColor
            Case 0
                TmpU = TmpU & "c/"
            Case 1
                TmpU = TmpU & "c1"
            Case 2
                TmpU = TmpU & "c2"
            Case 3
                TmpU = TmpU & "c3"
            Case 4
                TmpU = TmpU & "c4"
            Case 5
                TmpU = TmpU & "c5"
            Case 6
                TmpU = TmpU & "c8"
            Case 7
                TmpU = TmpU & "c9"
            Case 8
                TmpU = TmpU & "c*"
            Case 9
                TmpU = TmpU & "c("
            Case 10
                TmpU = TmpU & "c)"
            Case 11
                TmpU = TmpU & "c+"
            Case 12
                TmpU = TmpU & "c:"
            Case 13
                TmpU = TmpU & "c;"
        End Select
        TmpU = TmpU & Mid$(strMessage, I, 1)
    Next I
    Colorize = TmpU
End Function
Public Function ConvertPort(ByVal Port As String) As String
    On Error GoTo Erred
    ConvertPort = (Asc(Mid$(Port, 1, 1)) * (2 ^ 8)) + Asc(Mid$(Port, 2, 1))
Exit Function
Erred:
    ErrorHandler "Functions", "ConvertPort"
    Resume Next
End Function
Public Function ConvertTime(ByVal lngMS As Double, Optional ByVal Abbreviated As Boolean = False) As String
Dim lngSeconds As Long
Dim lngDays    As Long
Dim lngHours   As Long
Dim lngMins    As Long
Dim strSeconds As String
Dim strDays    As String
Dim strHours   As String
Dim strMins    As String
    On Error GoTo Erred
    lngSeconds = lngMS / 1000
    lngDays = Int(lngSeconds / 86400)
    lngSeconds = lngSeconds Mod 86400
    lngHours = Int(lngSeconds / 3600)
    lngSeconds = lngSeconds Mod 3600
    lngMins = Int(lngSeconds / 60)
    lngSeconds = lngSeconds Mod 60
    If lngSeconds <> 1 Then strSeconds = "s"
    If lngDays <> 1 Then strDays = "s"
    If lngHours <> 1 Then strHours = "s"
    If lngMins <> 1 Then strMins = "s"
    If Abbreviated Then
        If lngDays > 0 Then
            ConvertTime = lngDays & " day" & strDays & ", " & lngHours & " hr" & strHours & ", " & lngMins & " min" & strMins & ", and " & lngSeconds & " sec" & strSeconds
        ElseIf lngHours > 0 Then
            ConvertTime = lngHours & " hr" & strHours & ", " & lngMins & " min" & strMins & ", and " & lngSeconds & " sec" & strSeconds
        ElseIf lngMins > 0 Then
            ConvertTime = lngMins & " min" & strMins & " and " & lngSeconds & " sec" & strSeconds
        Else
            ConvertTime = lngSeconds & " sec" & strSeconds
        End If
    Else
        If lngDays > 0 Then
            ConvertTime = lngDays & " day" & strDays & ", " & lngHours & " hour" & strHours & ", " & lngMins & " minute" & strMins & ", and " & lngSeconds & " second" & strSeconds
        ElseIf lngHours > 0 Then
            ConvertTime = lngHours & " hour" & strHours & ", " & lngMins & " minute" & strMins & ", and " & lngSeconds & " second" & strSeconds
        ElseIf lngMins > 0 Then
            ConvertTime = lngMins & " minute" & strMins & " and " & lngSeconds & " second" & strSeconds
        Else
            ConvertTime = lngSeconds & " second" & strSeconds
        End If
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "Time Converter"
    Resume Next
End Function
Public Sub CreateServerList()
Dim nFile As Integer
    nFile = FreeFile
    Open App.Path & "/servers.ini" For Output As nFile
    Print #nFile, ";You may add or edit any of these connections."
    Print #nFile, ";The connection name is listed in brackets,"
    Print #nFile, ";and all data below is used as the connection IP."
    Print #nFile, "[US West]"
    Print #nFile, "63.241.83.9"
    Print #nFile, "63.241.83.12"
    Print #nFile, "63.241.83.13"
    Print #nFile, "63.241.83.107"
    Print #nFile, "63.241.83.108"
    Print #nFile, "63.241.83.109"
    Print #nFile, "63.241.83.110"
    Print #nFile, "63.241.83.111"
    Print #nFile, "63.241.83.112"
    Print #nFile, ""
    Print #nFile, "[US East]"
    Print #nFile, "63.240.202.120"
    Print #nFile, "63.240.202.121"
    Print #nFile, "63.240.202.122"
    Print #nFile, "63.240.202.126"
    Print #nFile, "63.240.202.127"
    Print #nFile, "63.240.202.128"
    Print #nFile, "63.240.202.129"
    Print #nFile, "63.240.202.130"
    Print #nFile, "63.240.202.131"
    Print #nFile, "63.240.202.134"
    Print #nFile, "63.240.202.138"
    Print #nFile, "63.240.202.139"
    Print #nFile, ""
    Print #nFile, "[Europe]"
    Print #nFile, "213.248.106.200"
    Print #nFile, "213.248.106.201"
    Print #nFile, "213.248.106.202"
    Print #nFile, "213.248.106.204"
    Print #nFile, ""
    Print #nFile, "[Asia]"
    Print #nFile, "211.233.0.49"
    Print #nFile, "211.233.0.50"
    Print #nFile, "211.233.0.51"
    Print #nFile, "211.233.0.52"
    Print #nFile, "211.233.0.53"
    Print #nFile, "211.233.0.72"
    Print #nFile, "211.233.0.73"
    Print #nFile, "211.233.0.74"
    Print #nFile, "211.233.0.75"
    Print #nFile, "211.233.0.76"
    Print #nFile, "211.233.0.78"
    Print #nFile, "211.233.0.79"
    Print #nFile, "211.233.0.80"
    Close #nFile
End Sub
Public Function DeCensor(ByVal strMessage As String) As String
Dim Caps As Boolean
    On Error GoTo Erred
    If strMessage = UCase$(strMessage) Then Caps = True
    If strMessage = LCase$(strMessage) Then Caps = False
    strMessage = Replace$(strMessage, "!&$%@", "pussy")
    strMessage = Replace$(strMessage, "!&$%", "fuck")
    strMessage = Replace$(strMessage, "$!@%", "shit")
    strMessage = Replace$(strMessage, "@$%!@%&", "asshole")
    strMessage = Replace$(strMessage, "$%$", "kkk")
    strMessage = Replace$(strMessage, "#@%$!", "bitch")
    strMessage = Replace$(strMessage, "!@!#&", "whore")
    strMessage = Replace$(strMessage, "!@!@%&", "nipple")
    strMessage = Replace$(strMessage, "!&!@$", "penis")
    strMessage = Replace$(strMessage, "$!$%", "cock")
    strMessage = Replace$(strMessage, "!@!@&#", "nigger")
    strMessage = Replace$(strMessage, "!@!@#", "nigga")
    strMessage = Replace$(strMessage, "$%&%", "slut")
    strMessage = Replace$(strMessage, "!@!@!@", "vagina")
    strMessage = Replace$(strMessage, "$&!%", "cunt")
    strMessage = Replace$(strMessage, "$%@%", "clit")
    strMessage = Replace$(strMessage, "&#&$%", "erect")
    strMessage = Replace$(strMessage, "%@$%", "dick")
    strMessage = Replace$(strMessage, "!#!@$&", "orgasm")
    strMessage = Replace$(strMessage, "$!@!$", "chink")
    strMessage = Replace$(strMessage, "!@!$", "gook")
    strMessage = Replace$(strMessage, "&@$%&#$@%", "masturbat")
    strMessage = Replace$(strMessage, "!@!@!%", "faggot")
    strMessage = Replace$(strMessage, "$%&!", "klux")
    strMessage = Replace$(strMessage, "$@$&", "kyke")
    strMessage = Replace$(strMessage, "%&$#@#!", "lesbian")
    strMessage = Replace$(strMessage, "%@%&!", "dildo")
    If Caps Then
        DeCensor = UCase$(strMessage)
    Else
        DeCensor = strMessage
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "Decensor"
    Resume Next
End Function
Public Sub DeleteFolder(sPath As String)
Dim sFile As String
Dim sDir  As String
    sFile = Dir$(sPath & "*.*", vbHidden Or vbReadOnly Or vbSystem)
    Do While Len(sFile)
        SetAttr sPath & sFile, vbArchive
        sFile = Dir$
    Loop
    If Len(Dir$(sPath & "*.*")) > 0 Then
        Kill sPath & "*.*"
    End If
    sDir = Dir$(sPath, vbDirectory)
    Do While Len(sDir)
        If (GetAttr(sPath & sDir) And vbDirectory) = vbDirectory Then
            If Left$(sDir, 1) <> "." Then
                DeleteFolder sPath & sDir & "\"
                sDir = Dir$(sPath, vbDirectory)
            End If
            sDir = Dir$
        End If
    Loop
    RmDir sPath
    sPath = sPath & ".."
End Sub
Public Function DisplayFileVerInfo(ByVal Filename As String) As String
Dim sBuffer() As Byte
Dim lBufferLen As Long
Dim lVerPointer As Long
Dim udtVerBuffer As VS_FIXEDFILEINFO
    On Error GoTo Erred
    lBufferLen = GetFileVersionInfoSizeA(Filename, 0&)
    If lBufferLen < 1 Then
        DisplayFileVerInfo = "0"
        Exit Function
    End If
    ReDim sBuffer(lBufferLen)
    GetFileVersionInfoA Filename, 0&, lBufferLen, sBuffer(0)
    VerQueryValueA sBuffer(0), "\", lVerPointer, 0&
    RtlMoveMemory udtVerBuffer, ByVal lVerPointer, Len(udtVerBuffer)
    DisplayFileVerInfo = Format$(udtVerBuffer.dwFileVersionMSh) & "." & Format$(udtVerBuffer.dwFileVersionMSl) & "." & Format$(udtVerBuffer.dwFileVersionLSl)
Exit Function
Erred:
    ErrorHandler "Functions", "DisplayFileVerInfo"
    Resume Next
End Function
Public Function DisplayProdVerInfo(ByVal Filename As String) As String
Dim sBuffer() As Byte
Dim lBufferLen As Long
Dim lVerPointer As Long
Dim udtVerBuffer As VS_FIXEDFILEINFO
    On Error GoTo Erred
    lBufferLen = GetFileVersionInfoSizeA(Filename, 0&)
    If lBufferLen < 1 Then
        DisplayProdVerInfo = 0
        Exit Function
    End If
    ReDim sBuffer(lBufferLen)
    GetFileVersionInfoA Filename, 0&, lBufferLen, sBuffer(0)
    VerQueryValueA sBuffer(0), "\", lVerPointer, 0&
    RtlMoveMemory udtVerBuffer, ByVal lVerPointer, Len(udtVerBuffer)
    DisplayProdVerInfo = Format$(udtVerBuffer.dwProductVersionMSh) & "." & Format$(udtVerBuffer.dwProductVersionMSl) & "." & Format$(udtVerBuffer.dwProductVersionLSh) & "." & Format$(udtVerBuffer.dwProductVersionLSl)
Exit Function
Erred:
    ErrorHandler "Functions", "DisplayProdVerInfo"
    Resume Next
End Function
Public Sub ErrorHandler(ByVal Window As String, ByVal Subroutine As String)
Dim ErrorBox As New frmError
    frmMain.Progress 0, 1
    Reset
    If LenB(Err.Description) = 0 Or Err.Description = "Out of memory" Then Exit Sub
    If Err.Description = "File not found: bncsutil.dll" Then
        frmMain.ChatAdd Chr$(8) & "eYou are missing BNCSutil.dll."
        Exit Sub
    End If
    ErrorBox.GetError Err.Number, Err.Description, Err.Source, Subroutine, Window
    If Not frmMain.Visible Then
        Screen.MousePointer = 13
        App.TaskVisible = True
        If frmMain.Maxed Then
            frmMain.WindowState = 2
        Else
            frmMain.WindowState = 0
        End If
        frmMain.Show
        frmMain.TrayIcon.HideIcon
        Screen.MousePointer = 0
    End If
    ErrorBox.Show vbModal, frmMain
End Sub
Private Function FindIllegal(ByVal From As String) As String
Dim I      As Integer
Dim strTmp As String
    On Error GoTo Erred
    For I = 1 To Len(From)
        If (Asc(UCase$(Mid$(From, I, 1))) >= vbKeyA And Asc(UCase$(Mid$(From, I, 1))) <= vbKeyZ) Or (Asc(Mid$(From, I, 1)) >= vbKey0 And Asc(Mid$(From, I, 1)) <= vbKey9) Or Asc(Mid$(From, I, 1)) = vbKeySpace Then
            strTmp = strTmp & Mid$(From, I, 1)
        Else
            Exit For
        End If
    Next I
    FindIllegal = Trim$(strTmp)
Exit Function
Erred:
    ErrorHandler "Functions", "FindIllegal"
    Resume Next
End Function
Public Function FormatTime(ByVal tTime As Date, ByVal tFormat As String) As String
Dim TimeStr As String
    TimeStr = tFormat
    TimeStr = Replace$(TimeStr, "HH", Format$(Hour(tTime), "00"))
    TimeStr = Replace$(TimeStr, "H", Hour(tTime))
    TimeStr = Replace$(TimeStr, "MM", Format$(Minute(tTime), "00"))
    TimeStr = Replace$(TimeStr, "M", Minute(tTime))
    TimeStr = Replace$(TimeStr, "SS", Format$(Second(tTime), "00"))
    TimeStr = Replace$(TimeStr, "S", Second(tTime))
    If Hour(tTime) > 12 Then
        TimeStr = Replace$(TimeStr, "hh", Format$(Hour(tTime) - 12, "00"))
        TimeStr = Replace$(TimeStr, "h", Hour(tTime) - 12)
        TimeStr = Replace$(TimeStr, "tt", "pm")
        TimeStr = Replace$(TimeStr, "TT", "PM")
    ElseIf Hour(tTime) = 0 Then
        TimeStr = Replace$(TimeStr, "hh", "12")
        TimeStr = Replace$(TimeStr, "h", "12")
        TimeStr = Replace$(TimeStr, "tt", "am")
        TimeStr = Replace$(TimeStr, "TT", "AM")
    Else
        TimeStr = Replace$(TimeStr, "hh", Format$(Hour(tTime), "00"))
        TimeStr = Replace$(TimeStr, "h", Hour(tTime))
        TimeStr = Replace$(TimeStr, "tt", "am")
        TimeStr = Replace$(TimeStr, "TT", "AM")
    End If
    FormatTime = TimeStr
End Function
Public Function GameToDWORD(ByVal fromGame As GameType) As Long
    On Error GoTo Erred
    If fromGame = DRTL Then
        GameToDWORD = CLIENT_DRTL
    ElseIf fromGame = DSHR Then
        GameToDWORD = CLIENT_DSHR
    ElseIf fromGame = D2DV Then
        GameToDWORD = CLIENT_D2DV
    ElseIf fromGame = D2XP Then
        GameToDWORD = CLIENT_D2XP
    ElseIf fromGame = STAR Then
        GameToDWORD = CLIENT_STAR
    ElseIf fromGame = SSHR Then
        GameToDWORD = CLIENT_SSHR
    ElseIf fromGame = JSTR Then
        GameToDWORD = CLIENT_JSTR
    ElseIf fromGame = SEXP Then
        GameToDWORD = CLIENT_SEXP
    ElseIf fromGame = W2BN Then
        GameToDWORD = CLIENT_W2BN
    ElseIf fromGame = WAR3 Then
        GameToDWORD = CLIENT_WAR3
    ElseIf fromGame = W3XP Then
        GameToDWORD = CLIENT_W3XP
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "GameToDWord"
    Resume Next
End Function
Public Function GameToString(ByVal fromGame As GameType) As String
    On Error GoTo Erred
    If fromGame = DRTL Then
        GameToString = "DRTL"
    ElseIf fromGame = DSHR Then
        GameToString = "DSHR"
    ElseIf fromGame = D2DV Then
        GameToString = "D2DV"
    ElseIf fromGame = D2XP Then
        GameToString = "D2XP"
    ElseIf fromGame = STAR Then
        GameToString = "STAR"
    ElseIf fromGame = SSHR Then
        GameToString = "SSHR"
    ElseIf fromGame = JSTR Then
        GameToString = "JSTR"
    ElseIf fromGame = SEXP Then
        GameToString = "SEXP"
    ElseIf fromGame = W2BN Then
        GameToString = "W2BN"
    ElseIf fromGame = WAR3 Then
        GameToString = "WAR3"
    ElseIf fromGame = W3XP Then
        GameToString = "W3XP"
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "GameToString"
    Resume Next
End Function
Public Function GameStringToName(ByVal fromGame As String) As String
    On Error GoTo Erred
    If fromGame = "LTRD" Then
        GameStringToName = "Diablo"
    ElseIf fromGame = "RHSD" Then
        GameStringToName = "Diablo Shareware"
    ElseIf fromGame = "VD2D" Then
        GameStringToName = "Diablo II"
    ElseIf fromGame = "PX2D" Then
        GameStringToName = "Diablo II: Lord of Destruction"
    ElseIf fromGame = "RATS" Then
        GameStringToName = "Starcraft"
    ElseIf fromGame = "RHSS" Then
        GameStringToName = "Starcraft Shareware"
    ElseIf fromGame = "RTSJ" Then
        GameStringToName = "Japanese Starcraft"
    ElseIf fromGame = "PXES" Then
        GameStringToName = "Brood War"
    ElseIf fromGame = "NB2W" Then
        GameStringToName = "Warcraft II"
    ElseIf fromGame = "3RAW" Then
        GameStringToName = "Warcraft III"
    ElseIf fromGame = "PX3W" Then
        GameStringToName = "Warcraft III: The Frozen Throne"
    ElseIf fromGame = "TAHC" Then
        GameStringToName = "Chat"
    Else
        GameStringToName = StrReverse(fromGame)
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "GameStringToName"
    Resume Next
End Function
Public Function GetCompUserName(Optional ByVal User As Boolean = False) As String
Dim strBuff As String
Dim Rut     As Long
    On Error GoTo Erred
    strBuff = String$(255, Chr$(&H0))
    If User Then
        Rut = GetUserNameA(strBuff, Len(strBuff))
    Else
        Rut = GetComputerNameA(strBuff, Len(strBuff))
    End If
    If Rut = 0 Then
        strBuff = vbNullString
    Else
        strBuff = KillNull(strBuff)
    End If
    GetCompUserName = strBuff
Exit Function
Erred:
    ErrorHandler "Functions", "GetCompUserName"
    Resume Next
End Function
Public Function GetFileTimeInfo(Filename As String) As FILETIME
Dim file_handle As Long
Dim create_time As FILETIME
Dim access_time As FILETIME
Dim write_time  As FILETIME
    On Error GoTo Erred
    If LenB(Dir$(Filename)) > 0 Then
        file_handle = CreateFileA(Filename, &H80000000, &H1 Or &H2, 0&, &H3, 0&, 0&)
        GetFileTime file_handle, create_time, access_time, write_time
        GetFileTimeInfo = write_time
        CloseHandle (file_handle)
    Else
        GetFileTimeInfo.dwHighDateTime = 0
        GetFileTimeInfo.dwLowDateTime = 0
    End If
    Exit Function
Erred:
    ErrorHandler "Functions", "GetFileTimeInfo"
    Resume Next
End Function
Public Sub SetFileTimeInfo(Filename As String, Created As FILETIME, Accessed As FILETIME, Written As FILETIME)
Dim file_handle As Long
    On Error GoTo Erred
    If LenB(Dir$(Filename)) > 0 Then
        file_handle = CreateFileA(Filename, &H40000000, &H1 Or &H2, 0&, &H3, 0&, 0&)
        SetFileTime file_handle, Created, Accessed, Written
        CloseHandle (file_handle)
    End If
Exit Sub
Erred:
    ErrorHandler "Functions", "SetFileTimeInfo"
    Resume Next
End Sub
Public Function GetFTString(Optional ByVal LocalTime As Boolean = False) As String
Dim SyT As SYSTEMTIME
Dim ft  As FILETIME
Dim P   As New clsPacket
    On Error GoTo Erred
    If LocalTime Then
        GetLocalTime SyT
    Else
        GetSystemTime SyT
    End If
    SystemTimeToFileTime SyT, ft
    GetFTString = P.CreateDWORD(ft.dwLowDateTime) & P.CreateDWORD(ft.dwHighDateTime)
Exit Function
Erred:
    ErrorHandler "Functions", "GetFTString"
    Resume Next
End Function
Public Function GetFTTime(ft As FILETIME) As String
Dim SysTime As SYSTEMTIME
    FileTimeToSystemTime ft, SysTime
    SysTime.wDayOfWeek = SysTime.wDayOfWeek + 1
    If SysTime.wHour > 12 Then
        GetFTTime = WeekdayName(SysTime.wDayOfWeek, True) & ", " & MonthName(SysTime.wMonth, True) & " " & SysTime.wDay & ", " & SysTime.wYear & " at " & SysTime.wHour - 12 & ":" & Format$(SysTime.wMinute, "00") & ":" & Format$(SysTime.wSecond, "00") & " PM"
    Else
        GetFTTime = WeekdayName(SysTime.wDayOfWeek, True) & ", " & MonthName(SysTime.wMonth, True) & " " & SysTime.wDay & ", " & SysTime.wYear & " at " & SysTime.wHour & ":" & Format$(SysTime.wMinute, "00") & ":" & Format$(SysTime.wSecond, "00") & " AM"
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "GetFTTime"
    Resume Next
End Function
Public Function GetInfo(ByVal lInfo As Long) As String
Dim Buffer As String
Dim ret    As String
    On Error GoTo Erred
    Buffer = String$(256, 0)
    ret = GetLocaleInfoA(LOCALE_USER_DEFAULT, lInfo, Buffer, Len(Buffer))
    If ret > 0 Then
        GetInfo = Left$(Buffer, ret - 1)
    Else
        GetInfo = vbNullString
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "GetInfo"
    Resume Next
End Function
Public Function GetQuote(ByVal Query As String) As String
Dim nFile    As Integer
Dim QuoteTmp As String
Dim FoundQ   As Boolean
    If LenB(Dir$(App.Path & "/Profiles/" & Profile & "/quotes.rcb")) > 0 Then
        nFile = FreeFile
        Open App.Path & "/Profiles/" & Profile & "/quotes.rcb" For Input As #nFile
        Do Until EOF(nFile)
            Line Input #nFile, QuoteTmp
            If InStr(1, QuoteTmp, Query) > 0 Then
                GetQuote = QuoteTmp
                FoundQ = True
                Exit Do
            End If
        Loop
        Close #nFile
        If Not FoundQ Then
            nFile = FreeFile
            Open App.Path & "/Profiles/" & Profile & "/quotes.rcb" For Input As #nFile
            Do Until EOF(nFile)
                Line Input #nFile, QuoteTmp
                If InStr(1, QuoteTmp, Query, vbTextCompare) > 0 Then
                    GetQuote = QuoteTmp
                    FoundQ = True
                    Exit Do
                End If
            Loop
            Close #nFile
            If Not FoundQ Then GetQuote = "Could not find a quote with the term """ & Query & """ in it."
        End If
    Else
        GetQuote = "No quotes exist."
    End If
    Exit Function
Erred:
    GetQuote = "Error in GetQuote: " & Err.Description
End Function
Public Function GetRegionDWord() As Long
Dim Conv As New clsConvert
Dim RegionString As String
    On Error GoTo Erred
    RegionString = GetInfo(LOCALE_SISO639LANGNAME) & GetInfo(LOCALE_SISO3166CTRYNAME)
    GetRegionDWord = CLng("&H" & Conv.ConvertTextToHexadecimal(RegionString))
Exit Function
Erred:
    ErrorHandler "Functions", "GetRegionString"
    Resume Next
End Function
Public Function GetSerialNumber(strDrive As String) As Long
Dim SerialNum As Long
Dim Res       As Long
Dim Temp1     As String
Dim Temp2     As String
    On Error GoTo Erred
    Temp1 = String$(255, Chr$(0))
    Temp2 = String$(255, Chr$(0))
    Res = GetVolumeInformationA(strDrive, Temp1, Len(Temp1), SerialNum, 0, 0, Temp2, Len(Temp2))
    GetSerialNumber = SerialNum
Exit Function
Erred:
    ErrorHandler "Functions", "GetSerialNumber (" & strDrive & ")"
    Resume Next
End Function
Public Function GetSpeed(ByVal CurrentSize As Long, ByVal StartTime As Long) As String
Dim TimeSoFar As Long
    On Error GoTo Erred
    TimeSoFar = (GetTickCount - StartTime) / 1000
    If TimeSoFar < 1 Then TimeSoFar = 1
    GetSpeed = ByteSize(Int(CurrentSize / TimeSoFar)) & "/S"
Exit Function
Erred:
    ErrorHandler "Functions", "GetSpeed"
    Resume Next
End Function
Public Function GetTempDir() As String
Dim nSize As Long
Dim tmp As String
    tmp = Space$(255)
    nSize = Len(tmp)
    GetTempPathA nSize, tmp
    GetTempDir = TrimNull(tmp)
End Function
Private Function getTempName(Optional anExt As String = "tmp") As String
Dim Filename     As String
Dim I            As Long
Const validChars As String = "123567890qwertyuiopasdfghjklzxcvbnm"
    Filename = Space$(12)
    Mid$(Filename, 1, 1) = "T"
    Mid$(Filename, Len(Filename) - Len(anExt), 1) = "."
    Mid$(Filename, Len(Filename) - Len(anExt) + 1, Len(anExt)) = anExt
    Randomize
    For I = 2 To Len(Filename) - 4
        Mid$(Filename, I, 1) = Mid$(validChars, CLng(Rnd() * (Len(validChars)) + 1), 1)
    Next I
    getTempName = GetTempDir & Filename
End Function
Public Function GetTime(ByVal TotalSize As Long, ByVal CurrentSize As Long, ByVal StartTime As Long) As String
Dim TimeSoFar As Long
    On Error GoTo Erred
    TimeSoFar = (GetTickCount - StartTime) / 1000
    If TimeSoFar < 1 Then TimeSoFar = 1
    GetTime = ConvertTime(Int((TotalSize - CurrentSize) / (CurrentSize \ TimeSoFar)) * 1000, True)
Exit Function
Erred:
    ErrorHandler "Functions", "GetTime"
    Resume Next
End Function
Public Function HasFocus(ByRef Frm As Form) As Boolean
    On Error GoTo Erred
    If GetActiveWindow = Frm.hwnd And Frm.Visible = True Then HasFocus = True
Exit Function
Erred:
    ErrorHandler "Functions", "HasFocus"
    Resume Next
End Function
Public Sub IconMenu()
    On Error GoTo Erred
    MenuIcon 0, frmMain.imlMenu.ListImages(4).Picture
    If frmMain.mnuConnect.Caption = "Co&nnect" Then
        MenuIcon 2, frmMain.imlMenu.ListImages(1).Picture
    Else
        MenuIcon 2, frmMain.imlMenu.ListImages(3).Picture
    End If
    MenuIcon 3, frmMain.imlMenu.ListImages(2).Picture
    MenuIcon 5, frmMain.imlMenu.ListImages(5).Picture
Exit Sub
Erred:
    ErrorHandler "Functions", "IconMenu"
    Resume Next
End Sub

Public Function IDMCP(ByVal PacketID As Byte) As String
    Select Case PacketID
        Case &H1
            IDMCP = "MCP_STARTUP"
        Case &H2
            IDMCP = "MCP_CHARCREATE"
        Case &H3
            IDMCP = "MCP_CREATEGAME"
        Case &H4
            IDMCP = "MCP_JOINGAME"
        Case &H5
            IDMCP = "MCP_GAMELIST"
        Case &H6
            IDMCP = "MCP_GAMEINFO"
        Case &H7
            IDMCP = "MCP_CHARLOGON"
        Case &HA
            IDMCP = "MCP_CHARDELETE"
        Case &H11
            IDMCP = "MCP_REQUESTLADDERDATA"
        Case &H12
            IDMCP = "MCP_MOTD"
        Case &H13
            IDMCP = "MCP_CANCELGAMECREATE"
        Case &H14
            IDMCP = "MCP_CREATEQUEUE"
        Case &H17
            IDMCP = "MCP_CHARLIST"
        Case &H18
            IDMCP = "MCP_CHARUPGRADE"
        Case &H19
            IDMCP = "MCP_CHARLIST2"
        Case Else
            IDMCP = "MCP (" & PacketID & ")"
    End Select
End Function
Public Function IDSID(ByVal PacketID As Byte) As String
    Select Case PacketID
        Case &H0
            IDSID = "SID_NULL"
        Case &H2
            IDSID = "SID_STOPADV"
        Case &H4
            IDSID = "SID_SERVERLIST"
        Case &H5
            IDSID = "SID_CLIENTID"
        Case &H6
            IDSID = "SID_STARTVERSIONING"
        Case &H7
            IDSID = "SID_REPORTVERSION"
        Case &H8
            IDSID = "SID_STARTADVEX"
        Case &H9
            IDSID = "SID_GETADVLISTEX"
        Case &HA
            IDSID = "SID_ENTERCHAT"
        Case &HB
            IDSID = "SID_GETCHANNELLIST"
        Case &HC
            IDSID = "SID_Send_SID_JOINCHANNEL"
        Case &HE
            IDSID = "SID_CHATCOMMAND"
        Case &HF
            IDSID = "SID_CHATEVENT"
        Case &H10
            IDSID = "SID_LEAVECHAT"
        Case &H12
            IDSID = "SID_LOCALEINFO"
        Case &H13
            IDSID = "SID_FLOODDETECTED"
        Case &H14
            IDSID = "SID_UDPPINGRESPONSE"
        Case &H15
            IDSID = "SID_CHECKAD"
        Case &H16
            IDSID = "SID_CLICKAD"
        Case &H18
            IDSID = "SID_REGISTRY"
        Case &H19
            IDSID = "SID_MESSAGEBOX"
        Case &H1C
            IDSID = "SID_STARTADVEX3"
        Case &H1D
            IDSID = "SID_LOGONCHALLENGEEX"
        Case &H1E
            IDSID = "SID_CLIENTID2"
        Case &H1F
            IDSID = "SID_LEAVEGAME"
        Case &H21
            IDSID = "SID_DISPLAYAD"
        Case &H22
            IDSID = "SID_NOTIFYJOIN"
        Case &H25
            IDSID = "SID_PING"
        Case &H26
            IDSID = "SID_READUSERDATA"
        Case &H27
            IDSID = "SID_Send_SID_WRITEUSERDATA"
        Case &H28
            IDSID = "SID_LOGONCHALLENGE"
        Case &H29
            IDSID = "SID_LOGONRESPONSE"
        Case &H2A
            IDSID = "SID_CREATEACCOUNT"
        Case &H2C
            IDSID = "SID_GAMERESULT"
        Case &H2D
            IDSID = "SID_GETICONDATA"
        Case &H2E
            IDSID = "SID_GETLADDERDATA"
        Case &H2F
            IDSID = "SID_FINDLADDERUSER"
        Case &H30
            IDSID = "SID_CDKEY"
        Case &H31
            IDSID = "SID_CHANGEPASSWORD"
        Case &H32
            IDSID = "SID_CHECKDATAFILE"
        Case &H33
            IDSID = "SID_GETFILETIME"
        Case &H34
            IDSID = "SID_QUERYREALMS"
        Case &H35
            IDSID = "SID_PROFILE"
        Case &H36
            IDSID = "SID_CDKEY2"
        Case &H3A
            IDSID = "SID_LOGONRESPONSE2"
        Case &H3C
            IDSID = "SID_CHECKDATAFILE2"
        Case &H3D
            IDSID = "SID_CREATEACCOUNT2"
        Case &H3E
            IDSID = "SID_LOGONREALMEX"
        Case &H3F
            IDSID = "SID_STARTVERSIONING2"
        Case &H40
            IDSID = "SID_QUERYREALMS2"
        Case &H41
            IDSID = "SID_QUERYADURL"
        Case &H44
            IDSID = "SID_WARCRAFTGENERAL"
        Case &H45
            IDSID = "SID_NETGAMEPORT"
        Case &H46
            IDSID = "SID_NEWS_INFO"
        Case &H4A
            IDSID = "SID_OPTIONALWORK"
        Case &H4C
            IDSID = "SID_REQUIREDWORK"
        Case &H50
            IDSID = "SID_AUTH_INFO"
        Case &H51
            IDSID = "SID_AUTH_CHECK"
        Case &H52
            IDSID = "SID_AUTH_ACCOUNTCREATE"
        Case &H53
            IDSID = "SID_AUTH_ACCOUNTLOGON"
        Case &H54
            IDSID = "SID_AUTH_ACCOUNTLOGONPROOF"
        Case &H55
            IDSID = "SID_AUTH_ACCOUNTCHANGE"
        Case &H56
            IDSID = "SID_AUTH_ACCOUNTCHANGEPROOF"
        Case &H59
            IDSID = "SID_SETEMAIL"
        Case &H5A
            IDSID = "SID_RESETPASSWORD"
        Case &H5B
            IDSID = "SID_CHANGEEMAIL"
        Case &H5C
            IDSID = "SID_SWITCHPRODUCT"
        Case &H60
            IDSID = "SID_GAMEPLAYERSEARCH"
        Case &H65
            IDSID = "SID_FRIENDSLIST"
        Case &H66
            IDSID = "SID_FRIENDSUPDATE"
        Case &H67
            IDSID = "SID_FRIENDSADD"
        Case &H68
            IDSID = "SID_FRIENDSREMOVE"
        Case &H69
            IDSID = "SID_FRIENDSPOSITION"
        Case &H70
            IDSID = "SID_CLANFINDCANDIDATES"
        Case &H71
            IDSID = "SID_CLANINVITEMULTIPLE"
        Case &H72
            IDSID = "SID_CLANCREATIONINVITATION"
        Case &H73
            IDSID = "SID_CLANDISBAND"
        Case &H74
            IDSID = "SID_CLANMAKECHIEFTAIN"
        Case &H75
            IDSID = "SID_CLANINFO"
        Case &H76
            IDSID = "SID_CLANQUITNOTIFY"
        Case &H77
            IDSID = "SID_CLANINVITATION"
        Case &H78
            IDSID = "SID_CLANREMOVEMEMBER"
        Case &H79
            IDSID = "SID_CLANINVITATIONRESPONSE"
        Case &H7A
            IDSID = "SID_CLANRANKCHANGE"
        Case &H7B
            IDSID = "SID_CLANSETMOTD"
        Case &H7C
            IDSID = "SID_CLANMOTD"
        Case &H7D
            IDSID = "SID_CLANMEMBERLIST"
        Case &H7E
            IDSID = "SID_CLANMEMBERREMOVED"
        Case &H7F
            IDSID = "SID_CLANMEMBERSTATUSCHANGE"
        Case &H81
            IDSID = "SID_CLANMEMBERRANKCHANGE"
        Case &H82
            IDSID = "SID_CLANMEMBERINFORMATION"
        Case Else
            IDSID = "SID (" & PacketID & ")"
    End Select
End Function
Public Function KillNull(ByVal Text As String) As String
    On Error GoTo Erred
    If InStr(Text, vbNullChar) > 0 Then
        KillNull = Split(Text, vbNullChar)(0)
    Else
        KillNull = Text
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "KillNull"
    Resume Next
End Function
Public Function Leet(ByVal strMessage As String) As String
Dim TmpL As String
Dim I    As Integer
    TmpL = " "
    Randomize
    For I = 1 To Len(strMessage)
        If LCase$(Mid$(strMessage, I, 3)) = "the" Then
            TmpL = TmpL & "t3h"
            I = I + 2
        ElseIf LCase$(Mid$(strMessage, I, 3)) = "you" Then
            TmpL = TmpL & "j00"
            I = I + 2
        ElseIf LCase$(Mid$(strMessage, I, 3)) = "own" Then
            TmpL = TmpL & "pwn"
            I = I + 2
        ElseIf LCase$(Mid$(strMessage, I, 5)) = "hacks" Then
            TmpL = TmpL & "h4x"
            I = I + 4
        ElseIf LCase$(Mid$(strMessage, I, 4)) = "omfg" Then
            TmpL = TmpL & "z0mFGEE"
            I = I + 3
        Else
            Select Case Mid$(strMessage, I, 1)
            Case "a"
                TmpL = TmpL & "4"
            Case "A"
                TmpL = TmpL & "/-\"
            Case "b"
                TmpL = TmpL & ""
            Case "B"
                TmpL = TmpL & "|3"
            Case "c"
                TmpL = TmpL & ""
            Case "C"
                TmpL = TmpL & "<"
            Case "d"
                TmpL = TmpL & ""
            Case "D"
                TmpL = TmpL & "|)"
            Case "e"
                TmpL = TmpL & "3"
            Case "E"
                TmpL = TmpL & ""
            Case "f"
                TmpL = TmpL & "ph"
            Case "F"
                TmpL = TmpL & "|="
            Case "g"
                TmpL = TmpL & "9"
            Case "G"
                TmpL = TmpL & "[,"
            Case "h"
                TmpL = TmpL & "h"
            Case "H"
                TmpL = TmpL & "|-|"
            Case "i"
                TmpL = TmpL & ""
            Case "I"
                TmpL = TmpL & "|"
            Case "j"
                TmpL = TmpL & "j"
            Case "J"
                TmpL = TmpL & "j"
            Case "k"
                TmpL = TmpL & "|<"
            Case "K"
                TmpL = TmpL & "|<"
            Case "l"
                TmpL = TmpL & "1"
            Case "L"
                TmpL = TmpL & "|_"
            Case "m"
                TmpL = TmpL & "nn"
            Case "M"
                TmpL = TmpL & "|\/|"
            Case "n"
                TmpL = TmpL & ""
            Case "N"
                TmpL = TmpL & "|\|"
            Case "o"
                TmpL = TmpL & ""
            Case "O"
                TmpL = TmpL & "0"
            Case "p"
                TmpL = TmpL & ""
            Case "P"
                TmpL = TmpL & "|"
            Case "q"
                TmpL = TmpL & "|"
            Case "Q"
                TmpL = TmpL & "O,"
            Case "r"
                TmpL = TmpL & "r"
            Case "R"
                TmpL = TmpL & ""
            Case "s"
                TmpL = TmpL & "5"
            Case "S"
                TmpL = TmpL & ""
            Case "t"
                TmpL = TmpL & "7"
            Case "T"
                TmpL = TmpL & "|"
            Case "u"
                TmpL = TmpL & ""
            Case "U"
                TmpL = TmpL & "(_)"
            Case "v"
                TmpL = TmpL & "v"
            Case "V"
                TmpL = TmpL & "\/"
            Case "w"
                TmpL = TmpL & "vv"
            Case "W"
                TmpL = TmpL & "\/\/"
            Case "x"
                TmpL = TmpL & "x"
            Case "X"
                TmpL = TmpL & "xx"
            Case "y"
                TmpL = TmpL & "y"
            Case "Y"
                TmpL = TmpL & "`/"
            Case "z"
                TmpL = TmpL & "Z"
            Case "Z"
                TmpL = TmpL & "ZZ0"
            Case Else
                TmpL = TmpL & Mid$(strMessage, I, 1)
            End Select
        End If
    Next I
    Leet = TmpL
End Function
Public Function LegalURL(ByVal URL As String) As Boolean
    On Error GoTo Erred
    URL = LCase$(URL)
    If Left$(URL, 4) = "www." Then
        Select Case LCase$(Mid$(URL, 5, 1))
        Case "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"
            LegalURL = True
            Exit Function
        Case Else
            LegalURL = False
            Exit Function
        End Select
    ElseIf Left$(URL, 7) = "http://" Then
        If Mid$(URL, 8, 4) = "www." Then
            Select Case LCase$(Mid$(URL, 12, 1))
            Case "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"
                LegalURL = True
                Exit Function
            Case Else
                LegalURL = False
                Exit Function
            End Select
        Else
            Select Case LCase$(Mid$(URL, 8, 1))
            Case "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"
                LegalURL = True
                Exit Function
            Case Else
                LegalURL = False
                Exit Function
            End Select
        End If
    ElseIf Left$(URL, 8) = "https://" Then
        If Mid$(URL, 9, 4) = "www." Then
            Select Case LCase$(Mid$(URL, 13, 1))
            Case "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"
                LegalURL = True
                Exit Function
            Case Else
                LegalURL = False
                Exit Function
            End Select
        Else
            Select Case LCase$(Mid$(URL, 9, 1))
            Case "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"
                LegalURL = True
                Exit Function
            Case Else
                LegalURL = False
                Exit Function
            End Select
        End If
    ElseIf Left$(URL, 6) = "ftp://" Then
        If Mid$(URL, 7, 4) = "www." Then
            Select Case LCase$(Mid$(URL, 11, 1))
            Case "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"
                LegalURL = True
                Exit Function
            Case Else
                LegalURL = False
                Exit Function
            End Select
        Else
            Select Case LCase$(Mid$(URL, 7, 1))
            Case "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"
                LegalURL = True
                Exit Function
            Case Else
                LegalURL = False
                Exit Function
            End Select
        End If
    Else
        LegalURL = False
        Exit Function
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "LegalURL"
    Resume Next
End Function
Public Function MakeFT(ByVal FromStr As String) As FILETIME
Dim HighTime As Double
Dim LowTime As Double
    On Error GoTo Erred
        HighTime = Left$(FromStr, InStr(1, FromStr, " "))
        HighTime = MakeLongSize(HighTime)
        LowTime = Mid$(FromStr, InStr(1, FromStr, " "))
        LowTime = MakeLongSize(LowTime)
        MakeFT.dwHighDateTime = CLng(HighTime)
        MakeFT.dwLowDateTime = CLng(LowTime)
Exit Function
Erred:
    ErrorHandler "Functions", "MakeFT " & FromStr
    Resume Next
End Function
Public Function MakeLongSize(ByVal BigNumber As Double) As Long
    On Error GoTo Erred
ReCheck:
    If BigNumber > 2147483647 Then
        BigNumber = BigNumber - 2147483647
        GoTo ReCheck
    End If
    MakeLongSize = BigNumber
Exit Function
Erred:
    ErrorHandler "Functions", "MakeLongSize " & BigNumber
    Resume Next
End Function
Public Sub MaxLines(ByVal MaxCount As Long, ByRef Box As RichTextBox, ByRef linkStuff As clsHyperlink)
Dim LinesToRemove As Long
Dim chrsToStart   As Long
Dim chrsToEnd     As Long
    On Error GoTo Erred
    If SendMessageA(Box.hwnd, EM_GETLINECOUNT, 0, 0) > MaxCount Then
        LinesToRemove = MaxCount \ 10
        If LinesToRemove < 1 Then LinesToRemove = 1
        chrsToStart = SendMessageA(Box.hwnd, EM_LINEINDEX, 0, ByVal 0&)
        chrsToEnd = SendMessageA(Box.hwnd, EM_LINEINDEX, LinesToRemove, ByVal 0&)
        SendMessageA Box.hwnd, EM_SETSEL, chrsToStart, ByVal chrsToEnd
        SendMessageA Box.hwnd, EM_REPLACESEL, 0, 0
        Box.SelStart = Len(Box.Text)
        linkStuff.UpdateLinks chrsToEnd - chrsToStart
    End If
Exit Sub
Erred:
    ErrorHandler "Functions", "MaxLines"
    Resume Next
End Sub
Private Sub MenuIcon(ByVal Target As Long, ByRef ipcPicture As IPictureDisp)
Dim hMenu     As Long
Dim hSubMenu  As Long
Dim nPosition As Long
    On Error GoTo Erred
    hMenu = GetMenu(frmMain.hwnd)
    If frmMain.imgMnuSize.Left > 0 Then
        hSubMenu = GetSubMenu(hMenu, 0)
    Else
        hSubMenu = GetSubMenu(hMenu, 3)
    End If
    nPosition = GetMenuItemID(hSubMenu, Target)
    SetMenuItemBitmaps hMenu, nPosition, 0, CLng(ipcPicture), CLng(ipcPicture)
Exit Sub
Erred:
    ErrorHandler "Functions", "MenuIcon"
    Resume Next
End Sub
Public Function MessageBox(ByVal strMessage As String, Optional ByVal IconStyle As style = Information, Optional ByVal ButtonStyle As Buttons = OKOnly, Optional ByVal strCaption As String = "Ripple Chat Bot", Optional ByVal Default As String) As String
Attribute MessageBox.VB_UserMemId = -552
Dim DialogBox As New frmDialog
    On Error GoTo Erred
    DialogBox.SetStyle strMessage, IconStyle, ButtonStyle, strCaption, Default
    If frmMain.WindowState = vbMinimized Or Not frmMain.Visible Then
        frmMain.Enabled = False
        DialogBox.Show
    Else
        DialogBox.Show vbModal
    End If
    Do Until DialogBox.Result <> vbNullString
        DoEvents
    Loop
    If IconStyle = InputDialog And (DialogBox.Result = "Cancel" Or DialogBox.Result = "No") Then
        MessageBox = vbNullString
    Else
        MessageBox = DialogBox.Result
    End If
    If frmMain.WindowState = vbMinimized Or Not frmMain.Visible Then frmMain.Enabled = True
Exit Function
Erred:
    ErrorHandler "Functions", "MessageBox"
    Resume Next
End Function
Public Function Morse(ByVal strMessage As String, MorseOut As Boolean) As String
Dim Ans    As String
Dim Nums() As String
Dim I      As Integer
    On Error GoTo Erred
    If MorseOut Then
        For I = 1 To Len(strMessage)
            Select Case LCase$(Mid$(strMessage, I, 1))
                Case "a"
                    Ans = Ans & ".-"
                Case "b"
                    Ans = Ans & "-..."
                Case "c"
                    Ans = Ans & "-.-."
                Case "d"
                    Ans = Ans & "-.."
                Case "e"
                    Ans = Ans & "."
                Case "f"
                    Ans = Ans & "..-."
                Case "g"
                    Ans = Ans & "--."
                Case "h"
                    Ans = Ans & "...."
                Case "i"
                    Ans = Ans & ".."
                Case "j"
                    Ans = Ans & ".---"
                Case "k"
                    Ans = Ans & "-.-"
                Case "l"
                    Ans = Ans & ".-.."
                Case "m"
                    Ans = Ans & "--"
                Case "n"
                    Ans = Ans & "-."
                Case "o"
                    Ans = Ans & "---"
                Case "p"
                    Ans = Ans & ".--."
                Case "q"
                    Ans = Ans & "--.-"
                Case "r"
                    Ans = Ans & ".-."
                Case "s"
                    Ans = Ans & "..."
                Case "t"
                    Ans = Ans & "-"
                Case "u"
                    Ans = Ans & "..-"
                Case "v"
                    Ans = Ans & "...-"
                Case "w"
                    Ans = Ans & ".--"
                Case "x"
                    Ans = Ans & "-..-"
                Case "y"
                    Ans = Ans & "-.--"
                Case "z"
                    Ans = Ans & "--.."
                Case "0"
                    Ans = Ans & "-----"
                Case "1"
                    Ans = Ans & ".----"
                Case "2"
                    Ans = Ans & "..---"
                Case "3"
                    Ans = Ans & "...--"
                Case "4"
                    Ans = Ans & "....-"
                Case "5"
                    Ans = Ans & "....."
                Case "6"
                    Ans = Ans & "-...."
                Case "7"
                    Ans = Ans & "--..."
                Case "8"
                    Ans = Ans & "---.."
                Case "9"
                    Ans = Ans & "----."
                Case "."
                    Ans = Ans & ".-.-.-"
                Case ","
                    Ans = Ans & "--..--"
                Case "?"
                    Ans = Ans & "..--.."
                Case "'"
                    Ans = Ans & ".----."
                Case "!"
                    Ans = Ans & "-.-.--"
                Case "/"
                    Ans = Ans & "-..-."
                Case "("
                    Ans = Ans & "-.--."
                Case ")"
                    Ans = Ans & "-.--.-"
                Case "&"
                    Ans = Ans & ". ..."
                Case ":"
                    Ans = Ans & "---..."
                Case ";"
                    Ans = Ans & "-.-.-."
                Case "="
                    Ans = Ans & "-...-"
                Case "\"
                    Ans = Ans & "-..-."
                Case "-"
                    Ans = Ans & "-....-"
                Case "_"
                    Ans = Ans & "..-- .-"
                Case """"
                    Ans = Ans & ".-..-."
                Case "$"
                    Ans = Ans & "...-..-"
                Case "@"
                    Ans = Ans & ".--.-."
                Case " "
                    Ans = Ans & "/"
                Case Else
                    Ans = Ans & "_"
            End Select
            Ans = Ans & "  "
        Next I
    Else
        Nums = Split(strMessage, "  ")
        For I = 0 To UBound(Nums)
            Select Case Nums(I)
                Case ".-"
                    Ans = Ans & "a"
                Case "-..."
                    Ans = Ans & "b"
                Case "-.-."
                    Ans = Ans & "c"
                Case "-.."
                    Ans = Ans & "d"
                Case "."
                    Ans = Ans & "e"
                Case "..-."
                    Ans = Ans & "f"
                Case "--."
                    Ans = Ans & "g"
                Case "...."
                    Ans = Ans & "h"
                Case ".."
                    Ans = Ans & "i"
                Case ".---"
                    Ans = Ans & "j"
                Case "-.-"
                    Ans = Ans & "k"
                Case ".-.."
                    Ans = Ans & "l"
                Case "--"
                    Ans = Ans & "m"
                Case "-."
                    Ans = Ans & "n"
                Case "---"
                    Ans = Ans & "o"
                Case ".--."
                    Ans = Ans & "p"
                Case "--.-"
                    Ans = Ans & "q"
                Case ".-."
                    Ans = Ans & "r"
                Case "..."
                    Ans = Ans & "s"
                Case "-"
                    Ans = Ans & "t"
                Case "..-"
                    Ans = Ans & "u"
                Case "...-"
                    Ans = Ans & "v"
                Case ".--"
                    Ans = Ans & "w"
                Case "-..-"
                    Ans = Ans & "x"
                Case "-.--"
                    Ans = Ans & "y"
                Case "--.."
                    Ans = Ans & "z"
                Case "-----"
                    Ans = Ans & "0"
                Case ".----"
                    Ans = Ans & "1"
                Case "..---"
                    Ans = Ans & "2"
                Case "...--"
                    Ans = Ans & "3"
                Case "....-"
                    Ans = Ans & "4"
                Case "....."
                    Ans = Ans & "5"
                Case "-...."
                    Ans = Ans & "6"
                Case "--..."
                    Ans = Ans & "7"
                Case "---.."
                    Ans = Ans & "8"
                Case "----."
                    Ans = Ans & "9"
                Case ".-.-.-"
                    Ans = Ans & "."
                Case "--..--"
                    Ans = Ans & ","
                Case "..--.."
                    Ans = Ans & "?"
                Case ".----."
                    Ans = Ans & "'"
                Case "-.-.--"
                    Ans = Ans & "!"
                Case "-..-."
                    Ans = Ans & "/"
                Case "-.--."
                    Ans = Ans & "("
                Case "-.--.-"
                    Ans = Ans & ")"
                Case ". ..."
                    Ans = Ans & "&"
                Case "---..."
                    Ans = Ans & ":"
                Case "-.-.-."
                    Ans = Ans & ";"
                Case "-...-"
                    Ans = Ans & "="
                Case "-..-."
                    Ans = Ans & "\"
                Case "-....-"
                    Ans = Ans & "-"
                Case "..-- .-"
                    Ans = Ans & "_"
                Case ".-..-."
                    Ans = Ans & """"
                Case "...-..-"
                    Ans = Ans & "$"
                Case ".--.-."
                    Ans = Ans & "@"
                Case "/"
                    Ans = Ans & " "
                Case Else
                    Ans = Ans & "_"
            End Select
        Next I
    End If
    Morse = Trim$(Ans)
Exit Function
Erred:
    ErrorHandler "Functions", "Morse"
    Resume Next
End Function
Public Sub OnTop(ByRef Frm As Form, ByVal TopMost As Boolean)
    On Error GoTo Erred
    If TopMost Then
        SetWindowPos Frm.hwnd, -1, 0, 0, 0, 0, &H1 Or &H2 Or &H10
    Else
        SetWindowPos Frm.hwnd, -2, 0, 0, 0, 0, &H1 Or &H2 Or &H10
    End If
Exit Sub
Erred:
    ErrorHandler "Functions", "OnTop"
    Resume Next
End Sub
Public Sub OpenURL(ByVal URL As String)
    On Error GoTo Erred
    ShellExecuteA 0, vbNullString, URL, vbNullString, vbNullString, 1
Exit Sub
Erred:
    ErrorHandler "Functions", "OpenURL"
    Resume Next
End Sub
Public Function ReadINI(ByVal riSection As String, ByVal riKey As String, ByVal riDefault As String, ByVal riFile As String) As String
Dim sRiBuffer As String
Dim sRiValue  As String
Dim sRiLong   As String
Dim INIFile   As String
    On Error GoTo Erred
    INIFile = App.Path & "\" & riFile
    If LenB(Dir$(INIFile)) > 0 Then
        sRiBuffer = String$(255, vbNull)
        sRiLong = GetPrivateProfileStringA(riSection, riKey, ChrW$(1), sRiBuffer, 255, INIFile)
        If Left$(sRiBuffer, 1) <> ChrW$(1) Then
            sRiValue = Left$(sRiBuffer, sRiLong)
            If LenB(sRiValue) > 0 Then
                ReadINI = sRiValue
            Else
                ReadINI = riDefault
            End If
        Else
            ReadINI = riDefault
        End If
    Else
        ReadINI = riDefault
    End If
Exit Function
Erred:
    If Err.Description = "File already open" Then
        MessageBox "Could not save the config file. It is currently in use.", Critical, OKOnly
    Else
        ErrorHandler "Functions", "ReadINI"
        Resume Next
    End If
End Function
Public Function RemoveNumber(ByVal Account As String) As String
    On Error GoTo Erred
    If InStr(1, Account, "#") > 0 Then
        If InStr(InStr(1, Account, "#"), Account, "@") > 0 Then
            RemoveNumber = Left$(Account, InStr(1, Account, "#") - 1) & Mid$(Account, InStr(1, Account, "@"))
        Else
            RemoveNumber = Left$(Account, InStr(1, Account, "#") - 1)
        End If
    Else
        RemoveNumber = Account
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "RemoveNumber (" & Account & ")"
    Resume Next
End Function
Public Sub SendStringTo(ByVal strCaption As String, ByVal send As String)
Dim hwnd As Long
Dim cds  As COPYDATASTRUCT
    On Error GoTo Erred
    hwnd = FindWindowA("ThunderRT6FormDC", strCaption)
    If Len(send) = 0 Then
        send = vbNullString
    End If
    cds.cbData = LenB(send)
    cds.lpData = StrPtr(send)
    SendMessageA hwnd, &H4A, frmMain.hwnd, cds
Exit Sub
Erred:
    ErrorHandler "Functions", "SendString"
    Resume Next
End Sub
Public Function ServerIPToChar(ByVal ServerIP As String, ByRef CharString As String) As Boolean
Dim IP() As String
    On Error GoTo Erred
    IP() = Split(ServerIP, ".")
    If UBound(IP) = 3 Then
        CharString = Chr$(IP(0)) & Chr$(IP(1)) & Chr$(IP(2)) & Chr$(IP(3))
        ServerIPToChar = True
    Else
        ServerIPToChar = False
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "ServerIPToChar"
    Resume Next
End Function
Public Sub SetAllCaps(ByVal txt As TextBox)
Const GWL_STYLE = (-16)
Const ES_UPPERCASE = &H8&
Dim style As Long
    style = GetWindowLongA(txt.hwnd, GWL_STYLE)
    style = style Or ES_UPPERCASE
    SetWindowLongA txt.hwnd, GWL_STYLE, style
End Sub
Public Sub SetHand()
Dim lHandle As Long
    On Error GoTo Erred
    lHandle = LoadCursorA(0, HANDCURSOR)
    If lHandle > 0 Then SetCursor lHandle
Exit Sub
Erred:
    ErrorHandler "Functions", "SetHand"
    Resume Next
End Sub
Public Function ShortenFilename(ByVal strFile As String, ByRef Frm As Form, ByRef lbl As Label) As String
    On Error GoTo Erred
    Frm.ScaleMode = vbPixels
    PathCompactPathA Frm.hDC, strFile, lbl.Width - Frm.DrawWidth - 3
    ShortenFilename = strFile
Exit Function
Erred:
    ErrorHandler "Functions", "ShortenFilename"
    Resume Next
End Function
Public Function SlashCheck(ByVal strMessage As String) As String
    On Error GoTo Erred
    If Left$(strMessage, 1) = "/" Then
        If LCase$(Left$(strMessage, 3)) <> "/me" And LCase$(Left$(strMessage, 2)) <> "/w" And LCase$(Left$(strMessage, 4)) <> "/msg" And LCase$(Left$(strMessage, 2)) <> "/m" And LCase$(Left$(strMessage, 8)) <> "/whisper" Then
            strMessage = Right$(strMessage, Len(strMessage) - 1)
            If Left$(strMessage, 1) = "/" Then SlashCheck (strMessage)
        End If
    End If
    SlashCheck = strMessage
Exit Function
Erred:
    ErrorHandler "Functions", "SlashCheck"
    Resume Next
End Function
Public Function Specs_Audio() As String
Dim soundinfo As WAVEOUTCAPS
Dim tmp As String
Dim I As Long
    On Error GoTo Erred
    If waveOutGetNumDevs > 0 Then
        tmp = vbNullString
        For I = 0 To waveOutGetNumDevs - 1
            waveOutGetDevCapsA I, soundinfo, Len(soundinfo)
            Specs_Audio = Specs_Audio & "Audio Device(" & I & "): " & FindIllegal(soundinfo.szPname) & vbLf
        Next I
    End If
    If LenB(Specs_Audio) = 0 Then
        Specs_Audio = "Audio Device: None detected."
    Else
        Specs_Audio = Left$(Specs_Audio, Len(Specs_Audio) - 1)
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "SpecsAudio"
    Resume Next
End Function
Public Function Specs_HardDrive() As String
Dim sDrive      As String
Dim liAvailable As LARGE_INTEGER
Dim liTotal     As LARGE_INTEGER
Dim liFree      As LARGE_INTEGER
Dim dblTotal    As Double
Dim dblFree     As Double
Dim I           As Integer
    On Error GoTo Erred
    For I = 65 To 90
        sDrive = Left$(Chr$(I) & ":", 2)
        If GetDriveTypeA(sDrive) = 3 Then
            GetDiskFreeSpaceExA sDrive, liAvailable, liTotal, liFree
            dblTotal = CLargeInt(liTotal.lowpart, liTotal.highpart)
            dblFree = CLargeInt(liFree.lowpart, liFree.highpart)
            Specs_HardDrive = Specs_HardDrive & "Hard Drive (" & sDrive & "\): " & ByteSize(dblTotal) & " (" & ByteSize(dblFree) & " free)" & vbLf
        End If
    Next I
    If LenB(Specs_HardDrive) = 0 Then
        Specs_HardDrive = "Hard Drive: None detected."
    Else
        Specs_HardDrive = Left$(Specs_HardDrive, Len(Specs_HardDrive) - 1)
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "SpecsHardDrive"
    Resume Next
End Function
Public Function Specs_Memory() As String
Dim mem As MEMORYSTATUS
    On Error GoTo Erred
    GlobalMemoryStatus mem
    Specs_Memory = "Memory: " & ByteSize(mem.dwTotalPhys) & " physical, " & ByteSize(mem.dwTotalVirtual) & " virtual"
    If LenB(Specs_Memory) = 0 Then Specs_Memory = "Memory: None detected."
Exit Function
Erred:
    ErrorHandler "Functions", "SpecsMemory"
    Resume Next
End Function
Public Function Specs_Motherboard() As String
Dim SpecList     As String
Dim BaseBoardSet As SWbemObjectSet
Dim bb           As SWbemObject
    On Error GoTo Erred
    Set BaseBoardSet = GetObject("winmgmts:{impersonationLevel=impersonate}").InstancesOf("Win32_BaseBoard")
    For Each bb In BaseBoardSet
        SpecList = SpecList & "Motherboard: " & bb.Manufacturer & " " & bb.Product & vbLf
    Next bb
    Specs_Motherboard = Left$(SpecList, Len(SpecList) - 1)
    If LenB(Specs_Motherboard) = 0 Then Specs_Motherboard = "Motherboard: None detected."
Exit Function
Erred:
    If Err.Number = 432 Then
        Specs_Motherboard = "Motherboard information not available."
    Else
        ErrorHandler "Functions", "SpecsVideo"
        Resume Next
    End If
End Function
Public Function Specs_OS() As String
Dim strMsg       As String
Dim udtVerinfo   As OSVERSIONINFOEX
    On Error GoTo Erred
    udtVerinfo.szCSDVersion = Space$(128)
    udtVerinfo.dwOSVersionInfoSize = Len(udtVerinfo)
    If GetVersionExA(udtVerinfo) Then
        Select Case udtVerinfo.dwMajorVersion
            Case 3
                Select Case udtVerinfo.dwMinorVersion
                    Case 5
                        strMsg = "Windows NT "
                    Case Else
                        strMsg = "Windows "
                End Select
            Case 4
                Select Case udtVerinfo.dwMinorVersion
                    Case 0
                        strMsg = "Windows NT "
                    Case 1
                        If udtVerinfo.dwBuildNumber < 2183 Then
                            strMsg = "Windows 98 "
                        Else
                            strMsg = "Windows 98 SE "
                        End If
                    Case Else
                        strMsg = "Windows ME "
                End Select
            Case 5
                Select Case udtVerinfo.dwMinorVersion
                    Case 0
                        strMsg = "Windows 2000 "
                    Case 1
                        strMsg = "Windows XP "
                    Case 2
                        strMsg = "Windows Server 2003 "
                End Select
            Case 6
                strMsg = "Windows Vista "
            Case Else
                strMsg = "Windows Unknown Version "
        End Select
        If LenB(strMsg) > 0 Then
            Specs_OS = "Operating System: " & strMsg & "Version " & udtVerinfo.dwMajorVersion & "." & udtVerinfo.dwMinorVersion & " (Build " & udtVerinfo.dwBuildNumber & ") " & FindIllegal(udtVerinfo.szCSDVersion)
        Else
            Specs_OS = "Operating System: None detected."
        End If
    Else
        Specs_OS = "Operating System: None detected."
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "SpecsOS"
    Resume Next
End Function
Public Function Specs_Processor() As String
    On Error GoTo Erred
    If LenB(Trim$(regQuery_A_Key(HKEY_LOCAL_MACHINE, "HARDWARE\DESCRIPTION\System\CentralProcessor\0", "ProcessorNameString"))) > 0 Then
        Specs_Processor = "Processor: " & Trim$(regQuery_A_Key(HKEY_LOCAL_MACHINE, "HARDWARE\DESCRIPTION\System\CentralProcessor\0", "ProcessorNameString")) & " (" & Trim$(regQuery_A_Key(HKEY_LOCAL_MACHINE, "HARDWARE\DESCRIPTION\System\CentralProcessor\0", "Identifier")) & ") at ~" & Trim$(regQuery_A_Key(HKEY_LOCAL_MACHINE, "HARDWARE\DESCRIPTION\System\CentralProcessor\0", "~MHz")) & " MHz"
    Else
        Specs_Processor = "Processor: None detected."
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "SpecsProcessor"
    Resume Next
End Function
Public Function Specs_Video() As String
Dim SpecList  As String
Dim wmiObjSet As SWbemObjectSet
Dim obj       As SWbemObject
Dim VidCount  As Byte
Dim bm        As BITMAP
    On Error GoTo Erred
    Set wmiObjSet = GetObject("winmgmts:{impersonationLevel=impersonate}").InstancesOf("Win32_VideoController")
    VidCount = 1
    For Each obj In wmiObjSet
        SpecList = SpecList & "Video Card(" & VidCount & "): " & ByteSize(obj.AdapterRAM) & " " & obj.VideoProcessor & vbLf
        VidCount = VidCount + 1
    Next obj
    If LenB(SpecList) = 0 Then SpecList = "Video Card: None detected." & vbLf
    GetObjectA frmMain.Image, Len(bm), bm
    SpecList = SpecList & "Screen Resolution: " & Screen.Width / Screen.TwipsPerPixelX & "x" & Screen.Height / Screen.TwipsPerPixelY & " with " & bm.bmBitsPixel & "bit color"
    Specs_Video = SpecList
Exit Function
Erred:
    If Err.Number = 432 Then
        Specs_Video = "Video Card information not available."
    Else
        ErrorHandler "Functions", "SpecsVideo"
        Resume Next
    End If
End Function
Public Sub SpellCheck(ByRef TextObj As TextBox)
Dim objSpellCheck    As Object
Dim tmpClipBoardText As String
    On Error GoTo MissingWord
    If LenB(TextObj.Text) = 0 Then Exit Sub
    Screen.MousePointer = 13
    tmpClipBoardText = Clipboard.GetText
    Set objSpellCheck = CreateObject("Word.Application")
    objSpellCheck.Visible = False
    objSpellCheck.Documents.Add
    Clipboard.Clear
    Clipboard.SetText TextObj.Text
    objSpellCheck.Selection.Paste
    objSpellCheck.ActiveDocument.CheckSpelling
    objSpellCheck.ActiveDocument.Select
    objSpellCheck.Selection.Cut
    TextObj.Text = Clipboard.GetText
    objSpellCheck.ActiveDocument.Close SaveChanges:=0
    objSpellCheck.Quit
    Set objSpellCheck = Nothing
    Clipboard.SetText tmpClipBoardText
    Screen.MousePointer = 0
Exit Sub
MissingWord:
    frmMain.tbFont.Buttons(11).Visible = False
    MessageBox "Microsoft Word's Spell Checker could not be initialized!", Critical, OKOnly, "Spell Check Disabled!"
    Screen.MousePointer = 0
End Sub
Public Function RemoveSmileys(ByVal strRTF As String) As String
Dim CompareTo As String
Dim CompareFrom As String
Dim FindAndRemove As String
Dim CompareCode As String
Dim I As Integer
    On Error GoTo Erred
    CompareFrom = strRTF
ReCompare:
    If InStr(1, CompareFrom, "\pict\") > 0 Then
        If InStr(1, CompareFrom, "\pict\wmetafile8\") > 0 Then
            CompareTo = Mid$(CompareFrom, InStr(1, CompareFrom, "\pict\wmetafile8\") + 59)
            If InStr(1, CompareTo, "}") > 0 Then
                CompareTo = Left$(CompareTo, InStr(1, CompareTo, "}") - 1)
                If InStr(1, CompareFrom, "\pict\wmetafile8\") > 0 Then
                    FindAndRemove = Mid$(CompareFrom, InStr(1, CompareFrom, "\pict\wmetafile8\"))
                    If InStr(1, FindAndRemove, "}") > 0 Then
                        FindAndRemove = Left$(FindAndRemove, InStr(1, FindAndRemove, "}"))
                        If InStr(1, StdPicAsRTF(frmMain.imlSmileys.ListImages(1).Picture), " ") > 0 Then
                            CompareCode = Mid$(StdPicAsRTF(frmMain.imlSmileys.ListImages(1).Picture), InStr(1, StdPicAsRTF(frmMain.imlSmileys.ListImages(1).Picture), " ") + 1)
                            If InStr(1, CompareCode, "}") > 0 Then
                                CompareCode = LCase$(Left$(CompareCode, InStr(1, CompareCode, "}") - 1))
                                CompareTo = Replace$(CompareTo, vbCr, vbNullString)
                                CompareTo = Replace$(CompareTo, vbLf, vbNullString)
                                For I = 1 To frmMain.imlSmileys.ListImages.Count
                                    If InStr(1, StdPicAsRTF(frmMain.imlSmileys.ListImages(I).Picture), " ") > 0 Then
                                        CompareCode = Mid$(StdPicAsRTF(frmMain.imlSmileys.ListImages(I).Picture), InStr(1, StdPicAsRTF(frmMain.imlSmileys.ListImages(I).Picture), " ") + 1)
                                        If InStr(1, CompareCode, "}") Then
                                            CompareCode = LCase$(Left$(CompareCode, InStr(1, CompareCode, "}") - 1))
                                            If CompareTo = CompareCode Then
                                                CompareFrom = Replace$(CompareFrom, FindAndRemove, GetSmileyFromNum(I))
                                                GoTo ReCompare
                                            End If
                                        Else
                                            RemoveSmileys = strRTF
                                            Exit For
                                        End If
                                    Else
                                        RemoveSmileys = strRTF
                                        Exit For
                                    End If
                                Next I
                            Else
                                RemoveSmileys = strRTF
                            End If
                        Else
                            RemoveSmileys = strRTF
                        End If
                    Else
                        RemoveSmileys = strRTF
                    End If
                Else
                    RemoveSmileys = strRTF
                End If
            Else
                RemoveSmileys = strRTF
            End If
        Else
            RemoveSmileys = strRTF
        End If
    Else
        RemoveSmileys = strRTF
    End If
    RemoveSmileys = CompareFrom
Exit Function
Erred:
    ErrorHandler "Functions", "RemoveSmileys"
    Resume Next
End Function
Public Sub GetSmileyFromText(ByVal strMessage As String, ByRef strRTF As String, ByRef Length As Integer)
Dim SmileyStr As String
    If Len(strMessage) > 4 Then strMessage = Left$(strMessage, 4)
    SmileyStr = strMessage
AddSpace:
    If Len(SmileyStr) < 4 Then
        SmileyStr = SmileyStr & " "
        GoTo AddSpace
    End If
    If Left$(SmileyStr, 3) = ":)=" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(27).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 2) = ":)" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(1).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 3) = ":((" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(26).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 2) = ":(" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(2).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":o" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(3).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":D" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(4).Picture)
        Length = 2
    ElseIf LCase$(Left$(SmileyStr, 2)) = ":p" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(5).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":|" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(6).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":~" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(7).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ";)" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(8).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":O" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(9).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 3) = ":*>" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(22).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 2) = ":*" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(10).Picture)
        Length = 2
    ElseIf LCase$(Left$(SmileyStr, 3)) = ">:o" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(11).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = "8-)" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(12).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 2) = "$D" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(13).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":!" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(14).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":<" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(15).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":\" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(16).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 3) = ":'(" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(17).Picture)
        Length = 3
    ElseIf LCase$(Left$(SmileyStr, 2)) = ":x" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(18).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = "<3" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(19).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 3) = "</3" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(20).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 2) = ":/" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(21).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":>" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(23).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 3) = "LOL" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(24).Picture)
        Length = 3
    ElseIf LCase$(Left$(SmileyStr, 2)) = "x(" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(25).Picture)
        Length = 2
    ElseIf LCase$(Left$(SmileyStr, 2)) = "z)" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(28).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":]" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(29).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":[" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(30).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 3) = ":_|" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(31).Picture)
        Length = 3
    ElseIf LCase$(Left$(SmileyStr, 2)) = ":s" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(32).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":z" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(33).Picture)
        Length = 2
    ElseIf LCase$(Left$(SmileyStr, 2)) = ":c" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(34).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":Z" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(35).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 3) = "?:~" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(36).Picture)
        Length = 3
    ElseIf LCase$(Left$(SmileyStr, 2)) = ";p" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(37).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":q" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(38).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = "XD" Or Left$(SmileyStr, 2) = "xD" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(39).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = "X~" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(40).Picture)
        Length = 2
    ElseIf LCase$(Left$(SmileyStr, 2)) = "xo" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(41).Picture)
        Length = 2
    ElseIf LCase$(Left$(SmileyStr, 3)) = "x-p" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(42).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = "OoO" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(43).Picture)
        Length = 3
    ElseIf LCase$(Left$(SmileyStr, 2)) = ":u" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(44).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 3) = ":,)" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(48).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = ":,D" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(49).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 2) = ":," Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(45).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":." Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(46).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 3) = ":')" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(47).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = ":`D" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(50).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = ":'~" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(51).Picture)
        Length = 3
    ElseIf LCase$(Left$(SmileyStr, 3)) = ":'c" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(52).Picture)
        Length = 3
    ElseIf LCase$(Left$(SmileyStr, 2)) = "x)" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(53).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 3) = "X'D" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(54).Picture)
        Length = 3
    ElseIf LCase$(Left$(SmileyStr, 3)) = "8-p" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(55).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = ">:]" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(56).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = ">:>" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(57).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 2) = "|(" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(58).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = "D:" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(59).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 3) = "8-D" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(60).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = ">:(" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(61).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = ",`)" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(62).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 2) = ":n" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(63).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 2) = ":3" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(64).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 3) = ":'D" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(65).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = "O.O" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(66).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = "O.o" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(67).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = "o.O" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(68).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = "o.o" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(69).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = "-.-" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(70).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = "-_-" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(71).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = "V^^" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(72).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = "T_T" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(73).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 2) = ":#" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(74).Picture)
        Length = 2
    ElseIf Left$(SmileyStr, 3) = ">:|" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(75).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 3) = "@.@" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(76).Picture)
        Length = 3
    ElseIf Left$(SmileyStr, 4) = "@};-" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(77).Picture)
        Length = 4
    ElseIf Left$(SmileyStr, 4) = "[RR]" Then
        strRTF = StdPicAsRTF(frmMain.imlSmileys.ListImages(78).Picture)
        Length = 4
    Else
        strRTF = vbNullString
        Length = 0
    End If
End Sub
Public Function GetSmileyFromNum(Number As Integer) As String
    On Error GoTo Erred
    If Number = 1 Then
        GetSmileyFromNum = ":)"
    ElseIf Number = 2 Then
        GetSmileyFromNum = ":("
    ElseIf Number = 3 Then
        GetSmileyFromNum = ":o"
    ElseIf Number = 4 Then
        GetSmileyFromNum = ":D"
    ElseIf Number = 5 Then
        GetSmileyFromNum = ":P"
    ElseIf Number = 6 Then
        GetSmileyFromNum = ":|"
    ElseIf Number = 7 Then
        GetSmileyFromNum = ":~"
    ElseIf Number = 8 Then
        GetSmileyFromNum = ";)"
    ElseIf Number = 9 Then
        GetSmileyFromNum = ":O"
    ElseIf Number = 10 Then
        GetSmileyFromNum = ":*"
    ElseIf Number = 11 Then
        GetSmileyFromNum = ">:o"
    ElseIf Number = 12 Then
        GetSmileyFromNum = "8-)"
    ElseIf Number = 13 Then
        GetSmileyFromNum = "$D"
    ElseIf Number = 14 Then
        GetSmileyFromNum = ":!"
    ElseIf Number = 15 Then
        GetSmileyFromNum = ":<"
    ElseIf Number = 16 Then
        GetSmileyFromNum = ":\"
    ElseIf Number = 17 Then
        GetSmileyFromNum = ":'("
    ElseIf Number = 18 Then
        GetSmileyFromNum = ":x"
    ElseIf Number = 19 Then
        GetSmileyFromNum = "<3"
    ElseIf Number = 20 Then
        GetSmileyFromNum = "</3"
    ElseIf Number = 21 Then
        GetSmileyFromNum = ":/"
    ElseIf Number = 22 Then
        GetSmileyFromNum = ":*>"
    ElseIf Number = 23 Then
        GetSmileyFromNum = ":>"
    ElseIf Number = 24 Then
        GetSmileyFromNum = "LOL"
    ElseIf Number = 25 Then
        GetSmileyFromNum = "X("
    ElseIf Number = 26 Then
        GetSmileyFromNum = ":(("
    ElseIf Number = 27 Then
        GetSmileyFromNum = ":)="
    ElseIf Number = 28 Then
        GetSmileyFromNum = "z)"
    ElseIf Number = 29 Then
        GetSmileyFromNum = ":]"
    ElseIf Number = 30 Then
        GetSmileyFromNum = ":["
    ElseIf Number = 31 Then
        GetSmileyFromNum = ":_|"
    ElseIf Number = 32 Then
        GetSmileyFromNum = ":s"
    ElseIf Number = 33 Then
        GetSmileyFromNum = ":z"
    ElseIf Number = 34 Then
        GetSmileyFromNum = ":c"
    ElseIf Number = 35 Then
        GetSmileyFromNum = ":Z"
    ElseIf Number = 36 Then
        GetSmileyFromNum = "?:~"
    ElseIf Number = 37 Then
        GetSmileyFromNum = ";P"
    ElseIf Number = 38 Then
        GetSmileyFromNum = ":q"
    ElseIf Number = 39 Then
        GetSmileyFromNum = "XD"
    ElseIf Number = 40 Then
        GetSmileyFromNum = "X~"
    ElseIf Number = 41 Then
        GetSmileyFromNum = "xo"
    ElseIf Number = 42 Then
        GetSmileyFromNum = "x-p"
    ElseIf Number = 43 Then
        GetSmileyFromNum = "OoO"
    ElseIf Number = 44 Then
        GetSmileyFromNum = ":u"
    ElseIf Number = 45 Then
        GetSmileyFromNum = ":,"
    ElseIf Number = 46 Then
        GetSmileyFromNum = ":."
    ElseIf Number = 47 Then
        GetSmileyFromNum = ":')"
    ElseIf Number = 48 Then
        GetSmileyFromNum = ":,)"
    ElseIf Number = 49 Then
        GetSmileyFromNum = ":,D"
    ElseIf Number = 50 Then
        GetSmileyFromNum = ":`D"
    ElseIf Number = 51 Then
        GetSmileyFromNum = ":'~"
    ElseIf Number = 52 Then
        GetSmileyFromNum = ":'c"
    ElseIf Number = 53 Then
        GetSmileyFromNum = "x)"
    ElseIf Number = 54 Then
        GetSmileyFromNum = "X'D"
    ElseIf Number = 55 Then
        GetSmileyFromNum = "8-P"
    ElseIf Number = 56 Then
        GetSmileyFromNum = ">:]"
    ElseIf Number = 57 Then
        GetSmileyFromNum = ">:>"
    ElseIf Number = 58 Then
        GetSmileyFromNum = "|("
    ElseIf Number = 59 Then
        GetSmileyFromNum = "D:"
    ElseIf Number = 60 Then
        GetSmileyFromNum = "8-D"
    ElseIf Number = 61 Then
        GetSmileyFromNum = ">:("
    ElseIf Number = 62 Then
        GetSmileyFromNum = ",`)"
    ElseIf Number = 63 Then
        GetSmileyFromNum = ":n"
    ElseIf Number = 64 Then
        GetSmileyFromNum = ":3"
    ElseIf Number = 65 Then
        GetSmileyFromNum = ":'D"
    ElseIf Number = 66 Then
        GetSmileyFromNum = "O.O"
    ElseIf Number = 67 Then
        GetSmileyFromNum = "O.o"
    ElseIf Number = 68 Then
        GetSmileyFromNum = "o.O"
    ElseIf Number = 69 Then
        GetSmileyFromNum = "o.o"
    ElseIf Number = 70 Then
        GetSmileyFromNum = "-.-"
    ElseIf Number = 71 Then
        GetSmileyFromNum = "-_-"
    ElseIf Number = 72 Then
        GetSmileyFromNum = "V^^"
    ElseIf Number = 73 Then
        GetSmileyFromNum = "T_T"
    ElseIf Number = 74 Then
        GetSmileyFromNum = ":#"
    ElseIf Number = 75 Then
        GetSmileyFromNum = ">:|"
    ElseIf Number = 76 Then
        GetSmileyFromNum = "@.@"
    ElseIf Number = 77 Then
        GetSmileyFromNum = "@};-"
    ElseIf Number = 78 Then
        GetSmileyFromNum = "[RR]"
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "GetSmileyFromNum"
    Resume Next
End Function
Private Function StdPicAsRTF(ByRef aStdPic As StdPicture) As String
Dim hMetaDC   As Long
Dim hMeta     As Long
Dim hPicDC    As Long
Dim hOldBmp   As Long
Dim aBMP      As BITMAP
Dim aSize     As Size
Dim aPt       As POINTAPI
Dim Filename  As String
Dim screenDC  As Long
Dim retStr    As String
Dim byteStr   As String
Dim bytes()   As Byte
Dim nFile     As Integer
Dim I         As Long
    On Error GoTo Erred
    Filename = getTempName("WMF")
    hMetaDC = CreateMetaFileA(Filename)
    SetMapMode hMetaDC, MM_ANISOTROPIC
    SetWindowOrgEx hMetaDC, 0, 0, aPt
    GetObjectA aStdPic.Handle, Len(aBMP), aBMP
    SetWindowExtEx hMetaDC, aBMP.bmWidth, aBMP.bmHeight, aSize
    SaveDC hMetaDC
    screenDC = GetDC(0)
    hPicDC = CreateCompatibleDC(screenDC)
    ReleaseDC 0, screenDC
    hOldBmp = SelectObject(hPicDC, aStdPic.Handle)
    BitBlt hMetaDC, 0, 0, aBMP.bmWidth, aBMP.bmHeight, hPicDC, 0, 0, vbSrcCopy
    SelectObject hPicDC, hOldBmp
    DeleteDC hPicDC
    DeleteObject hOldBmp
    RestoreDC hMetaDC, True
    hMeta = CloseMetaFile(hMetaDC)
    DeleteMetaFile hMeta
    If Dir$(Filename) = "" Then Exit Function
    ReDim bytes(1 To FileLen(Filename)) As Byte
    nFile = FreeFile
    Open Filename For Binary Access Read As #nFile
    Get #nFile, , bytes
    Close #nFile
    byteStr = String$(FileLen(Filename) * 2, "0")
    For I = LBound(bytes) To UBound(bytes)
        If bytes(I) > &HF Then
            Mid$(byteStr, 1 + (I - 1) * 2, 2) = Hex$(bytes(I))
        Else
            Mid$(byteStr, 2 + (I - 1) * 2, 1) = Hex$(bytes(I))
        End If
    Next I
    retStr = "{\rtf1\ansi{\pict\picscalex100\picscaley100\picw" & aStdPic.Width & "\pich" & aStdPic.Height & "\picwgoal" & aBMP.bmWidth * Screen.TwipsPerPixelX & "\pichgoal" & aBMP.bmHeight * Screen.TwipsPerPixelY & "\wmetafile8" & " " & byteStr & "}}"
    StdPicAsRTF = retStr
    On Local Error Resume Next
    If LenB(Dir$(Filename)) > 0 Then Kill Filename
Exit Function
Erred:
    ErrorHandler "Functions", "StdPicAsRTF (" & Filename & ")"
End Function
Public Function StringToHex(ByVal StrToHex As String) As String
Dim strTemp   As String
Dim strReturn As String
Dim I         As Long
    On Error GoTo Erred
    For I = 1 To Len(StrToHex)
        strTemp = Hex$(Asc(Mid$(StrToHex, I, 1)))
        If Len(strTemp) = 1 Then strTemp = "0" & strTemp
        strReturn = strReturn & Space$(1) & strTemp
    Next I
    StringToHex = strReturn
Exit Function
Erred:
    ErrorHandler "Functions", "StringToHex"
    Resume Next
End Function
Public Function HexToString(ByVal HexToStr As String) As String
Dim strTemp   As String
Dim strReturn As String
Dim I         As Long
    On Error GoTo Erred
    For I = 1 To Len(HexToStr) Step 3
        strTemp = Chr$(Val("&H" & Mid$(HexToStr, I, 2)))
        strReturn = strReturn & strTemp
    Next I
    HexToString = strReturn
Exit Function
Erred:
    ErrorHandler "Functions", "HexToString"
    Resume Next
End Function
Public Function SuperCrypt(ByVal strText As String, ByVal Encrypt As Boolean) As String
Dim I          As Integer
Dim intKeyChar As Integer
Dim strTemp    As String
Dim strEnding  As String
Dim strChar1   As String * 1
Dim strChar2   As String * 1
Dim strKey     As String
    On Error GoTo Erred
    strKey = "And if the snow buries my," & vbNewLine
    strKey = strKey & "my neighborhood." & vbNewLine
    strKey = strKey & "And if my parents are crying" & vbNewLine
    strKey = strKey & "then I'll dig a tunnel" & vbNewLine
    strKey = strKey & "from my window to yours," & vbNewLine
    strKey = strKey & "yeah a tunnel from my window to yours." & vbNewLine
    strKey = strKey & "You climb out the chimney" & vbNewLine
    strKey = strKey & "and meet me in the middle," & vbNewLine
    strKey = strKey & "the middle of the town." & vbNewLine
    strKey = strKey & "And since there's no one else around," & vbNewLine
    strKey = strKey & "we let our hair grow long" & vbNewLine
    strKey = strKey & "and forget all we used to know," & vbNewLine
    strKey = strKey & "then our skin gets thicker" & vbNewLine
    strKey = strKey & "from living out in the snow." & vbNewLine & vbNewLine
    strKey = strKey & "You change all the lead" & vbNewLine
    strKey = strKey & "sleepin' in my head," & vbNewLine
    strKey = strKey & "as the day grows dim" & vbNewLine
    strKey = strKey & "I hear you sing a golden hymn." & vbNewLine & vbNewLine
    strKey = strKey & "Then we tried to name our babies," & vbNewLine
    strKey = strKey & "but we forgot all the names that," & vbNewLine
    strKey = strKey & "the names we used to know." & vbNewLine
    strKey = strKey & "But sometimes, we remember our bedrooms," & vbNewLine
    strKey = strKey & "and our parent's bedrooms," & vbNewLine
    strKey = strKey & "and the bedrooms of our friends." & vbNewLine
    strKey = strKey & "Then we think of our parents," & vbNewLine
    strKey = strKey & "well what the hell ever happened to them?!" & vbNewLine & vbNewLine
    strKey = strKey & "You change all the lead" & vbNewLine
    strKey = strKey & "sleepin' in my head to gold," & vbNewLine
    strKey = strKey & "as the day grows dim," & vbNewLine
    strKey = strKey & "I hear you sing a golden hymn," & vbNewLine
    strKey = strKey & "the song I've been trying to sing." & vbNewLine & vbNewLine
    strKey = strKey & "Purify the colors, purify my mind." & vbNewLine
    strKey = strKey & "Purify the colors, purify my mind," & vbNewLine
    strKey = strKey & "and spread the ashes of the colors" & vbNewLine
    strKey = strKey & "over this heart of mine."
    If Encrypt Then
        strEnding = ""
        For I = 1 To Len(strText)
            strChar1 = Mid$(strText, I, 1)
            intKeyChar = ((I - 1) Mod Len(strKey)) + 1
            strChar2 = Mid$(strKey, intKeyChar, 1)
            strTemp = strTemp & ChrW$(Asc(strChar1) Xor Asc(strChar2))
        Next I
        For I = 1 To Len(strTemp)
            strEnding = strEnding & Format$(Asc(Mid$(strTemp, I, 1)), "000")
        Next I
    Else
        If IsNumeric(Mid$(strText, 2)) Or Len(strText) > 310 Then
            If Left$(strText, 1) = "" Then
                For I = 2 To Len(strText) Step 3
                    strTemp = strTemp & ChrW$(Mid$(strText, I, 3))
                Next I
                For I = 1 To Len(strTemp)
                    strChar1 = Mid$(strTemp, I, 1)
                    intKeyChar = ((I - 1) Mod Len(strKey)) + 1
                    strChar2 = Mid$(strKey, intKeyChar, 1)
                    strEnding = strEnding & ChrW$(Asc(strChar1) Xor Asc(strChar2))
                Next I
            Else
                strEnding = strText
            End If
        Else
            strEnding = strText
        End If
    End If
    SuperCrypt = strEnding
Exit Function
Erred:
    If Err.Number = 13 Then
        strEnding = strText
    Else
        ErrorHandler "Functions", "Encryption"
        Resume Next
    End If
End Function
Public Function SysDir() As String
Dim SystemDir As String
Dim ret       As Long
    SystemDir = Space$(&HFF)
    ret = GetSystemDirectoryA(SystemDir, &HFF)
    SystemDir = Left$(SystemDir, ret)
    SysDir = SystemDir
End Function
Public Function TempDir() As String
    Randomize
    TempDir = GetTempDir & "RCB" & Int(Rnd * 10) & Int(Rnd * 10) & Int(Rnd * 10) & Int(Rnd * 10) & Int(Rnd * 10) & Profile & "\"
End Function
Public Function TimeZoneBias() As String
Dim oTZI     As TIME_ZONE_INFORMATION
Dim TimeZone As String
Dim DLSDate  As String
Dim STDDate  As String
Dim Bias     As Long
    On Error GoTo Erred
    GetTimeZoneInformation oTZI
    DLSDate = oTZI.DaylightDate.wMonth & "/" & oTZI.DaylightDate.wDay & "/" & Year(Date) & " " & oTZI.DaylightDate.wHour & ":" & oTZI.DaylightDate.wMinute & ":" & oTZI.DaylightDate.wSecond
    STDDate = oTZI.StandardDate.wMonth & "/" & oTZI.StandardDate.wDay & "/" & Year(Date) & " " & oTZI.StandardDate.wHour & ":" & oTZI.StandardDate.wMinute & ":" & oTZI.StandardDate.wSecond
    If oTZI.DaylightDate.wMonth = 0 Then
        Bias = oTZI.Bias - oTZI.StandardBias
        GoTo SkipDST
    End If
    If DateDiff("s", Now, DLSDate) >= 0 Then
        If DateDiff("s", Now, STDDate) <= 0 Then
            Bias = oTZI.Bias - oTZI.DaylightBias
        Else
            Bias = oTZI.Bias - oTZI.StandardBias
        End If
    Else
        Bias = oTZI.Bias - oTZI.StandardBias
    End If
SkipDST:
    TimeZoneBias = Bias
Exit Function
Erred:
    ErrorHandler "Functions", "TimeZoneBias"
    Resume Next
End Function
Public Function TimeZoneName() As String
Dim oTZI     As TIME_ZONE_INFORMATION
Dim TimeZone As String
Dim tmp      As String
Dim DLSDate  As String
Dim DLSName  As String
Dim STDDate  As String
Dim STDName  As String
Dim Bias     As Long
Dim I        As Integer
    On Error GoTo Erred
    GetTimeZoneInformation oTZI
    DLSDate = oTZI.DaylightDate.wMonth & "/" & oTZI.DaylightDate.wDay & "/" & Year(Date) & " " & oTZI.DaylightDate.wHour & ":" & oTZI.DaylightDate.wMinute & ":" & oTZI.DaylightDate.wSecond
    DLSName = vbNullString
    For I = 0 To 31
        DLSName = DLSName & Chr$(oTZI.DaylightName(I))
    Next I
    STDDate = oTZI.StandardDate.wMonth & "/" & oTZI.StandardDate.wDay & "/" & Year(Date) & " " & oTZI.StandardDate.wHour & ":" & oTZI.StandardDate.wMinute & ":" & oTZI.StandardDate.wSecond
    STDName = vbNullString
    For I = 0 To 31
        STDName = STDName & Chr$(oTZI.StandardName(I))
    Next I
    DLSName = TrimNull(DLSName)
    STDName = TrimNull(STDName)
    If oTZI.DaylightDate.wMonth = 0 Then
        Bias = oTZI.Bias - oTZI.StandardBias
        TimeZoneName = STDName
        GoTo SkipDST
    End If
    If DateDiff("s", Now, DLSDate) >= 0 Then
        If DateDiff("s", Now, STDDate) <= 0 Then
            TimeZoneName = DLSName
        Else
            TimeZoneName = STDName
        End If
    Else
        TimeZoneName = STDName
    End If
SkipDST:
    TimeZone = Trim$(Str$(-1 * (oTZI.Bias / 60)))
    If InStr(1, TimeZone, "-") = 0 Then TimeZone = "+" & TimeZone
    If InStr(1, TimeZone, ".") Then
        TimeZoneName = "[" & TimeZoneName & " (GMT " & Left$(TimeZone, InStr(1, TimeZone, ".") - 1) & ":" & Left$((Mid$(TimeZone, InStr(1, TimeZone, ".") + 1) * 60 / 10), 2) & ")]"
    Else
        TimeZoneName = "[" & TimeZoneName & " (GMT " & TimeZone & ":00" & ")]"
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "TimeZoneName"
    Resume Next
End Function
Public Function Translate(Conversion As String) As String
Dim ConversionType As String
Dim ConversionText As String
Dim Translation    As String
Dim Ans            As String
    On Error GoTo Erred
    ConversionType = Replace$(LCase$(Left$(Conversion, 5)), "-", "_")
    ConversionText = Replace$(Mid$(Conversion, 7), " ", "_")
    ConversionText = Replace$(ConversionText, "'", "`")
    frmMain.NewsClose
    DoEvents
    Translation = frmMain.itpNews.OpenURL("http://babelfish.altavista.com/babelfish/trurl_pagecontent?lp=" & ConversionType & "&url=realityripple.com/software/freeware/RCB/trans.php?q=" & ConversionText)
    DoEvents
    frmMain.NewsClose
    Ans = Mid$(Translation, InStr(1, Translation, vbLf) + 1)
    Ans = Left$(Ans, InStr(1, Ans, "<!-") - 1)
    Ans = Replace$(Ans, vbCr, "")
    Ans = Replace$(Ans, vbLf, " ")
    If InStr(1, Ans, "<html>") Then GoTo Erred
    Translate = Ans
    Exit Function
Erred:
    frmMain.NewsClose
    Translate = "Could Not Translate!"
End Function
Public Function TrimNull(Item As String)
Dim pos As Integer
    pos = InStr(Item, Chr$(0))
    If pos Then
        TrimNull = Left$(Item, pos - 1)
    Else
        TrimNull = Item
    End If
End Function
Public Function Version() As String
    On Error GoTo Erred
    If Len(Trim$(Str$(App.Revision))) > 2 Then
        If Mid$(Trim$(Str$(App.Revision)), 2, 1) = "0" Then
            Version = App.major & "." & App.minor & "." & Left$(App.Revision, 1) & " Beta " & Mid$(App.Revision, 3)
        Else
            Version = App.major & "." & App.minor & "." & Left$(App.Revision, 2) & " Beta " & Mid$(App.Revision, 3)
        End If
    Else
        Version = App.major & "." & App.minor & "." & App.Revision
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "Version"
    Resume Next
End Function
Public Function WindowEnumerator(ByVal app_hwnd As Long, ByVal lParam As Long) As Long
Dim buf    As String * 256
Dim Title  As String
Dim Length As Long
    On Error GoTo Erred
    Length = GetWindowTextA(app_hwnd, buf, Len(buf))
    Title = Left$(buf, Length)
    If InStr(Title, TargetName) > 0 Then
        TargetHwnd = app_hwnd
        WindowEnumerator = False
    Else
        WindowEnumerator = True
    End If
Exit Function
Erred:
    ErrorHandler "Functions", "WindowEnumerator"
    Resume Next
End Function
Public Sub WriteINI(ByVal wiSection As String, ByVal wiKey As String, ByVal wiValue As String, ByVal wiFile As String)
    On Error GoTo Erred
    WritePrivateProfileStringA wiSection, wiKey, wiValue, App.Path & "\" & wiFile
Exit Sub
Erred:
    If Err.Description = "File already open" Then
        MessageBox "Could not save the config file. It is currently in use.", Critical, OKOnly
    Else
        ErrorHandler "Functions", "WriteINI"
        Resume Next
    End If
End Sub
