Attribute VB_Name = "modKb"
Option Explicit
Private Const NoLoad   As String = "KbMedia Player not loaded."
Private RandomPly     As Boolean
Public Function KbClose() As String
    On Error GoTo Erred
    If lngKb = 0 Then
        KbClose = NoLoad
    Else
        PostMessageA lngKb, &H111, &HB, 0
        KbClose = "Kb Closed."
    End If
    Exit Function
Erred:
    ErrorHandler "Kb Control", "Close"
    Resume Next
End Function
Public Function KbFadeOutStop() As String
    On Error GoTo Erred
    If lngKb = 0 Then
        KbFadeOutStop = NoLoad
    Else
        PostMessageA lngKb, &H111, &H10, 0
        KbFadeOutStop = "Faded out."
    End If
    Exit Function
Erred:
    ErrorHandler "Kb Control", "FadeOutStop"
    Resume Next
End Function
Public Function KbJumpToFile(strFile As String) As String
    On Error GoTo Erred
    If lngKb = 0 Then
        KbJumpToFile = NoLoad
    Else
        KbJumpToFile = "Kb does not support this command."
    End If
    Exit Function
Erred:
    ErrorHandler "Kb Control", "JumpToFile"
    Resume Next
End Function
Public Function KbNext() As String
    On Error GoTo Erred
    If lngKb = 0 Then
        KbNext = NoLoad
    Else
        PostMessageA lngKb, &H111, &H12, 0
        KbNext = "Skipped forward."
    End If
    Exit Function
Erred:
    ErrorHandler "Kb Control", "Next"
    Resume Next
End Function
Public Function KbNoRandom() As String
    On Error GoTo Erred
    If lngKb = 0 Then
        KbNoRandom = NoLoad
    Else
        PostMessageA lngKb, &H111, &H1C, 0
        KbNoRandom = "Playing in Order."
    End If
    Exit Function
Erred:
    ErrorHandler "Kb Control", "NoRandom"
    Resume Next
End Function
Public Function KbPause() As String
    On Error GoTo Erred
    If lngKb = 0 Then
        KbPause = NoLoad
    Else
        PostMessageA lngKb, &H111, &HE, 0
        KbPause = "Paused."
    End If
    Exit Function
Erred:
    ErrorHandler "Kb Control", "Play"
    Resume Next
End Function
Public Function KbPlay() As String
    On Error GoTo Erred
    If lngKb = 0 Then
        KbPlay = NoLoad
    Else
        PostMessageA lngKb, &H111, &HD, 0
        KbPlay = "Playing."
    End If
    Exit Function
Erred:
    ErrorHandler "Kb Control", "Play"
    Resume Next
End Function
Public Function KbPrevious() As String
    On Error GoTo Erred
    If lngKb = 0 Then
        KbPrevious = NoLoad
    Else
        PostMessageA lngKb, &H111, &H13, 0
        KbPrevious = "Skipped back."
    End If
    Exit Function
Erred:
    ErrorHandler "Kb Control", "Previous"
    Resume Next
End Function
Public Function KbRandom() As String
    On Error GoTo Erred
    If RandomPly Then
        KbRandom = KbNoRandom
    Else
        KbRandom = KbYesRandom
    End If
    RandomPly = Not RandomPly
Exit Function
Erred:
    ErrorHandler "Kb Control", "Random"
    Resume Next
End Function
Public Function KbSetVolume(intIndex As Integer) As String
Dim lngVolWindow As Long
Dim NewVol       As Long
Dim I            As Integer
    On Error GoTo Erred
    If lngKb = 0 Then
        KbSetVolume = NoLoad
    Else
        lngVolWindow = FindWindowExA(lngKb, 0, "TTrackBar", vbNullString)
        NewVol = (100 - intIndex) + 11
        PostMessageA lngVolWindow, &H201, &H1, 720896 + 15
        For I = 0 To 20
            PostMessageA lngVolWindow, &H200, &H1, 720896 + 15
        Next I
        PostMessageA lngVolWindow, &H202, &H0, 720896 + 15
        If intIndex < 100 Then
            PostMessageA lngVolWindow, &H201, &H1, 720896 + 15
            For I = 10 To NewVol
                PostMessageA lngVolWindow, &H200, &H1, I * 65536 + 15
            Next I
            PostMessageA lngVolWindow, &H202, &H0, NewVol * 65536 + 15
        End If
        KbSetVolume = "Volume set to " & intIndex & "."
    End If
    Exit Function
Erred:
    ErrorHandler "Kb Control", "Volume"
    Resume Next
End Function
Public Function KbStop() As String
    On Error GoTo Erred
    If lngKb = 0 Then
        KbStop = NoLoad
    Else
        PostMessageA lngKb, &H111, &HF, 0
        KbStop = "Stopped."
    End If
    Exit Function
Erred:
    ErrorHandler "Kb Control", "Stop"
    Resume Next
End Function
Public Function KbToggleRepeat() As String
    On Error GoTo Erred
    If lngKb = 0 Then
        KbToggleRepeat = NoLoad
    Else
        PostMessageA lngKb, &H111, &H17, 0
        KbToggleRepeat = "Repeat toggled."
    End If
    Exit Function
Erred:
    ErrorHandler "Kb Control", "Repeat"
    Resume Next
End Function
Public Function KbYesRandom() As String
    On Error GoTo Erred
    If lngKb = 0 Then
        KbYesRandom = NoLoad
    Else
        PostMessageA lngKb, &H111, &H1D, 0
        KbYesRandom = "Playing Randomly."
    End If
    Exit Function
Erred:
    ErrorHandler "Kb Control", "Random"
    Resume Next
End Function
Public Function lngKb() As Long
    On Error GoTo Erred
    lngKb = FindWindowA("TFrmMIDI", vbNullString)
Exit Function
Erred:
    ErrorHandler "Kb Control", "lngKb"
    Resume Next
End Function
Public Function strGetText(lngHwnd As Long) As String
Dim ilngLength As Long
Dim strBuffer  As String
    On Error GoTo Erred
    ilngLength = SendMessageA(lngHwnd, &HE, 0, ByVal 0&)
    strBuffer = String$(ilngLength, 0)
    SendMessageA lngHwnd, &HD, ilngLength + 1, ByVal strBuffer
    strGetText = strBuffer
Exit Function
Erred:
    ErrorHandler "Kb Control", "GetText"
    Resume Next
End Function
Public Function strKbTitle() As String
Dim strCaption As String
    On Error GoTo Erred
    If lngKb = 0 Then
        strKbTitle = NoLoad
    Else
        strCaption = strGetText(lngKb)
        strCaption = Replace$(strCaption, "[", vbNullString)
        strCaption = Replace$(strCaption, "]", vbNullString)
        If InStrRev(strCaption, " - Kb") > 0 Then
            strCaption = Trim$(Left$(strCaption, InStrRev(strCaption, " - Kb")))
        ElseIf strCaption = " - KbMedia Player - " Then
            strCaption = "Nothing"
        End If
        If Mid$(strCaption, Len(strCaption) - 4, 1) = "." Then strCaption = Left$(strCaption, Len(strCaption) - 5)
        If Mid$(strCaption, Len(strCaption) - 3, 1) = "." Then strCaption = Left$(strCaption, Len(strCaption) - 4)
        If Mid$(strCaption, Len(strCaption) - 2, 1) = "." Then strCaption = Left$(strCaption, Len(strCaption) - 3)
        strKbTitle = strCaption
    End If
    Exit Function
Erred:
    ErrorHandler "Kb Control", "KbTitle"
    Resume Next
End Function
