VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Region"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Public hndRegion As Long
Private DIB As New cDIBSection
Private Declare Function timeGetTime Lib "winmm.dll" () As Long
Private Declare Function OffsetRgn Lib "gdi32" (ByVal hRgn As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Sub Class_Terminate()
    If hndRegion <> 0 Then Call DeleteObject(hndRegion)
End Sub
Public Sub ApplyRgn(ByVal hWnd As Long)
    Dim hndRegionCopy As Long
    hndRegionCopy = CreateRectRgn(0, 0, 0, 0)
    Call CombineRgn(hndRegionCopy, hndRegion, hndRegionCopy, RGN_OR)
    Call SetWindowRgn(hWnd, hndRegionCopy, True)
End Sub
Public Sub ScanPicture(ByVal Picture As StdPicture, Optional transColor As Long = vbNull)
    Dim Rgn2 As Long
    hndRegion = CreateRectRgn(0, 0, 0, 0)
    Dim X As Long, Y As Long
    Dim SPos As Long, EPos As Long
    Dim Wid As Long, Hgt As Long
    Dim bDib() As Byte
    Dim tSA As SAFEARRAY2D
    Call DIB.CreateFromPicture(Picture)
    Wid = DIB.Width
    Hgt = DIB.Height
    With tSA
        .cbElements = 1
        .cDims = 2
        .Bounds(0).lLbound = 0
        .Bounds(0).cElements = DIB.Height
        .Bounds(1).lLbound = 0
        .Bounds(1).cElements = DIB.BytesPerScanLine
        .pvData = DIB.DIBSectionBitsPtr
    End With
    Call CopyMemory(ByVal VarPtrArray(bDib), VarPtr(tSA), 4)
    If transColor = vbNull Then transColor = RGB(bDib(0, 0), bDib(1, 0), bDib(2, 0))
    For Y = 0 To DIB.Height - 1
        X = -3
        Do
            Rgn2 = 0
            X = X + 3
            While RGB(bDib(X, Y), bDib(X + 1, Y), bDib(X + 2, Y)) = transColor And (X < DIB.Width * 3 - 3)
                X = X + 3
            Wend
            SPos = X / 3
            While RGB(bDib(X, Y), bDib(X + 1, Y), bDib(X + 2, Y)) <> transColor And (X < DIB.Width * 3 - 3)
                X = X + 3
            Wend
            EPos = X / 3
            If SPos <= EPos Then
                Rgn2 = CreateRectRgn(SPos, DIB.Height - Y, EPos, DIB.Height - 1 - Y)
                Call CombineRgn(hndRegion, hndRegion, Rgn2, RGN_OR)
                Call DeleteObject(Rgn2)
            End If
        Loop Until X >= DIB.Width * 3 - 3
    Next Y
    Call CopyMemory(ByVal VarPtrArray(bDib), 0&, 4)
End Sub
Public Sub OffsetHeader(ByRef tmpForm As Form)
    With tmpForm
        If .BorderStyle <> 0 Then
            Dim xoff As Long, yoff As Long
            .ScaleMode = vbPixels
            xoff = (.ScaleX(.Width, vbTwips, vbPixels) - .ScaleWidth) / 2
            yoff = .ScaleY(.Height, vbTwips, vbPixels) - .ScaleHeight - xoff
            Call OffsetRgn(hndRegion, xoff, yoff)
        End If
    End With
End Sub
