VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPacket"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Inbound      As String
Private Outbound     As String
Private CFm_lngPosition   As Long
Public Sub ClearOutbound()
    On Error GoTo Erred
    Outbound = vbNullString
Exit Sub
Erred:
    ErrorHandler "Packet", "ClearOutbound"
    Resume Next
End Sub
Public Function CreateDWORD(ByVal Value As Long) As String
Dim Result As String * 4
    On Error GoTo Erred
    RtlMoveMemory ByVal Result, Value, 4
    CreateDWORD = Result
Exit Function
Erred:
    ErrorHandler "Packet", "CreateDWORD"
    Resume Next
End Function
Public Function CreateWORD(ByVal Value As Integer) As String
Dim Result As String * 2
    On Error GoTo Erred
    RtlMoveMemory ByVal Result, Value, 2
    CreateWORD = Result
Exit Function
Erred:
    ErrorHandler "Packet", "CreateWORD"
    Resume Next
End Function
Public Function GetByte() As Byte
    On Error GoTo Erred
    If Len(Inbound) >= CFm_lngPosition Then
        GetByte = Asc(Mid$(Inbound, CFm_lngPosition, 1))
        CFm_lngPosition = CFm_lngPosition + 1
    End If
Exit Function
Erred:
    ErrorHandler "Packet", "GetByte"
    Resume Next
End Function
Public Function GetData() As String
    On Error GoTo Erred
    GetData = Inbound
Exit Function
Erred:
    ErrorHandler "Packet", "GetData"
    Resume Next
End Function
Public Function GetNull() As String
    On Error GoTo Erred
    GetNull = Mid$(Inbound, CFm_lngPosition)
Exit Function
Erred:
    ErrorHandler "Packet", "GetNull"
    Resume Next
End Function
Public Function GetDWORD() As Long
Dim rVal As Long
    On Error GoTo Erred
    If Len(Inbound) - CFm_lngPosition + 1 >= 4 Then
        RtlMoveMemory rVal, ByVal Mid$(Inbound, CFm_lngPosition, 4), 4
        CFm_lngPosition = CFm_lngPosition + 4
        GetDWORD = rVal
    End If
Exit Function
Erred:
    ErrorHandler "Packet", "GetDWORD"
    Resume Next
End Function
Public Function GetNTString() As String
Dim rVal As String
    On Error GoTo Erred
    If InStr(Inbound, vbNullChar) > 0 Then
        If Len(Inbound) > 0 Then
            If Len(Mid$(Inbound, CFm_lngPosition)) > 0 Then
                rVal = KillNull(Mid$(Inbound, CFm_lngPosition))
                CFm_lngPosition = CFm_lngPosition + Len(rVal) + 1
                GetNTString = rVal
            End If
        End If
    End If
Exit Function
Erred:
    ErrorHandler "Packet", "GetNTString"
    Resume Next
End Function
Public Function GetString(ByVal lngLength As Long) As String
Dim rVal As String
    On Error GoTo Erred
    If Len(Inbound) > 0 Then
        rVal = Mid$(Inbound, CFm_lngPosition, lngLength)
        CFm_lngPosition = CFm_lngPosition + Len(rVal)
        GetString = rVal
    End If
Exit Function
Erred:
    ErrorHandler "Packet", "GetString"
    Resume Next
End Function
Public Function GetWORD() As Long
Dim rVal As Long
    On Error GoTo Erred
    If Len(Inbound) - CFm_lngPosition + 1 >= 2 Then
        RtlMoveMemory rVal, ByVal Mid$(Inbound, CFm_lngPosition, 2), 2
        CFm_lngPosition = CFm_lngPosition + 2
        GetWORD = rVal
    End If
Exit Function
Erred:
    ErrorHandler "Packet", "GetWORD"
    Resume Next
End Function
Public Sub InsertByte(ByVal Data As Byte)
    On Error GoTo Erred
    Outbound = Outbound & Chr$(Data)
Exit Sub
Erred:
    ErrorHandler "Packet", "InsertByte"
    Resume Next
End Sub
Public Sub InsertDWORD(ByVal Data As Long)
    On Error GoTo Erred
    Outbound = Outbound & CreateDWORD(Data)
Exit Sub
Erred:
    ErrorHandler "Packet", "InsertDWORD"
    Resume Next
End Sub
Public Sub InsertNTString(ByVal Data As String)
    On Error GoTo Erred
    Outbound = Outbound & Data & vbNullChar
Exit Sub
Erred:
    ErrorHandler "Packet", "InsertNTString"
    Resume Next
End Sub
Public Sub InsertString(ByVal Data As String)
    On Error GoTo Erred
    Outbound = Outbound & Data
Exit Sub
Erred:
    ErrorHandler "Packet", "InsertString"
    Resume Next
End Sub
Public Sub InsertWORD(ByVal Data As Integer)
    On Error GoTo Erred
    Outbound = Outbound & CreateWORD(Data)
Exit Sub
Erred:
    ErrorHandler "Packet", "InsertWORD"
    Resume Next
End Sub
Public Property Get lngPosition() As Long
    lngPosition = CFm_lngPosition
End Property
Public Property Let lngPosition(ByVal PropVal As Long)
    CFm_lngPosition = PropVal
End Property
Public Function PeekByte() As Byte
    On Error GoTo Erred
    If Len(Inbound) >= CFm_lngPosition Then PeekByte = Asc(Mid$(Inbound, CFm_lngPosition, 1))
Exit Function
Erred:
    ErrorHandler "Packet", "PeekByte"
    Resume Next
End Function
Public Function PeekDWORD() As Long
Dim rVal As Long
    On Error GoTo Erred
    If Len(Inbound) - CFm_lngPosition + 1 >= 4 Then
        RtlMoveMemory rVal, ByVal Mid$(Inbound, CFm_lngPosition, 4), 4
        PeekDWORD = rVal
    End If
Exit Function
Erred:
    ErrorHandler "Packet", "PeekDWORD"
    Resume Next
End Function
Public Function PeekNTString() As String
Dim rVal As String
    On Error GoTo Erred
    If InStr(Inbound, vbNullChar) > 0 Then
        If Len(Inbound) > 0 Then
            If Len(Mid$(Inbound, CFm_lngPosition)) > 0 Then
                rVal = KillNull(Mid$(Inbound, CFm_lngPosition))
                PeekNTString = rVal
            End If
        End If
    End If
Exit Function
Erred:
    ErrorHandler "Packet", "PeekNTString"
    Resume Next
End Function
Public Function PeekPacket() As String
    On Error GoTo Erred
    If Len(Inbound) > 0 Then PeekPacket = Inbound
Exit Function
Erred:
    ErrorHandler "Packet", "PeekPacket"
    Resume Next
End Function
Public Function PeekString(ByVal lngLength As Long) As String
Dim rVal As String
    On Error GoTo Erred
    If Len(Inbound) > 0 Then
        rVal = Mid$(Inbound, CFm_lngPosition, lngLength)
        PeekString = rVal
    End If
Exit Function
Erred:
    ErrorHandler "Packet", "PeekString"
    Resume Next
End Function
Public Function PeekWORD() As Long
Dim rVal As Long
    On Error GoTo Erred
    If Len(Inbound) - CFm_lngPosition + 1 >= 2 Then
        RtlMoveMemory rVal, ByVal Mid$(Inbound, CFm_lngPosition, 2), 2
        PeekWORD = rVal
    End If
Exit Function
Erred:
    ErrorHandler "Packet", "PeekWORD"
    Resume Next
End Function
Public Sub SendBNLSPacket(ByVal PacketID As Byte, ByRef Socket As Winsock)
    On Error GoTo Erred
    If Socket.State <> 7 Then Exit Sub
    Outbound = CreateWORD(Len(Outbound) + 3) & Chr$(PacketID) & Outbound
    If Socket.State = 7 Then Socket.SendData Outbound
    Outbound = vbNullString
Exit Sub
Erred:
    ErrorHandler "Packet", "SendBNLSPacket"
    Resume Next
End Sub
Public Sub SendFTPPacket(ByRef Socket As Winsock)
    On Error GoTo Erred
    If Socket.State <> 7 Then Exit Sub
    Outbound = CreateWORD(Len(Outbound) + 2) & Outbound
    If Socket.State = 7 Then Socket.SendData Outbound
    Outbound = vbNullString
Exit Sub
Erred:
    ErrorHandler "Packet", "SendFTPPacket"
    Resume Next
End Sub
Public Sub SendMCPPacket(ByVal PacketID As Byte, ByRef Socket As Winsock)
    On Error GoTo Erred
    If Socket.State <> 7 Then Exit Sub
    frmMain.Verbose ("SEND " & IDMCP(PacketID))
    Outbound = CreateWORD(Len(Outbound) + 3) & Chr$(PacketID) & Outbound
    If Socket.State = 7 Then Socket.SendData Outbound
    Outbound = vbNullString
Exit Sub
Erred:
    ErrorHandler "Packet", "SendMCPPacket"
    Resume Next
End Sub
Public Sub SendPacket(ByVal PacketID As Byte, ByRef Socket As Winsock, ByVal QueueEnabled As Boolean)
    On Error GoTo Erred
    If Socket.State <> 7 Then Exit Sub
    If PacketID <> 0 Then frmMain.Verbose ("SEND " & IDSID(PacketID))
    Outbound = Chr$(&HFF) & Chr$(PacketID) & CreateWORD(Len(Outbound) + 4) & Outbound
    If QueueEnabled Then
        frmMain.BNet.AddQueue PacketID, Outbound
    Else
        If Socket.State = 7 Then Socket.SendData Outbound
    End If
    Outbound = vbNullString
Exit Sub
Erred:
    ErrorHandler "Packet", "SendPacket [" & Hex$(PacketID) & " - " & Outbound & "]"
    Resume Next
End Sub
Public Sub SetData(ByVal strValue As String)
    On Error GoTo Erred
    Inbound = strValue
    CFm_lngPosition = 1
Exit Sub
Erred:
    ErrorHandler "Packet", "SetData"
    Resume Next
End Sub
Public Sub SetPos(ByVal intPosition As Integer)
    On Error GoTo Erred
    CFm_lngPosition = intPosition
Exit Sub
Erred:
    ErrorHandler "Packet", "SetPos"
    Resume Next
End Sub
Public Sub Skip(ByVal intBytes As Integer)
    On Error GoTo Erred
    CFm_lngPosition = CFm_lngPosition + intBytes
Exit Sub
Erred:
    ErrorHandler "Packet", "Skip"
    Resume Next
End Sub
Public Sub SkipNTString()
Dim rVal As String
    On Error GoTo Erred
    If InStr(Inbound, vbNullChar) > 0 Then
        If Len(Inbound) > 0 Then
            If Len(Mid$(Inbound, CFm_lngPosition)) > 0 Then
                rVal = KillNull(Mid$(Inbound, CFm_lngPosition))
                CFm_lngPosition = CFm_lngPosition + Len(rVal) + 1
            End If
        End If
    End If
Exit Sub
Erred:
    ErrorHandler "Packet", "SkipNTString"
    Resume Next
End Sub
