VERSION 5.00
Begin VB.Form frmReport 
   BackColor       =   &H00000000&
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Report Error"
   ClientHeight    =   3600
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   6450
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3600
   ScaleWidth      =   6450
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdReport 
      Caption         =   "Report"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4560
      TabIndex        =   3
      Top             =   3120
      Width           =   855
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5520
      TabIndex        =   2
      Top             =   3120
      Width           =   855
   End
   Begin VB.TextBox txtDetails 
      BackColor       =   &H00000000&
      ForeColor       =   &H00FFFFFF&
      Height          =   2535
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   480
      Width           =   6255
   End
   Begin VB.Label lblNote 
      BackColor       =   &H00000000&
      BackStyle       =   0  'Transparent
      Caption         =   "NOTE: Error information is automatically sent with the report. Please do not paste Error details into this area."
      ForeColor       =   &H00FFFFFF&
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   3120
      Width           =   3975
   End
   Begin VB.Label lblDetails 
      BackColor       =   &H00FFFFFF&
      BackStyle       =   0  'Transparent
      Caption         =   "Please enter any details on what you were doing before the error occured (Optional):"
      ForeColor       =   &H00FFFFFF&
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6255
   End
End
Attribute VB_Name = "frmReport"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public ErrNo As Integer
Public ErrDesc As String
Public Cause As String
Public Sub ApplySkin()
    OnTop Me, True
End Sub
Private Sub cmdCancel_Click()
    Unload Me
End Sub
Private Sub cmdReport_Click()
Dim URL As String
Dim Note As String
    On Error GoTo Erred
    Me.Caption = "Reporting... Please wait"
    Me.Enabled = False
    URL = WEBURL & "RD/err/report.php"
    If LenB(strCurrentUsername) > 0 Then
        URL = URL & "?u=" & strCurrentUsername
    ElseIf LenB(Profile) > 0 Then
        URL = URL & "?u=" & ReadINI("Main", "Username", "Unknown", "Profiles\" & Profile & "\config.ini")
    Else
        URL = URL & "?u=Unknown"
    End If
    URL = URL & "&e=" & ErrNo
    URL = URL & "&er=" & ErrDesc
    URL = URL & "&c=" & Cause
    If LenB(txtDetails.Text) > 0 Then
        Note = Replace$(txtDetails.Text, vbCrLf, vbLf)
        Note = Replace$(Note, vbCr, vbLf)
        Note = Replace$(Note, vbLf, "[nl]")
        URL = URL & "&n=" & Note
    End If
    frmMain.NewsClose
    On Error GoTo TimeOut
    frmMain.itpNews.OpenURL URL
    On Error GoTo Erred
    frmMain.NewsClose
    Unload Me
Exit Sub
Erred:
    Me.Caption = "Report errored"
    MessageBox "Could not send error report!", Critical
    Unload Me
Exit Sub
TimeOut:
    Me.Caption = "Report timed out"
    MessageBox "Could not connect to Error server!", Critical
    Unload Me
End Sub
Private Sub Form_Load()
    ApplySkin
End Sub
