VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmWhisper 
   Caption         =   "Whisper Window"
   ClientHeight    =   2775
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   6135
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmWhisper.frx":0000
   LinkTopic       =   "Whisper"
   ScaleHeight     =   185
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   409
   Begin VB.Timer tmrOnline 
      Interval        =   100
      Left            =   0
      Top             =   0
   End
   Begin VB.TextBox txtSend 
      BackColor       =   &H00000000&
      ForeColor       =   &H00FFFFFF&
      Height          =   255
      Left            =   0
      MaxLength       =   32000
      MousePointer    =   3  'I-Beam
      MultiLine       =   -1  'True
      TabIndex        =   0
      ToolTipText     =   "Message to send."
      Top             =   2520
      Width           =   5055
   End
   Begin VB.CommandButton cmdSend 
      Caption         =   "&Send"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   5160
      Style           =   1  'Graphical
      TabIndex        =   1
      ToolTipText     =   "Send."
      Top             =   2520
      Width           =   975
   End
   Begin RichTextLib.RichTextBox rtbWhis 
      Height          =   2415
      Left            =   0
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   0
      Width           =   6135
      _ExtentX        =   10821
      _ExtentY        =   4260
      _Version        =   393217
      BackColor       =   0
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      MousePointer    =   1
      TextRTF         =   $"frmWhisper.frx":014A
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Arial"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Image imgVert 
      Appearance      =   0  'Flat
      Height          =   75
      Left            =   0
      MousePointer    =   7  'Size N S
      Top             =   2400
      Width           =   6000
   End
   Begin VB.Image imgSendSize 
      Appearance      =   0  'Flat
      Height          =   255
      Left            =   5040
      MousePointer    =   9  'Size W E
      Stretch         =   -1  'True
      Top             =   2520
      Width           =   75
   End
End
Attribute VB_Name = "frmWhisper"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Implements ISubclass
Private m_emr            As EMsgResponse
Private CFm_WhisperTo    As String
Private Selecting        As Boolean
Private HyperLink        As clsHyperlink
Private ResizeSend       As Boolean
Private ResizeSendDist   As Single
Private ResizeVert       As Boolean
Private ResizeVertDist   As Single
Public Sub ApplySkin()
Dim UnZip As New clsUnzip
Dim I     As Integer
Dim TmpDr As String
    On Error GoTo Erred
    Screen.MousePointer = 13
    TmpDr = TempDir
    If ReadINI("Main", "OnTop", "N", "Profiles\" & Profile & "\config.ini") = "Y" Then
        OnTop Me, True
    Else
        OnTop Me, False
    End If
    If LenB(SkinName) > 0 Then
        If LenB(Dir$(TmpDr, vbDirectory)) > 0 Then DeleteFolder TmpDr
        If LenB(Dir$(TmpDr, vbDirectory)) = 0 Then MkDir TmpDr
        UnZip.UnzipFolder = TmpDr
        UnZip.OverwriteExisting = True
        UnZip.UseFolderNames = True
        UnZip.ZipFile = App.Path & "\Skins\" & SkinName & ".rrz"
        UnZip.Directory
        For I = 1 To UnZip.FileCount
            If LCase$(UnZip.FileDirectory(I)) = "main" Then
                UnZip.FileSelected(I) = True
            Else
                UnZip.FileSelected(I) = False
            End If
        Next I
        UnZip.UnZip
    End If
    If LenB(SkinName) > 0 And LenB(Dir$(TmpDr, vbDirectory)) > 0 Then
        cmdSend.Picture = LoadPicture(TmpDr & "Main\Send.bmp")
        cmdSend.Caption = vbNullString
    Else
        cmdSend.Picture = Nothing
        cmdSend.Caption = "&Send"
    End If
    rtbWhis.BackColor = MainApp.ChatBox.BackColor
    txtSend.BackColor = MainApp.SendBox.BackColor
    txtSend.Font.Name = MainApp.SendBox.Font
    txtSend.Font.Size = MainApp.SendBox.Size
    txtSend.ForeColor = MainApp.SendBox.Color
    If LenB(Dir$(TmpDr, vbDirectory)) > 0 Then DeleteFolder TmpDr
    Screen.MousePointer = 0
Exit Sub
Erred:
    If LenB(SkinName) > 0 Then
        MessageBox "The skin """ & SkinName & """ is corrupted. Please download it again!", Critical, OKOnly, "Corrupt Skin!"
        SkinName = vbNullString
        ApplySkin
    Else
        ErrorHandler "Whisper", "Skinning"
        Resume Next
    End If
End Sub
Private Sub cmdSend_Click()
Dim strSend    As String
Dim strSends() As String
Dim J          As Integer
    On Error GoTo Erred
    Screen.MousePointer = 13
    If LenB(txtSend.Text) > 0 Then
        strSend = txtSend
        txtSend.Text = vbNullString
        strSend = Replace$(strSend, vbTab, "    ")
        strSend = Replace$(strSend, vbLf, vbNullString)
        strSends = Split(strSend, vbCr)
        For J = 0 To UBound(strSends)
            strSend = strSends(J)
            If LenB(strSend) > 0 Then
                If frmMain.DII Then
                    frmMain.Display "/w *" & CFm_WhisperTo & " " & strSend
                Else
                    frmMain.Display "/w " & CFm_WhisperTo & " " & strSend
                End If
            End If
        Next J
    Else
        Beep
    End If
    If HasFocus(Me) Then txtSend.SetFocus
    Screen.MousePointer = 0
Exit Sub
Erred:
    ErrorHandler "Whisper", "Send"
    Resume Next
End Sub
Private Sub Form_Activate()
    On Error GoTo Erred
    If Me.Visible Then Me.SetFocus
Exit Sub
Erred:
    ErrorHandler "Whisper", "Activate"
    Resume Next
End Sub
Private Sub Form_Load()
Dim strConfig As String
    On Error GoTo Erred
    Screen.MousePointer = 13
    AttachMessage Me, Me.hwnd, WM_GETMINMAXINFO
    ApplySkin
    strConfig = "Profiles\" & Profile & "\config.ini"
    Me.Move ReadINI("Whisper", "Left", Screen.Width / 2 - Me.Width / 2, strConfig), ReadINI("Whisper", "Top", Screen.Height / 2 - Me.Height / 2, strConfig), ReadINI("Whisper", "Width", 6255, strConfig), ReadINI("Whisper", "Height", 3495, strConfig)
    If Me.Top < 0 Then Me.Top = 0
    If Me.Top > Screen.Height - Me.Height Then Me.Top = Screen.Height - Me.Height
    If Me.Left < 0 Then Me.Left = 0
    If Me.Left > Screen.Width - Me.Width Then Me.Left = Screen.Width - Me.Width
    txtSend.Height = txtSend.Font.Size * 3 / 2 + 5
    ResizeSendDist = ReadINI("Whisper", "SendButton", 60, strConfig)
    ResizeVertDist = ReadINI("Whisper", "SendBox", 29, strConfig)
    Form_Resize
    Set HyperLink = New clsHyperlink
    Screen.MousePointer = 0
Exit Sub
Erred:
    ErrorHandler "Whisper", "Load"
    Resume Next
End Sub
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
Dim strConfig As String
    On Error GoTo Erred
    Screen.MousePointer = 13
    DetachMessage Me, Me.hwnd, WM_GETMINMAXINFO
    strConfig = "Profiles\" & Profile & "\config.ini"
    If Me.WindowState = vbNormal Then
        WriteINI "Whisper", "Top", Me.Top, strConfig
        WriteINI "Whisper", "Left", Me.Left, strConfig
        WriteINI "Whisper", "Height", Me.Height, strConfig
        WriteINI "Whisper", "Width", Me.Width, strConfig
    End If
    WriteINI "Whisper", "SendButton", Trim$(Str$(ResizeSendDist)), strConfig
    WriteINI "Whisper", "SendBox", Trim$(Str$(ResizeVertDist)), strConfig
    If HasFocus(frmMain) Then frmMain.txtSend.SetFocus
    Set HyperLink = Nothing
    CFm_WhisperTo = vbNullString
    Screen.MousePointer = 0
Exit Sub
Erred:
    ErrorHandler "Whisper", "QueryUnload"
    Resume Next
End Sub
Private Sub Form_Resize()
    On Error GoTo Erred
    If Me.WindowState <> 1 Then
        rtbWhis.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight - ResizeVertDist
        If ResizeVertDist < 5 Then ResizeVertDist = 5
        txtSend.Move 0, Me.ScaleHeight - ResizeVertDist + 5, imgSendSize.Left, ResizeVertDist - 5
        imgVert.Move 0, Me.ScaleHeight - ResizeVertDist, Me.ScaleWidth, 5
        cmdSend.Move Me.ScaleWidth - ResizeSendDist, txtSend.Top, ResizeSendDist, txtSend.Height
        imgSendSize.Move cmdSend.Left - 5, cmdSend.Top, 5, cmdSend.Height
        cmdSend.Visible = Not (cmdSend.Width <= 0)
    End If
Exit Sub
Erred:
    ErrorHandler "Whisper", "Resize"
    Resume Next
End Sub
Private Sub imgSendSize_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    On Error GoTo Erred
    If Button = 1 Then ResizeSend = True
Exit Sub
Erred:
    ErrorHandler "Whisper", "SendSize MouseDown"
    Resume Next
End Sub
Private Sub imgSendSize_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    On Error GoTo Erred
    If ResizeSend Then
        imgSendSize.Left = imgSendSize.Left + x / 15
        If imgSendSize.Left > Me.ScaleWidth - 5 Then imgSendSize.Left = Me.ScaleWidth - 5
        If imgSendSize.Left < Me.ScaleWidth - 68 Then imgSendSize.Left = Me.ScaleWidth - 68
        ResizeSendDist = Me.ScaleWidth - imgSendSize.Left - 5
        Form_Resize
    End If
Exit Sub
Erred:
    ErrorHandler "Whisper", "SendSize MouseMove"
    Resume Next
End Sub
Private Sub imgSendSize_MouseUp(Button As Integer, Shift As Integer, x As Single, Y As Single)
    On Error GoTo Erred
    ResizeSend = False
    ResizeSendDist = Me.ScaleWidth - imgSendSize.Left - 5
    Form_Resize
Exit Sub
Erred:
    ErrorHandler "Whisper", "SendSize MouseUp"
    Resume Next
End Sub
Private Sub imgVert_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    On Error GoTo Erred
    If Button = 1 Then ResizeVert = True
Exit Sub
Erred:
    ErrorHandler "Whisper", "VertSize MouseDown"
    Resume Next
End Sub
Private Sub imgVert_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    On Error GoTo Erred
    If ResizeVert Then
        imgVert.Top = imgVert.Top + Y / 15
        If imgVert.Top > Me.ScaleHeight - 29 Then imgVert.Top = Me.ScaleHeight - 29
        If imgVert.Top < Me.ScaleHeight - 74 Then imgVert.Top = Me.ScaleHeight - 74
        ResizeVertDist = Me.ScaleHeight - imgVert.Top
        Form_Resize
    End If
Exit Sub
Erred:
    ErrorHandler "Whisper", "VertSize MouseMove"
    Resume Next
End Sub
Private Sub imgVert_MouseUp(Button As Integer, Shift As Integer, x As Single, Y As Single)
    On Error GoTo Erred
    ResizeVert = False
    ResizeVertDist = Me.ScaleHeight - imgVert.Top
    Form_Resize
Exit Sub
Erred:
    ErrorHandler "Whisper", "VertSize MouseUp"
    Resume Next
End Sub
Private Property Let ISubclass_MsgResponse(ByVal RHS As SSubTimer6.EMsgResponse)
    m_emr = RHS
End Property
Private Property Get ISubclass_MsgResponse() As SSubTimer6.EMsgResponse
    m_emr = emrConsume
    ISubclass_MsgResponse = m_emr
End Property
Private Function ISubclass_WindowProc(ByVal hwnd As Long, ByVal iMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    If iMsg = WM_GETMINMAXINFO Then
        Dim mmiT As MINMAXINFO
        RtlMoveMemory mmiT, ByVal lParam, LenB(mmiT)
        mmiT.ptMinTrackSize.x = 2000 / Screen.TwipsPerPixelX
        mmiT.ptMinTrackSize.Y = 1200 / Screen.TwipsPerPixelY
        RtlMoveMemory ByVal lParam, mmiT, LenB(mmiT)
    End If
End Function
Private Sub rtbWhis_GotFocus()
    On Error GoTo Erred
    If Not Selecting Then If HasFocus(Me) Then txtSend.SetFocus
Exit Sub
Erred:
    ErrorHandler "Whisper", "Whis GotFocus"
    Resume Next
End Sub
Private Sub rtbWhis_KeyPress(KeyAscii As Integer)
    On Error GoTo Erred
    If HasFocus(Me) Then
        If KeyAscii <> 3 Then
            txtSend.SetFocus
            txtSend.SelStart = Len(txtSend)
            txtSend.SelLength = 0
            SendKeys ChrW$(KeyAscii)
        End If
    End If
    KeyAscii = 0
Exit Sub
Erred:
    ErrorHandler "Whisper", "rtbWhis KeyPress"
    Resume Next
End Sub
Private Sub rtbWhis_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    On Error GoTo Erred
    If Button = vbLeftButton Then HyperLink.HitTest x \ Screen.TwipsPerPixelX, Y \ Screen.TwipsPerPixelY, rtbWhis, MouseDown, rtfArrow
    Selecting = True
Exit Sub
Erred:
    ErrorHandler "Whisper", "rtbWhis MouseDown"
    Resume Next
End Sub
Private Sub rtbWhis_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    On Error GoTo Erred
    HyperLink.HitTest x \ Screen.TwipsPerPixelX, Y \ Screen.TwipsPerPixelY, rtbWhis, MouseMove, rtfArrow
Exit Sub
Erred:
    ErrorHandler "Whisper", "rtbWhis MouseDown"
    Resume Next
End Sub
Private Sub rtbWhis_MouseUp(Button As Integer, Shift As Integer, x As Single, Y As Single)
Dim CopyText As String
    On Error GoTo Erred
    If Button = vbLeftButton Then HyperLink.HitTest x \ Screen.TwipsPerPixelX, Y \ Screen.TwipsPerPixelY, rtbWhis, MouseUp, rtfArrow
    If Selecting Then
        Selecting = False
        If LenB(rtbWhis.SelText) > 0 Then
            frmMain.rtbTemp.TextRTF = vbNullString
            frmMain.rtbTemp.SelRTF = RemoveSmileys(rtbWhis.SelRTF)
            If InStr(1, frmMain.rtbTemp.Text, "{\rtf1\") > 0 Then
                CopyText = Left$(frmMain.rtbTemp.Text, InStr(1, frmMain.rtbTemp.Text, "{\rtf1\") - 1)
            Else
                CopyText = frmMain.rtbTemp.Text
            End If
            CopyText = Replace$(CopyText, vbLf, vbNullString)
            CopyText = Replace$(CopyText, vbCr, vbNewLine)
            Clipboard.Clear
            Clipboard.SetText CopyText
        End If
    End If
    If HasFocus(Me) Then txtSend.SetFocus
Exit Sub
Erred:
    ErrorHandler "Whisper", "rtbWhis MouseUp"
    Resume Next
End Sub
Public Sub ShowTitle()
    On Error GoTo Erred
    Me.Caption = "Whispering with " & CFm_WhisperTo
Exit Sub
Erred:
    ErrorHandler "Whisper", "ShowTitile"
    Resume Next
End Sub
Private Sub tmrOnline_Timer()
    If Not frmMain.BNet.IsOnline Then Unload Me
End Sub
Private Sub txtSend_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo Erred
    If KeyCode = 13 And Shift = 0 Then
        cmdSend_Click
        KeyCode = 0
        Shift = 0
    ElseIf KeyCode = vbKeyB And Shift = 2 Then
        txtSend.SelLength = 0
        txtSend.SelText = "cb"
    ElseIf KeyCode = vbKeyI And Shift = 2 Then
        txtSend.SelLength = 0
        txtSend.SelText = "ci"
    ElseIf KeyCode = vbKeyS And Shift = 2 Then
        txtSend.SelLength = 0
        txtSend.SelText = "cs"
    ElseIf KeyCode = vbKeyU And Shift = 2 Then
        txtSend.SelLength = 0
        txtSend.SelText = "cu"
    ElseIf KeyCode = vbKeyF7 And Shift = 2 Then
        SpellCheck txtSend
        KeyCode = 0
    End If
Exit Sub
Erred:
    ErrorHandler "Whisper", "txtSend KeyDown"
    Resume Next
End Sub
Private Sub txtSend_KeyPress(KeyAscii As Integer)
    On Error GoTo Erred
    If (KeyAscii < 32 And KeyAscii <> vbKeyBack And KeyAscii <> 22 And KeyAscii <> 3 And KeyAscii <> 24 And KeyAscii <> 10) Or (KeyAscii = 13 Or KeyAscii = 9 Or KeyAscii = 12 Or KeyAscii = 13 Or KeyAscii = 6 Or KeyAscii = 7 Or KeyAscii = 19 Or KeyAscii = 14 Or KeyAscii = 11 Or KeyAscii = 4 Or KeyAscii = 18 Or KeyAscii = 17 Or KeyAscii = 5 Or KeyAscii = 6 Or KeyAscii = 16 Or KeyAscii = 15 Or KeyAscii = 1 Or KeyAscii = 2 Or KeyAscii = 9 Or KeyAscii = 19 Or KeyAscii = 21) Then
        KeyAscii = 0
        Exit Sub
    End If
Exit Sub
Erred:
    ErrorHandler "Whisper", "txtSend KeyPress"
    Resume Next
End Sub
Public Sub WhisAdd(ByVal strMessage As String)
Dim I             As Integer
Dim FontSize      As String
Dim FontNameStart As Integer
Dim FontNameEnd   As Integer
Dim URL           As String
Dim EndUrl        As Integer
Dim EndChar       As String
    On Error GoTo Erred
    rtbWhis.SelStart = Len(rtbWhis.Text)
    rtbWhis.SelLength = 0
    rtbWhis.SelText = vbNewLine
    rtbWhis.SelBold = 0
    rtbWhis.SelColor = MainApp.ChatBox.Color
    rtbWhis.SelFontName = MainApp.ChatBox.Font
    rtbWhis.SelFontSize = MainApp.ChatBox.Size
    rtbWhis.SelItalic = 0
    rtbWhis.SelStrikeThru = 0
    rtbWhis.SelUnderline = 0
    rtbWhis.SelAlignment = 0
    strMessage = Replace$(strMessage, vbNewLine, vbLf)
    strMessage = Replace$(strMessage, vbCr, vbLf)
    For I = 1 To Len(strMessage)
        rtbWhis.SelStart = Len(rtbWhis.Text)
        rtbWhis.SelLength = 0
        If ReadINI("Main", "Emoticons", "N", "Profiles\" & Profile & "\config.ini") = "Y" Then
            frmMain.imlSmileys.BackColor = rtbWhis.BackColor
            frmMain.imlSmileys.MaskColor = rtbWhis.BackColor
            If I > 1 Then If Mid$(strMessage, I - 1, 1) <> " " Then GoTo NoSmile
            Dim TmpFont  As New StdFont
            Dim TmpColor As Long
            Dim SmileRTF As String
            Dim SmileLen As Integer
            TmpFont.Bold = rtbWhis.SelBold
            TmpColor = rtbWhis.SelColor
            TmpFont.Italic = rtbWhis.SelItalic
            TmpFont.Name = rtbWhis.SelFontName
            TmpFont.Size = rtbWhis.SelFontSize
            TmpFont.Strikethrough = rtbWhis.SelStrikeThru
            TmpFont.Underline = rtbWhis.SelUnderline
            GetSmileyFromText Mid$(strMessage, I), SmileRTF, SmileLen
            If LenB(SmileRTF) > 0 Then
                rtbWhis.SelRTF = SmileRTF
                I = I + SmileLen
                rtbWhis.SelBold = TmpFont.Bold
                rtbWhis.SelColor = TmpColor
                rtbWhis.SelItalic = TmpFont.Italic
                rtbWhis.SelFontName = TmpFont.Name
                rtbWhis.SelFontSize = TmpFont.Size
                rtbWhis.SelStrikeThru = TmpFont.Strikethrough
                rtbWhis.SelUnderline = TmpFont.Underline
            End If
        End If
NoSmile:
        Select Case LCase$(Mid$(strMessage, I, 2))
        Case "c"
            Select Case Mid$(strMessage, I + 2, 1)
            Case "0"
                rtbWhis.SelColor = MainApp.ChatBox.Color
            Case "1"
                rtbWhis.SelColor = 255
            Case "2"
                rtbWhis.SelColor = 65280
            Case "3"
                rtbWhis.SelColor = 16711852
            Case "4"
                rtbWhis.SelColor = 44245
            Case "5"
                rtbWhis.SelColor = 8421504
            Case "6"
                rtbWhis.SelColor = 0
            Case "7"
                rtbWhis.SelColor = 44245
            Case "8"
                rtbWhis.SelColor = 32767
            Case "9"
                rtbWhis.SelColor = 65535
            Case "/"
                rtbWhis.SelColor = RGB(255, 255, 255)
            Case "<"
                rtbWhis.SelColor = 65280
            Case "&"
                rtbWhis.SelColor = 8421504
            Case "%"
                rtbWhis.SelColor = 65535
            Case "*"
                rtbWhis.SelColor = 16711680
            Case """"
                rtbWhis.SelColor = 16711680
            Case "("
                rtbWhis.SelColor = 12632256
            Case ")"
                rtbWhis.SelColor = 16776960
            Case "."
                rtbWhis.SelColor = 16776960
            Case "+"
                rtbWhis.SelColor = 16777138
            Case ":"
                rtbWhis.SelColor = 49152
            Case ";"
                rtbWhis.SelColor = 16711935
            Case "b"
                rtbWhis.SelBold = Not rtbWhis.SelBold
            Case "i"
                rtbWhis.SelItalic = Not rtbWhis.SelItalic
            Case "u"
                rtbWhis.SelUnderline = Not rtbWhis.SelUnderline
            Case "s"
                rtbWhis.SelStrikeThru = Not rtbWhis.SelStrikeThru
            Case "t"
                rtbWhis.SelColor = OtherApp.Bot
            Case "e"
                rtbWhis.SelColor = OtherApp.Error
            Case "f"
                If Mid$(strMessage, I + 2, 2) = "fr" Then
                    rtbWhis.SelColor = OtherApp.Friend
                    I = I + 1
                Else
                    GoTo Normal
                End If
            Case "o"
                If Mid$(strMessage, I + 2, 2) = "ot" Then
                    rtbWhis.SelColor = OtherApp.Other
                    I = I + 1
                Else
                    GoTo Normal
                End If
            Case Else
                GoTo Normal
            End Select
            rtbWhis.SelStart = Len(rtbWhis.Text)
            I = I + 2
        Case "w"
            rtbWhis.SelColor = RGB(255, 255, 255)
        Case "q"
            rtbWhis.SelColor = 8421504
        Case "r"
            rtbWhis.SelColor = 49152
        Case "v"
            rtbWhis.SelColor = 16711680
        Case "y"
            rtbWhis.SelColor = 255
        Case "z"
            rtbWhis.SelColor = 65535
        Case ""
            Select Case Mid$(strMessage, I + 2, 1)
            Case "0"
                rtbWhis.SelAlignment = 0
            Case "1"
                rtbWhis.SelAlignment = 1
            Case "2"
                rtbWhis.SelAlignment = 2
            Case Else
                GoTo Normal
            End Select
            rtbWhis.SelStart = Len(rtbWhis.Text)
            I = I + 2
        Case ""
            If IsNumeric(Mid$(strMessage, I + 2, 2)) Then
                FontSize = Mid$(strMessage, I + 2, 2)
                If Val(FontSize) > 0 And Val(FontSize) < 100 Then
                    rtbWhis.SelFontSize = Mid$(strMessage, I + 2, 2)
                    rtbWhis.SelStart = Len(rtbWhis.Text)
                    I = I + 3
                Else
                    GoTo Normal
                End If
            Else
                GoTo Normal
            End If
        Case ""
            If Mid$(strMessage, I + 2, 1) = """" Then
                FontNameStart = InStr(I, strMessage, """")
                FontNameStart = FontNameStart + 1
                FontNameEnd = InStrRev(strMessage, """")
                FontNameEnd = FontNameEnd - FontNameStart
                If FontNameStart > 0 And FontNameEnd > 0 Then
                    rtbWhis.SelFontName = Mid$(strMessage, FontNameStart, FontNameEnd)
                End If
                rtbWhis.SelStart = Len(rtbWhis.Text)
                I = I + 3 + Len(Mid$(strMessage, FontNameStart, FontNameEnd))
            Else
                GoTo Normal
            End If
        Case vbLf & Mid$(strMessage, I + 1, 1)
            rtbWhis.SelText = vbNewLine
        Case Else
Normal:
            If LCase$(Mid$(strMessage, I, 4)) = "www." Or LCase$(Mid$(strMessage, I, 7)) = "http://" Or LCase$(Mid$(strMessage, I, 8)) = "https://" Or LCase$(Mid$(strMessage, I, 6)) = "ftp://" Then
                For EndUrl = I To Len(strMessage)
                    EndChar = Mid$(strMessage, EndUrl, 1)
                    If EndChar = " " Then
                        URL = Mid$(strMessage, I, InStr(I, strMessage, " ") - I)
                        If Not LegalURL(URL) Then GoTo Norm2
                        HyperLink.AddLink Len(rtbWhis.Text), URL, URL, rtbWhis
                        I = EndUrl - 1
                        Exit For
                    ElseIf EndChar = vbLf Then
                        URL = Mid$(strMessage, I, InStr(I, strMessage, vbLf) - I)
                        If Not LegalURL(URL) Then GoTo Norm2
                        HyperLink.AddLink Len(rtbWhis.Text), URL, URL, rtbWhis
                        I = EndUrl + 1
                        rtbWhis.SelText = vbNewLine
                        Exit For
                    ElseIf EndChar = "" Then
                        URL = Mid$(strMessage, I, InStr(I, strMessage, "") - I)
                        If Not LegalURL(URL) Then GoTo Norm2
                        HyperLink.AddLink Len(rtbWhis.Text), URL, URL, rtbWhis
                        I = EndUrl - 1
                        Exit For
                    ElseIf EndUrl = Len(strMessage) Then
                        URL = Mid$(strMessage, I)
                        If Not LegalURL(URL) Then GoTo Norm2
                        HyperLink.AddLink Len(rtbWhis.Text), URL, URL, rtbWhis
                        I = EndUrl + 1
                        Exit For
                    End If
                Next EndUrl
            Else
Norm2:
                rtbWhis.SelText = Mid$(strMessage, I, 1)
            End If
        End Select
    Next I
    If ReadINI("Main", "MaxLines", "Y", "Profiles\" & Profile & "\config.ini") = "Y" Then MaxLines ReadINI("Main", "MaxLineCount", "500", "Profiles\" & Profile & "\config.ini"), rtbWhis, HyperLink
Exit Sub
Erred:
    ErrorHandler "Whisper", "ChatAdd"
    Resume Next
End Sub
Public Property Get WhisperTo() As String
    WhisperTo = CFm_WhisperTo
End Property
Public Property Let WhisperTo(PropVal As String)
    CFm_WhisperTo = PropVal
End Property
