VERSION 5.00
Begin VB.Form frmBans 
   Caption         =   "Bans"
   ClientHeight    =   3795
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6780
   Icon            =   "frmBans.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   3795
   ScaleWidth      =   6780
   WindowState     =   2  'Maximized
   Begin VB.ListBox lstBans 
      Height          =   3180
      IntegralHeight  =   0   'False
      Left            =   0
      TabIndex        =   3
      ToolTipText     =   "List of banned users."
      Top             =   0
      Width           =   6735
   End
   Begin VB.TextBox txtBannedUser 
      Height          =   315
      Left            =   0
      TabIndex        =   0
      ToolTipText     =   "Name of a user to add to the Ban List."
      Top             =   3360
      Width           =   4575
   End
   Begin VB.CommandButton cmdRemoveBan 
      Caption         =   "Remove"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5520
      TabIndex        =   2
      ToolTipText     =   "Remove the selected user from the Ban List."
      Top             =   3360
      Width           =   1215
   End
   Begin VB.CommandButton cmdAddBan 
      Caption         =   "Add"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4680
      TabIndex        =   1
      ToolTipText     =   "Add a new user to the Ban List."
      Top             =   3360
      Width           =   735
   End
End
Attribute VB_Name = "frmBans"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub cmdAddBan_Click()
    If txtBannedUser.Text <> vbNullString Then
        Dim I As Integer
        If lstBans.ListCount > 0 Then
            For I = 0 To lstBans.ListCount - 1
                If Trim$(LCase$(lstBans.List(I))) = Trim$(LCase$(txtBannedUser.Text)) Then
                    MsgBox txtBannedUser.Text & " already exists on the Ban list!", vbExclamation
                    txtBannedUser.SetFocus
                    Exit Sub
                End If
            Next I
        End If
        lstBans.AddItem txtBannedUser.Text
        txtBannedUser.Text = vbNullString
        txtBannedUser.SetFocus
    Else
        Beep
        txtBannedUser.SetFocus
    End If
End Sub
Private Sub cmdRemoveBan_Click()
    If lstBans.ListCount > 0 Then
        Dim I As Integer
        For I = 0 To lstBans.ListCount - 1
            If lstBans.Selected(I) = True Then
                lstBans.RemoveItem (I)
                Exit For
            End If
        Next I
    Else
        Beep
    End If
    txtBannedUser.SetFocus
End Sub
Private Sub Form_Resize()
    On Error Resume Next
    lstBans.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight - txtBannedUser.Height - 100
    txtBannedUser.Move 0, lstBans.Height + 100, Me.ScaleWidth - cmdAddBan.Width - cmdRemoveBan.Width - 200
    cmdAddBan.Move txtBannedUser.Width + 100, txtBannedUser.Top, cmdAddBan.Width, txtBannedUser.Height
    cmdRemoveBan.Move txtBannedUser.Width + cmdAddBan.Width + 200, txtBannedUser.Top, cmdRemoveBan.Width, txtBannedUser.Height
End Sub
Private Sub lstBans_DblClick()
    If lstBans.ListIndex > -1 Then
        txtBannedUser.Text = lstBans.Text
        lstBans.RemoveItem lstBans.ListIndex
    Else
        Beep
    End If
End Sub
Private Sub lstBans_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyDelete Then
        cmdRemoveBan_Click
    ElseIf KeyAscii = vbKeyInsert Then
        cmdAddBan_Click
    End If
End Sub
Private Sub txtBannedUser_GotFocus()
    txtBannedUser.SelStart = 0
    txtBannedUser.SelLength = Len(txtBannedUser)
End Sub
Private Sub txtBannedUser_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
        cmdAddBan_Click
        KeyAscii = 0
    ElseIf KeyAscii > 64 And KeyAscii < 91 Then
        'A-Z
    ElseIf KeyAscii > 96 And KeyAscii < 123 Then
        'a-z
    ElseIf KeyAscii > 47 And KeyAscii < 58 Then
        '0-9
    ElseIf KeyAscii = 40 Or KeyAscii = 41 Or KeyAscii = 91 Or KeyAscii = 93 Or KeyAscii = 95 Or KeyAscii = 45 Or KeyAscii = 46 Or KeyAscii = 64 Then
        'Symbols
    ElseIf KeyAscii = vbKeyBack Or KeyAscii = 26 Or KeyAscii = 24 Or KeyAscii = 3 Or KeyAscii = 22 Then
        'allowed others
    Else
        Beep
        KeyAscii = 0
    End If
End Sub
