VERSION 5.00
Begin VB.Form frmQuotes 
   Caption         =   "Quotes"
   ClientHeight    =   3825
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6765
   Icon            =   "frmQuotes.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   3825
   ScaleWidth      =   6765
   WindowState     =   2  'Maximized
   Begin VB.ListBox lstQuotes 
      Height          =   3180
      IntegralHeight  =   0   'False
      ItemData        =   "frmQuotes.frx":0442
      Left            =   0
      List            =   "frmQuotes.frx":0444
      TabIndex        =   3
      ToolTipText     =   "List of PermaSquelched users."
      Top             =   0
      Width           =   6735
   End
   Begin VB.TextBox txtQuotes 
      Height          =   315
      Left            =   0
      TabIndex        =   0
      ToolTipText     =   "Name of a user to add to the PermaSquelch List."
      Top             =   3360
      Width           =   4575
   End
   Begin VB.CommandButton cmdRemoveQuote 
      Caption         =   "Remove"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5520
      TabIndex        =   2
      ToolTipText     =   "Remove the selected user from the PermaSquelch List."
      Top             =   3360
      Width           =   1215
   End
   Begin VB.CommandButton cmdAddQuote 
      Caption         =   "Add"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4680
      TabIndex        =   1
      ToolTipText     =   "Add a new user to the PermaSquelch List."
      Top             =   3360
      Width           =   735
   End
End
Attribute VB_Name = "frmQuotes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub cmdAddQuote_Click()
    If txtQuotes.Text <> vbNullString Then
        Dim I As Integer
        If lstQuotes.ListCount > 0 Then
            For I = 0 To lstQuotes.ListCount - 1
                If Trim$(LCase$(lstQuotes.List(I))) = Trim$(LCase$(txtQuotes.Text)) Then
                    MsgBox txtQuotes.Text & " already exists on the Ban list!", vbExclamation
                    txtQuotes.SetFocus
                    Exit Sub
                End If
            Next I
        End If
        lstQuotes.AddItem txtQuotes.Text
        txtQuotes.Text = vbNullString
        txtQuotes.SetFocus
    Else
        Beep
        txtQuotes.SetFocus
    End If
End Sub
Private Sub cmdRemoveQuote_Click()
    If lstQuotes.ListCount > 0 Then
        Dim I As Integer
        For I = 0 To lstQuotes.ListCount - 1
            If lstQuotes.Selected(I) = True Then
                lstQuotes.RemoveItem (I)
                Exit For
            End If
        Next I
    Else
        Beep
    End If
    txtQuotes.SetFocus
End Sub
Private Sub Form_Resize()
    On Error Resume Next
    lstQuotes.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight - txtQuotes.Height - 100
    txtQuotes.Move 0, lstQuotes.Height + 100, Me.ScaleWidth - cmdAddQuote.Width - cmdRemoveQuote.Width - 200
    cmdAddQuote.Move txtQuotes.Width + 100, txtQuotes.Top, cmdAddQuote.Width, txtQuotes.Height
    cmdRemoveQuote.Move txtQuotes.Width + cmdAddQuote.Width + 200, txtQuotes.Top, cmdRemoveQuote.Width, txtQuotes.Height
End Sub
Private Sub lstQuotes_DblClick()
    If lstQuotes.ListIndex > -1 Then
        txtQuotes.Text = lstQuotes.Text
        lstQuotes.RemoveItem lstQuotes.ListIndex
    Else
        Beep
    End If
End Sub
Private Sub lstQuotes_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyDelete Then
        cmdRemoveQuote_Click
    ElseIf KeyAscii = vbKeyInsert Then
        cmdAddQuote_Click
    End If
End Sub
Private Sub txtQuotes_GotFocus()
    txtQuotes.SelStart = 0
    txtQuotes.SelLength = Len(txtQuotes)
End Sub
Private Sub txtQuotes_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
        cmdAddQuote_Click
        KeyAscii = 0
    End If
End Sub


