VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmResp 
   Caption         =   "Auto-Response"
   ClientHeight    =   4095
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7050
   Icon            =   "frmResp.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   4095
   ScaleWidth      =   7050
   WindowState     =   2  'Maximized
   Begin VB.CommandButton cmdDelResp 
      Caption         =   "Remove"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5760
      TabIndex        =   3
      ToolTipText     =   "Remove the selected Auto-Response."
      Top             =   3615
      Width           =   1215
   End
   Begin VB.CommandButton cmdAddResp 
      Caption         =   "Add"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4920
      TabIndex        =   2
      ToolTipText     =   "Add a new Auto-Response."
      Top             =   3615
      Width           =   735
   End
   Begin VB.TextBox txtSay 
      Height          =   285
      Left            =   0
      MaxLength       =   250
      TabIndex        =   0
      ToolTipText     =   "Key text to look for."
      Top             =   3720
      Width           =   2295
   End
   Begin VB.TextBox txtResp 
      Height          =   285
      Left            =   2400
      MaxLength       =   250
      TabIndex        =   1
      ToolTipText     =   "Response to display."
      Top             =   3720
      Width           =   2295
   End
   Begin MSComctlLib.ListView lvRespond 
      Height          =   3015
      Left            =   0
      TabIndex        =   4
      ToolTipText     =   "List of words to look for and responses to those words."
      Top             =   240
      Width           =   6975
      _ExtentX        =   12303
      _ExtentY        =   5318
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   0   'False
      HideSelection   =   0   'False
      Checkboxes      =   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Arial"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   2
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "User Text"
         Object.Width           =   6068
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Bot Response"
         Object.Width           =   6068
      EndProperty
   End
   Begin VB.Label lblSay 
      AutoSize        =   -1  'True
      BackColor       =   &H80000012&
      BackStyle       =   0  'Transparent
      Caption         =   "User Says:"
      ForeColor       =   &H80000008&
      Height          =   210
      Left            =   0
      TabIndex        =   5
      Top             =   3360
      UseMnemonic     =   0   'False
      Width           =   810
   End
   Begin VB.Label lblResp 
      AutoSize        =   -1  'True
      BackColor       =   &H80000012&
      BackStyle       =   0  'Transparent
      Caption         =   "Respond With:"
      ForeColor       =   &H80000008&
      Height          =   210
      Left            =   2400
      TabIndex        =   6
      Top             =   3360
      UseMnemonic     =   0   'False
      Width           =   1050
   End
   Begin VB.Label lblCheckbox 
      Alignment       =   2  'Center
      BackColor       =   &H80000012&
      BackStyle       =   0  'Transparent
      Caption         =   "Check the box next to the User Text if you wish the text to be Case-Sensitive."
      ForeColor       =   &H80000008&
      Height          =   210
      Left            =   825
      TabIndex        =   7
      Top             =   0
      UseMnemonic     =   0   'False
      Width           =   5655
   End
End
Attribute VB_Name = "frmResp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub lvRespond_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    lvRespond.SortKey = ColumnHeader.Index - 1
    If lvRespond.SortOrder = lvwAscending Then
        lvRespond.SortOrder = lvwDescending
    Else
        lvRespond.SortOrder = lvwAscending
    End If
    lvRespond.Sorted = True
End Sub
Private Sub txtResp_GotFocus()
    txtResp.SelStart = 0
    txtResp.SelLength = Len(txtResp)
End Sub
Private Sub txtResp_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
        cmdAddResp_Click
        KeyAscii = 0
    End If
End Sub
Private Sub txtSay_GotFocus()
    txtSay.SelStart = 0
    txtSay.SelLength = Len(txtSay)
End Sub
Private Sub txtSay_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
        KeyAscii = 0
        If txtResp.Text = vbNullString Then
            txtResp.SetFocus
        Else
            cmdAddResp_Click
        End If
    End If
End Sub
Private Sub cmdAddResp_Click()
    If LenB(txtSay.Text) <> 0 And LenB(txtResp.Text) <> 0 Then
        If lvRespond.ListItems.Count > 0 Then
            Dim I As Integer
            For I = 1 To lvRespond.ListItems.Count
                If Trim$(LCase$(lvRespond.ListItems(I).Text)) = Trim$(LCase$(txtSay.Text)) Then
                    MsgBox txtSay.Text & " already exists on the Auto-Response list!", vbExclamation
                    txtSay.SetFocus
                    Exit Sub
                End If
            Next I
        End If
        lvRespond.ListItems.Add , , txtSay.Text
        lvRespond.FindItem(txtSay, lvwText, , lvwWhole).SubItems(1) = txtResp.Text
        lvRespond.FindItem(txtSay, lvwText, , lvwWhole).Selected = True
        txtSay.Text = vbNullString
        txtResp.Text = vbNullString
        txtSay.SetFocus
    Else
        If LenB(txtResp.Text) = 0 Then txtResp.SetFocus
        If LenB(txtSay.Text) = 0 Then txtSay.SetFocus
        Beep
    End If
End Sub
Private Sub cmdDelResp_Click()
    If lvRespond.ListItems.Count > 0 Then
        If LenB(lvRespond.SelectedItem.Text) <> 0 Then
            lvRespond.ListItems.Remove lvRespond.SelectedItem.Index
        End If
        If lvRespond.ListItems.Count > 0 Then lvRespond.ListItems(lvRespond.ListItems.Count).Selected = True
    Else
        Beep
    End If
    txtSay.SetFocus
End Sub
Private Sub Form_Resize()
    On Error Resume Next
    lblCheckbox.Move 0, 0, Me.ScaleWidth
    lvRespond.Move 0, lblCheckbox.Height, Me.ScaleWidth, Me.ScaleHeight - lvRespond.Top - txtSay.Height - lblSay.Height - 200
    lblSay.Move 0, lvRespond.Top + lvRespond.Height + 100
    lblResp.Move (Me.ScaleWidth - cmdAddResp.Width - cmdDelResp.Width - 200) / 2, lblSay.Top
    txtSay.Move 0, lblSay.Top + lblSay.Height + 100, lblResp.Left - 100
    txtResp.Move lblResp.Left, txtSay.Top, txtSay.Width
    cmdAddResp.Move txtResp.Left + txtResp.Width + 100, lblSay.Top + lblSay.Height
    cmdDelResp.Move cmdAddResp.Left + cmdAddResp.Width + 100, cmdAddResp.Top
End Sub
