Attribute VB_Name = "INETRetrieve"
Option Explicit
Public CurrentStatus As String
Public BytesRead     As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Function ByteSize(ByVal InBytes As Variant) As String
    On Error GoTo Erred
    If InBytes > 1024 Then
        If InBytes / 1024 > 1024 Then
            If InBytes / 1024 / 1024 > 1024 Then
                If InBytes / 1024 / 1024 / 1024 > 1024 Then
                    ByteSize = Format$((InBytes) / 1024 / 1024 / 1024 / 1024, "0.0#") & " TB"
                Else
                    ByteSize = Format$((InBytes) / 1024 / 1024 / 1024, "0.0#") & " GB"
                End If
            Else
                ByteSize = Format$((InBytes) / 1024 / 1024, "0.0#") & " MB"
            End If
        Else
            ByteSize = Format$((InBytes) / 1024, "0.0#") & " KB"
        End If
    Else
        ByteSize = (InBytes) & " B"
    End If
Exit Function
Erred:
Dim iErr As Integer
    iErr = MsgBox("Error #" & Err.Number & ": " & Err.Description & vbNewLine & "Caused in ByteSize", vbAbortRetryIgnore)
    If iErr = vbAbort Then
        End
    ElseIf iErr = vbRetry Then
        Err.Clear
        Resume Next
    Else
        Err.Clear
    End If
End Function
Public Sub ChangeOBJColor(OBJ As Long, BGR As Integer, BGG As Integer, BGB As Integer, FGR As Integer, FGG As Integer, FGB As Integer)
    On Error GoTo Erred
    SendMessage OBJ, &H2000 + 1, 0, ByVal RGB(BGR, BGG, BGB)
    SendMessage OBJ, &H400 + 9, 0, ByVal RGB(FGR, FGG, FGB)
Exit Sub
Erred:
Dim iErr As Integer
    iErr = MsgBox("Error #" & Err.Number & ": " & Err.Description & vbNewLine & "Caused in ChangeOBJColor", vbAbortRetryIgnore)
    If iErr = vbAbort Then
        End
    ElseIf iErr = vbRetry Then
        Err.Clear
        Resume Next
    Else
        Err.Clear
    End If
End Sub
Public Sub RetreiveFile(intInet1 As Inet, ByVal FileDestination As String, StatusBar1 As ProgressBar, ByRef LabelStatus As Label)
Dim FileSize   As Long
Dim FileSizeKB As Long
Dim FileData() As Byte
Dim DComplete  As Boolean
Dim Filep1     As Long
    On Error GoTo Erred
    FileSize = Val(intInet1.GetHeader("Content-Length"))
    FileSizeKB = Round(FileSize / 1024, 2)
    LabelStatus.Caption = "0 bytes of " & FileSize & " bytes"
    StatusBar1.Max = FileSize
    StatusBar1.Value = 0
    BytesRead = 0
    FileData() = intInet1.GetChunk(1024, 1)
    BytesRead = 1024
    Filep1 = FreeFile
    Open FileDestination For Binary Access Write As #Filep1
    Do While Not DComplete
        If frmMain.Unloading Then Exit Do
        Put #Filep1, , FileData()
        StatusBar1.Value = IIf(StatusBar1.Value + 1024 > FileSize, FileSize, StatusBar1.Value + 1024)
        LabelStatus.Caption = CurrentStatus & vbNewLine & "(" & ByteSize(StatusBar1.Value) & " of " & ByteSize(FileSize) & ")"
        FileData() = intInet1.GetChunk(1024, 1)
        BytesRead = BytesRead + 1024
        DoEvents
        If UBound(FileData()) = -1 Then DComplete = True
    Loop
    Close #Filep1
Exit Sub
Erred:
Dim iErr As Integer
    iErr = MsgBox("Error #" & Err.Number & ": " & Err.Description & vbNewLine & "Caused in RetreiveFile", vbAbortRetryIgnore)
    If iErr = vbAbort Then
        End
    ElseIf iErr = vbRetry Then
        Err.Clear
        Resume Next
    Else
        Err.Clear
    End If
End Sub
