Attribute VB_Name = "modTray"
Option Explicit
Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Type NOTIFYICONDATA
    cbSize                        As Long
    hWnd                          As Long
    uID                           As Long
    uFlags                        As Long
    uCallbackMessage              As Long
    hIcon                         As Long
    szTip                         As String * 64
End Type
Private IconIsThere           As Boolean
Private NotifyIcon            As NOTIFYICONDATA
Private Const NIM_ADD         As Long = &H0
Private Const NIM_MODIFY      As Long = &H1
Private Const NIM_DELETE      As Long = &H2
Private Const NIF_MESSAGE     As Long = &H1
Private Const NIF_ICON        As Long = &H2
Private Const NIF_TIP         As Long = &H4
Private Const WM_MOUSEMOVE    As Long = &H200
Public Sub AddIconToTray(ByVal MeHwnd As Long, ByVal MeIcon As Long, ByVal Tip As String)
    With NotifyIcon
        .cbSize = Len(NotifyIcon)
        .hWnd = MeHwnd
        .uID = 1&
        .uFlags = NIF_MESSAGE Or NIF_ICON Or NIF_TIP
        .uCallbackMessage = WM_MOUSEMOVE
        .hIcon = MeIcon
        .szTip = Tip & ChrW$(0)
    End With
    Shell_NotifyIcon NIM_ADD, NotifyIcon
    IconIsThere = True
End Sub
Public Sub ChangeIcon(ByVal MeIcon As Long, ByVal Tip As String)
    If Not IconIsThere Then Exit Sub
    NotifyIcon.hIcon = MeIcon
    NotifyIcon.szTip = Tip & ChrW$(0)
    Shell_NotifyIcon NIM_MODIFY, NotifyIcon
End Sub
Public Sub RemoveIconFromTray()
    Shell_NotifyIcon NIM_DELETE, NotifyIcon
    IconIsThere = False
End Sub
