Attribute VB_Name = "modConstants"
Option Explicit

Public Const SID_NULL                         As Byte = &H0
Public Const SID_STOPADV                      As Byte = &H2
Public Const SID_SERVERLIST                   As Byte = &H4
Public Const SID_CLIENTID                     As Byte = &H5
Public Const SID_STARTVERSIONING              As Byte = &H6
Public Const SID_REPORTVERSION                As Byte = &H7
Public Const SID_STARTADVEX                   As Byte = &H8
Public Const SID_GETADVLISTEX                 As Byte = &H9
Public Const SID_ENTERCHAT                    As Byte = &HA
Public Const SID_GETCHANNELLIST               As Byte = &HB
Public Const SID_JOINCHANNEL                  As Byte = &HC
Public Const SID_CHATCOMMAND                  As Byte = &HE
Public Const SID_CHATEVENT                    As Byte = &HF
Public Const SID_LEAVECHAT                    As Byte = &H10
Public Const SID_LOCALEINFO                   As Byte = &H12
Public Const SID_FLOODDETECTED                As Byte = &H13
Public Const SID_UDPPINGRESPONSE              As Byte = &H14
Public Const SID_CHECKAD                      As Byte = &H15
Public Const SID_CLICKAD                      As Byte = &H16
Public Const SID_REGISTRY                     As Byte = &H18
Public Const SID_MESSAGEBOX                   As Byte = &H19
Public Const SID_STARTADVEX3                  As Byte = &H1C
Public Const SID_LOGONCHALLENGEEX             As Byte = &H1D
Public Const SID_CLIENTID2                    As Byte = &H1E
Public Const SID_LEAVEGAME                    As Byte = &H1F
Public Const SID_DISPLAYAD                    As Byte = &H21
Public Const SID_NOTIFYJOIN                   As Byte = &H22
Public Const SID_PING                         As Byte = &H25
Public Const SID_READUSERDATA                 As Byte = &H26
Public Const SID_WRITEUSERDATA                As Byte = &H27
Public Const SID_LOGONCHALLENGE               As Byte = &H28
Public Const SID_LOGONRESPONSE                As Byte = &H29
Public Const SID_CREATEACCOUNT                As Byte = &H2A
Public Const SID_GAMERESULT                   As Byte = &H2C
Public Const SID_GETICONDATA                  As Byte = &H2D
Public Const SID_GETLADDERDATA                As Byte = &H2E
Public Const SID_FINDLADDERUSER               As Byte = &H2F
Public Const SID_CDKEY                        As Byte = &H30
Public Const SID_CHANGEPASSWORD               As Byte = &H31
Public Const SID_CHECKDATAFILE                As Byte = &H32
Public Const SID_GETFILETIME                  As Byte = &H33
Public Const SID_QUERYREALMS                  As Byte = &H34
Public Const SID_PROFILE                      As Byte = &H35
Public Const SID_CDKEY2                       As Byte = &H36
Public Const SID_LOGONRESPONSE2               As Byte = &H3A
Public Const SID_CHECKDATAFILE2               As Byte = &H3C
Public Const SID_CREATEACCOUNT2               As Byte = &H3D
Public Const SID_LOGONREALMEX                 As Byte = &H3E
Public Const SID_STARTVERSIONING2             As Byte = &H3F
Public Const SID_QUERYREALMS2                 As Byte = &H40
Public Const SID_QUERYADURL                   As Byte = &H41
Public Const SID_WARCRAFTGENERAL              As Byte = &H44
Public Const SID_NETGAMEPORT                  As Byte = &H45
Public Const SID_NEWS_INFO                    As Byte = &H46
Public Const SID_OPTIONALWORK                 As Byte = &H4A
Public Const SID_REQUIREDWORK                 As Byte = &H4C
Public Const SID_AUTH_INFO                    As Byte = &H50
Public Const SID_AUTH_CHECK                   As Byte = &H51
Public Const SID_AUTH_ACCOUNTCREATE           As Byte = &H52
Public Const SID_AUTH_ACCOUNTLOGON            As Byte = &H53
Public Const SID_AUTH_ACCOUNTLOGONPROOF       As Byte = &H54
Public Const SID_AUTH_ACCOUNTCHANGE           As Byte = &H55
Public Const SID_AUTH_ACCOUNTCHANGEPROOF      As Byte = &H56
Public Const SID_SETEMAIL                     As Byte = &H59
Public Const SID_RESETPASSWORD                As Byte = &H5A
Public Const SID_CHANGEEMAIL                  As Byte = &H5B
Public Const SID_SWITCHPRODUCT                As Byte = &H5C
Public Const SID_GAMEPLAYERSEARCH             As Byte = &H60
Public Const SID_FRIENDSLIST                  As Byte = &H65
Public Const SID_FRIENDSUPDATE                As Byte = &H66
Public Const SID_FRIENDSADD                   As Byte = &H67
Public Const SID_FRIENDSREMOVE                As Byte = &H68
Public Const SID_FRIENDSPOSITION              As Byte = &H69
Public Const SID_CLANFINDCANDIDATES           As Byte = &H70
Public Const SID_CLANINVITEMULTIPLE           As Byte = &H71
Public Const SID_CLANCREATIONINVITATION       As Byte = &H72
Public Const SID_CLANDISBAND                  As Byte = &H73
Public Const SID_CLANMAKECHIEFTAIN            As Byte = &H74
Public Const SID_CLANINFO                     As Byte = &H75
Public Const SID_CLANQUITNOTIFY               As Byte = &H76
Public Const SID_CLANINVITATION               As Byte = &H77
Public Const SID_CLANREMOVEMEMBER             As Byte = &H78
Public Const SID_CLANINVITATIONRESPONSE       As Byte = &H79
Public Const SID_CLANRANKCHANGE               As Byte = &H7A
Public Const SID_CLANSETMOTD                  As Byte = &H7B
Public Const SID_CLANMOTD                     As Byte = &H7C
Public Const SID_CLANMEMBERLIST               As Byte = &H7D
Public Const SID_CLANMEMBERREMOVED            As Byte = &H7E
Public Const SID_CLANMEMBERSTATUSCHANGE       As Byte = &H7F
Public Const SID_CLANMEMBERRANKCHANGE         As Byte = &H81
Public Const SID_CLANMEMBERINFORMATION        As Byte = &H82

Public Const MCP_STARTUP                      As Byte = &H1
Public Const MCP_CHARCREATE                   As Byte = &H2
Public Const MCP_CREATEGAME                   As Byte = &H3
Public Const MCP_JOINGAME                     As Byte = &H4
Public Const MCP_GAMELIST                     As Byte = &H5
Public Const MCP_GAMEINFO                     As Byte = &H6
Public Const MCP_CHARLOGON                    As Byte = &H7
Public Const MCP_CHARDELETE                   As Byte = &HA
Public Const MCP_REQUESTLADDERDATA            As Byte = &H11
Public Const MCP_MOTD                         As Byte = &H12
Public Const MCP_CANCELGAMECREATE             As Byte = &H13
Public Const MCP_CREATEQUEUE                  As Byte = &H14
Public Const MCP_CHARLIST                     As Byte = &H17
Public Const MCP_CHARUPGRADE                  As Byte = &H18
Public Const MCP_CHARLIST2                    As Byte = &H19

Public Const BNLS_NULL                        As Byte = &H0
Public Const BNLS_CDKEY                       As Byte = &H1
Public Const BNLS_LOGONCHALLENGE              As Byte = &H2
Public Const BNLS_LOGONPROOF                  As Byte = &H3
Public Const BNLS_CREATEACCOUNT               As Byte = &H4
Public Const BNLS_CHANGECHALLENGE             As Byte = &H5
Public Const BNLS_CHANGEPROOF                 As Byte = &H6
Public Const BNLS_UPGRADECHALLENGE            As Byte = &H7
Public Const BNLS_UPGRADEPROOF                As Byte = &H8
Public Const BNLS_VERSIONCHECK                As Byte = &H9
Public Const BNLS_CONFIRMLOGON                As Byte = &HA
Public Const BNLS_HASHDATA                    As Byte = &HB
Public Const BNLS_CDKEY_EX                    As Byte = &HC
Public Const BNLS_CHOOSENLSREVISION           As Byte = &HD
Public Const BNLS_AUTHORIZE                   As Byte = &HE
Public Const BNLS_AUTHORIZEPROOF              As Byte = &HF
Public Const BNLS_REQUESTVERSIONBYTE          As Byte = &H10
Public Const BNLS_VERIFYSERVER                As Byte = &H11
Public Const BNLS_RESERVESERVERSLOTS          As Byte = &H12
Public Const BNLS_SERVERLOGONCHALLENGE        As Byte = &H13
Public Const BNLS_SERVERLOGONPROOF            As Byte = &H14
Public Const BNLS_RESERVED0                   As Byte = &H15
Public Const BNLS_RESERVED1                   As Byte = &H16
Public Const BNLS_RESERVED2                   As Byte = &H17
Public Const BNLS_VERSIONCHECKEX              As Byte = &H18
Public Const BNLS_RESERVED3                   As Byte = &H19
Public Const BNLS_VERSIONCHECKEX2             As Byte = &H1A

Public Const EID_SHOWUSER                     As Byte = &H1
Public Const EID_JOIN                         As Byte = &H2
Public Const EID_LEAVE                        As Byte = &H3
Public Const EID_WHISPER                      As Byte = &H4
Public Const EID_TALK                         As Byte = &H5
Public Const EID_BROADCAST                    As Byte = &H6
Public Const EID_CHANNEL                      As Byte = &H7
Public Const EID_USERFLAGS                    As Byte = &H9
Public Const EID_WHISPERSENT                  As Byte = &HA
Public Const EID_CHANNELFULL                  As Byte = &HD
Public Const EID_CHANNELDOESNOTEXIST          As Byte = &HE
Public Const EID_CHANNELRESTRICTED            As Byte = &HF
Public Const EID_INFO                         As Byte = &H12
Public Const EID_ERROR                        As Byte = &H13
Public Const EID_EMOTE                        As Byte = &H17

Public Const LOCALE_USER_DEFAULT              As Long = &H400
Public Const LOCALE_SABBREVLANGNAME           As Long = &H3
Public Const LOCALE_SENGCOUNTRY               As Long = &H1002
Public Const LOCALE_SABBREVCTRYNAME           As Long = &H7
Public Const LOCALE_SNATIVECTRYNAME           As Long = &H8
Public Const LOCALE_SISO3166CTRYNAME          As Long = &H5A
Public Const LOCALE_SISO639LANGNAME           As Long = &H59

Public Const BNCSUTIL_PLATFORM_X86            As Byte = &H1
Public Const BNCSUTIL_PLATFORM_PPC            As Byte = &H2
Public Const BNCSUTIL_PLATFORM_MAC            As Byte = &H2
Public Const BNCSUTIL_PLATFORM_OSX            As Byte = &H3

Public Const USER_BLIZZREP                    As Long = &H1
Public Const USER_CHANNELOP                   As Long = &H2
Public Const USER_SPEAKER                     As Long = &H4
Public Const USER_ADMIN                       As Long = &H8
Public Const USER_NOUDP                       As Long = &H10
Public Const USER_SQUELCHED                   As Long = &H20
Public Const USER_GUEST                       As Long = &H40
Public Const USER_INVISIBLE                   As Long = &H80
Public Const USER_BEEPENABLED                 As Long = &H100
Public Const USER_PGLPLAYER                   As Long = &H200
Public Const USER_PGLOFFICIAL                 As Long = &H400
Public Const USER_WCGPLAYER                   As Long = &H800
Public Const USER_WCGOFFICIAL                 As Long = &H1000
Public Const USER_KBKPLAYER                   As Long = &H2000
Public Const USER_KBKBEGINNER                 As Long = &H10000
Public Const USER_KBKWHITE                    As Long = &H20000
Public Const USER_GFOFFICIAL                  As Long = &H100000
Public Const USER_GFPLAYER                    As Long = &H200000

Public Const CHANNEL_PUBLIC                   As Long = &H1
Public Const CHANNEL_MODERATED                As Long = &H2
Public Const CHANNEL_RESTRICTED               As Long = &H4
Public Const CHANNEL_SILENT                   As Long = &H8
Public Const CHANNEL_SYSTEM                   As Long = &H10
Public Const CHANNEL_PRODUCTSPECIFIC          As Long = &H20
Public Const CHANNEL_GLOBAL                   As Long = &H1000

Public Const MB_OK                            As Byte = &H0
Public Const MB_OKCANCEL                      As Byte = &H1
Public Const MB_YESNO                         As Byte = &H4
Public Const MB_ICONSTOP                      As Byte = &H10
Public Const MB_ICONQUESTION                  As Byte = &H20
Public Const MB_ICONEXCLAMATION               As Byte = &H30
Public Const MB_ICONINFORMATION               As Byte = &H40

Public Const CLIENT_DRTL                      As Long = &H4452544C
Public Const CLIENT_DSHR                      As Long = &H44534852
Public Const CLIENT_D2DV                      As Long = &H44324456
Public Const CLIENT_D2XP                      As Long = &H44325850
Public Const CLIENT_STAR                      As Long = &H53544152
Public Const CLIENT_SSHR                      As Long = &H53534852
Public Const CLIENT_JSTR                      As Long = &H4A535452
Public Const CLIENT_SEXP                      As Long = &H53455850
Public Const CLIENT_W2BN                      As Long = &H5732424E
Public Const CLIENT_WAR3                      As Long = &H57415233
Public Const CLIENT_W3XP                      As Long = &H57335850

Public Const HKEY_CLASSES_ROOT                As Long = &H80000000
Public Const HKEY_CURRENT_USER                As Long = &H80000001
Public Const HKEY_LOCAL_MACHINE               As Long = &H80000002
Public Const HKEY_USERS                       As Long = &H80000003
Public Const HKEY_PERFORMANCE_DATA            As Long = &H80000004
Public Const HKEY_CURRENT_CONFIG              As Long = &H80000005
Public Const HKEY_DYN_DATA                    As Long = &H80000006

Public Const HANDCURSOR                       As Long = &H7F89
Public Const ARCH_IX86                        As Long = &H49583836
Public Const SRVR_BNET                        As Long = &H626E6574
Public Const LVM_GETCOUNTPERPAGE              As Long = &H1028
Public Const LVM_HITTEST                      As Long = &H1012
Public Const WM_GETMINMAXINFO                 As Long = &H24

Public Const WEBURL                           As String = "http://realityripple.com/software/freeware/RCB/"
