Attribute VB_Name = "modStorm"
Option Explicit
Private Declare Function SFileCloseArchive Lib "Storm.dll" Alias "#252" (ByVal hMPQ As Long) As Boolean
Private Declare Function SFileCloseFile Lib "Storm.dll" Alias "#253" (ByVal hFile As Long) As Boolean
Private Declare Function SFileDestroy Lib "Storm.dll" Alias "#262" () As Boolean
Private Declare Function SFileGetFileSize Lib "Storm.dll" Alias "#265" (ByVal hFile As Long, ByRef lpFileSizeHigh As Long) As Long
Private Declare Function SFileOpenArchive Lib "Storm.dll" Alias "#266" (ByVal lpFileName As String, ByVal dwPriority As Long, ByVal dwFlags As Long, ByRef hMPQ As Long) As Boolean
Private Declare Function SFileOpenFileEx Lib "Storm.dll" Alias "#268" (ByVal hMPQ As Long, ByVal lpFileName As String, ByVal dwSearchScope As Long, ByRef hFile As Long) As Boolean
Private Declare Function SFileReadFile Lib "Storm.dll" Alias "#269" (ByVal hFile As Long, lpBuffer As Byte, ByVal nNumberOfBYTEsToRead As Long, ByRef lpNumberOfBYTEsRead As Long, lpOverlapped As Long) As Boolean
Private Declare Function SFileAuthenticateArchive Lib "Storm.dll" Alias "#251" (ByVal hMPQ As Long, ByRef dwAuthenticationStatus As Long) As Boolean
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, lpOverlapped As Long) As Long
Public Sub TestExistance()
    SFileDestroy
End Sub
Public Function ExtractFromMPQ(ByVal strArchive As String, ByVal strFile As String) As String
Dim hMPQ       As Long
Dim hFile      As Long
Dim hOutput    As Long
Dim lngSize    As Long
Dim dwBytes    As Long
Dim szBuffer() As Byte
Dim Status     As Long
    SFileDestroy
    SFileOpenArchive App.Path & "\MPQs\" & strArchive, 0, 0, hMPQ
    SFileOpenFileEx hMPQ, strFile, 0, hFile
    SFileAuthenticateArchive hMPQ, Status
    If Status = &H0 Or Status = &H1 Or Status = &H5 Then
        lngSize = SFileGetFileSize(hFile, 0)
        ReDim szBuffer(0 To lngSize)
        SFileReadFile hFile, szBuffer(0), lngSize, dwBytes, ByVal &H0
        If dwBytes <> lngSize Then
            ExtractFromMPQ = "MPQ Corrupt (" & dwBytes & " / " & lngSize & ")"
            GoTo Failed
        End If
        If LenB(Dir$(App.Path & "\MPQs\" & strFile)) > 0 Then Kill App.Path & "\MPQs\" & strFile
        hOutput = CreateFileA(App.Path & "\MPQs\" & strFile, &H40000000, &H2, ByVal 0&, &H2, ByVal 0&, ByVal 0&)
        WriteFile hOutput, szBuffer(0), lngSize, dwBytes, ByVal &H0
        CloseHandle hOutput
        If dwBytes <> lngSize Then
            ExtractFromMPQ = "DLL Corrupt (" & dwBytes & " / " & lngSize & ")"
            GoTo Failed
        End If
        SFileCloseFile hFile
        SFileCloseArchive hMPQ
        SetFileTimeInfo App.Path & "\MPQs\" & strFile, GetFileTimeInfo(App.Path & "\MPQs\" & strArchive), GetFileTimeInfo(App.Path & "\MPQs\" & strArchive), GetFileTimeInfo(App.Path & "\MPQs\" & strArchive)
        ExtractFromMPQ = "OK"
    Else
        ExtractFromMPQ = "MPQ not authentic"
    End If
    SFileDestroy
    Exit Function
Failed:
    If hFile <> 0 Then SFileCloseFile hFile
    If hMPQ <> 0 Then SFileCloseArchive hMPQ
End Function
