Attribute VB_Name = "modWMP"
Option Explicit
Private Const NoLoad   As String = "Windows Media Player not loaded."
Public Function lngWMP() As Long
    On Error GoTo Erred
    lngWMP = FindWindowA("WMPlayerApp", vbNullString)
Exit Function
Erred:
    ErrorHandler "WMP Control", "lngWMP"
    Resume Next
End Function
Public Function strGetText(lngHwnd As Long) As String
Dim ilngLength As Long
Dim strBuffer  As String
    On Error GoTo Erred
    ilngLength = SendMessageA(lngHwnd, &HE, &H0, ByVal 0&)
    strBuffer = String$(ilngLength, 0)
    SendMessageA lngHwnd, &HD, ilngLength + 1, ByVal strBuffer
    strGetText = strBuffer
Exit Function
Erred:
    ErrorHandler "WMP Control", "GetText"
    Resume Next
End Function
Public Function strWMPTitle() As String
Dim strCaption As String
    On Error GoTo Erred
    If lngWMP = 0 Then
        strWMPTitle = NoLoad
    Else
        strCaption = strGetText(lngWMP)
        If strCaption = "Windows Media Player" Then
            strWMPTitle = "Nothing"
        Else
            strWMPTitle = Trim$(Left$(strCaption, InStr(1, strCaption, " - Windows Media Player")))
        End If
    End If
    Exit Function
Erred:
    ErrorHandler "WMP Control", "WMPTitle"
    Resume Next
End Function
Public Function WMPClose() As String
    On Error GoTo Erred
    If lngWMP = 0 Then
        WMPClose = NoLoad
    Else
        PostMessageA lngWMP, &H111, &HE141, 0
        WMPClose = "Windows Media Player Closed."
    End If
    Exit Function
Erred:
    ErrorHandler "WMP Control", "Close"
    Resume Next
End Function
Public Function WMPFadeOutStop() As String
Dim I As Integer
    On Error GoTo Erred
    If lngWMP = 0 Then
        WMPFadeOutStop = NoLoad
    Else
        For I = 100 To 0 Step -10
            Sleep 10
            WMPSetVolume I
        Next I
        WMPFadeOutStop = "Faded out."
        WMPStop
        WMPSetVolume 100
    End If
    Exit Function
Erred:
    ErrorHandler "WMP Control", "FadeOutStop"
    Resume Next
End Function
Public Function WMPJumpToFile(strFile As String) As String
Dim LastSong      As String
Dim Tried         As Boolean
Dim lngJumpWindow As Long
Dim TmpTime       As Long
Dim OnTheWay      As Long
Dim lngFinderBox  As Long
Dim lngSendFind   As Long
Dim WMPVer        As String
Dim FilePath      As String
Dim WMP11Button   As String
    On Error GoTo Erred
    If lngWMP = 0 Then
        WMPJumpToFile = NoLoad
    Else
        LastSong = strWMPTitle
        FilePath = ReadINI("Main", "WMPPath", Left$(App.Path, 3) & "Program Files\Windows Media Player\wmplayer.exe", "Profiles\" & Profile & "\config.ini")
ReTry:
        lngJumpWindow = FindWindowExA(lngWMP, 0, "WMPAppHost", vbNullString)
        WMPVer = Left$(DisplayProdVerInfo(FilePath), 2)
        If Right$(WMPVer, 1) = "." Then WMPVer = Left$(WMPVer, 1)
        If WMPVer = "9" Or WMPVer = "10" Then
            PostMessageA lngJumpWindow, &H201, &H1, &H110083
            PostMessageA lngJumpWindow, &H200, &H1, &H110083
            PostMessageA lngJumpWindow, &H202, &H0, &H110083
        'ElseIf WMPVer = "11" Then
        '    PostMessageA lngJumpWindow, &H201, &H1, &H20017C
        '    PostMessageA lngJumpWindow, &H200, &H1, &H20017C
        '    PostMessageA lngJumpWindow, &H202, &H0, &H20017C
        Else
            WMPJumpToFile = "Version " & WMPVer & " of Windows Media Player is not fully supported."
            Exit Function
        End If
        TmpTime = GetTickCount
        Do Until GetTickCount >= TmpTime + 200
            DoEvents
        Loop
        OnTheWay = FindWindowExA(lngJumpWindow, 0, "WMP Skin Host", vbNullString)
        If WMPVer = "9" Then
            OnTheWay = FindWindowExA(OnTheWay, 0, "ATL:075CB22F", vbNullString)
        ElseIf WMPVer = "10" Then
            OnTheWay = FindWindowExA(OnTheWay, 0, "ATL:0756E607", vbNullString)
        'ElseIf WMPVer = "11" Then
        '    OnTheWay = FindWindowExA(OnTheWay, 0, "ATL:131D3790", vbNullString)
        End If
        If OnTheWay = 0 And Not Tried Then
            PostMessageA lngWMP, &H111, &H4D11, 0
            Tried = True
            GoTo ReTry
        End If
        lngFinderBox = FindWindowExA(OnTheWay, 0, "Edit", vbNullString)
        SendMessageA lngFinderBox, &HC, 0, ByVal strFile
        lngSendFind = FindWindowExA(OnTheWay, 0, "ToolbarWindow32", vbNullString)
        PostMessageA lngSendFind, &H201, &H1, &HD002A
        PostMessageA lngSendFind, &H200, &H1, &HD002A
        PostMessageA lngSendFind, &H202, &H0, &HD002A
        Do Until GetTickCount >= TmpTime + 1000
            DoEvents
        Loop
        WMPStop
        WMPPlayPause
        PostMessageA lngJumpWindow, &H201, &H1, &H14001C
        PostMessageA lngJumpWindow, &H200, &H1, &H14001C
        PostMessageA lngJumpWindow, &H202, &H0, &H14001C
        If Tried Then PostMessageA lngWMP, &H111, &H4D11, 0
        TmpTime = GetTickCount
        Do Until GetTickCount >= TmpTime + 2000
            DoEvents
            If LastSong <> strWMPTitle And strWMPTitle <> "Nothing" Then Exit Do
        Loop
        If LastSong <> strWMPTitle Then
            WMPJumpToFile = "Playing " & strWMPTitle
        Else
            WMPJumpToFile = "Could not find " & strFile & "."
        End If
    End If
    Exit Function
Erred:
    ErrorHandler "WMP Control", "JumpToFile"
    Resume Next
End Function
Public Function WMPNext() As String
    On Error GoTo Erred
    If lngWMP = 0 Then
        WMPNext = NoLoad
    Else
        PostMessageA lngWMP, &H111, &H497B, 0
        WMPNext = "Skipped forward."
    End If
    Exit Function
Erred:
    ErrorHandler "WMP Control", "Next"
    Resume Next
End Function
Public Function WMPPlayPause() As String
    On Error GoTo Erred
    If lngWMP = 0 Then
        WMPPlayPause = NoLoad
    Else
        PostMessageA lngWMP, &H111, &H4978, 0
        WMPPlayPause = "Play/Pause Toggled."
    End If
    Exit Function
Erred:
    ErrorHandler "WMP Control", "Play"
    Resume Next
End Function
Public Function WMPPrevious() As String
    On Error GoTo Erred
    If lngWMP = 0 Then
        WMPPrevious = NoLoad
    Else
        PostMessageA lngWMP, &H111, &H497A, 0
        WMPPrevious = "Skipped back."
    End If
    Exit Function
Erred:
    ErrorHandler "WMP Control", "Previous"
    Resume Next
End Function
Public Function WMPSetVolume(intIndex As Integer) As String
Dim I As Integer
    On Error GoTo Erred
    If lngWMP = 0 Then
        WMPSetVolume = NoLoad
    Else
        intIndex = (intIndex \ 10) * 10
        For I = 0 To 9
            PostMessageA lngWMP, &H111, &H497F, 0
        Next I
        If intIndex <> 100 Then
            For I = 100 To intIndex Step -10
                PostMessageA lngWMP, &H111, &H4980, 0
            Next I
        End If
        WMPSetVolume = "Volume set to " & intIndex & "."
    End If
    Exit Function
Erred:
    ErrorHandler "WMP Control", "Volume"
    Resume Next
End Function
Public Function WMPStop() As String
    On Error GoTo Erred
    If lngWMP = 0 Then
        WMPStop = NoLoad
    Else
        PostMessageA lngWMP, &H111, &H4979, 0
        WMPStop = "Stopped."
    End If
    Exit Function
Erred:
    ErrorHandler "WMP Control", "Stop"
    Resume Next
End Function
Public Function WMPToggleRandom() As String
    On Error GoTo Erred
    If lngWMP = 0 Then
        WMPToggleRandom = NoLoad
    Else
        PostMessageA lngWMP, &H111, &H499A, 0
        WMPToggleRandom = "Random toggled."
    End If
    Exit Function
Erred:
    ErrorHandler "WMP Control", "Random"
    Resume Next
End Function
Public Function WMPToggleRepeat() As String
    On Error GoTo Erred
    If lngWMP = 0 Then
        WMPToggleRepeat = NoLoad
    Else
        PostMessageA lngWMP, &H111, &H499B, 0
        WMPToggleRepeat = "Repeat toggled."
    End If
    Exit Function
Erred:
    ErrorHandler "WMP Control", "Repeat"
    Resume Next
End Function
