Attribute VB_Name = "modWinamp"
Option Explicit
Private Const NoLoad   As String = "Winamp not loaded."
Public Function lngWinamp() As Long
    On Error GoTo Erred
    lngWinamp = FindWindowA("Winamp v1.x", vbNullString)
Exit Function
Erred:
    ErrorHandler "Winamp Control", "lngWinamp"
    Resume Next
End Function
Public Function strGetText(lngHwnd As Long) As String
Dim ilngLength As Long
Dim strBuffer  As String
    On Error GoTo Erred
    ilngLength = SendMessageA(lngHwnd, &HE, &H0, ByVal 0&)
    strBuffer = String$(ilngLength, 0)
    SendMessageA lngHwnd, &HD, ilngLength + 1, ByVal strBuffer
    strGetText = strBuffer
Exit Function
Erred:
    ErrorHandler "Winamp Control", "GetText"
    Resume Next
End Function
Public Function strWinampTitle() As String
Dim strCaption As String
    On Error GoTo Erred
    If lngWinamp = 0 Then
        strWinampTitle = NoLoad
    Else
        strCaption = strGetText(lngWinamp)
        If InStr(1, strCaption, ". ") > 0 Then strCaption = Trim$(Mid$(strCaption, InStr(1, strCaption, ". ") + 2))
        If InStr(1, strCaption, " - Winamp") > 0 Then
            strWinampTitle = Trim$(Left$(strCaption, InStr(1, strCaption, " - Winamp")))
        ElseIf Left$(strCaption, 6) = "Winamp" Then
            strWinampTitle = "Nothing"
        End If
    End If
    Exit Function
Erred:
    ErrorHandler "Winamp Control", "WinampTitle"
    Resume Next
End Function
Public Function winampClose() As String
    On Error GoTo Erred
    If lngWinamp = 0 Then
        winampClose = NoLoad
    Else
        PostMessageA lngWinamp, 273, 40001, 0
        winampClose = "Winamp Closed."
    End If
    Exit Function
Erred:
    ErrorHandler "Winamp Control", "Close"
    Resume Next
End Function
Public Function winampFadeOutStop() As String
    On Error GoTo Erred
    If lngWinamp = 0 Then
        winampFadeOutStop = NoLoad
    Else
        PostMessageA lngWinamp, 273, 40147, 0
        winampFadeOutStop = "Faded out."
    End If
    Exit Function
Erred:
    ErrorHandler "Winamp Control", "FadeOutStop"
    Resume Next
End Function
Public Function winampJumpToFile(strFile As String) As String
Dim LastSong   As String
Dim lngJumpto  As Long
Dim lngEdit    As Long
Dim lngListBox As Long
    On Error GoTo Erred
    If lngWinamp = 0 Then
        winampJumpToFile = NoLoad
    Else
        LastSong = strWinampTitle
        PostMessageA lngWinamp, &H111, &H9D02, 0
        Do
            DoEvents
            lngJumpto = FindWindowA("#32770", "Jump to file")
            lngEdit = FindWindowExA(lngJumpto, 0, "Edit", vbNullString)
            lngListBox = FindWindowExA(lngJumpto, 0, "ListBox", vbNullString)
        Loop Until lngListBox <> 0 And lngEdit <> 0
        DoEvents
        SendMessageA lngEdit, &HC, 0, ByVal strFile
        Sleep 250
        If SendMessageA(lngListBox, &H18B, 0, ByVal 0&) = 0 Then
            winampJumpToFile = "Could not find " & strFile & "."
            PostMessageA lngJumpto, &H10, 0, 0
        Else
            PostMessageA lngListBox, &H203, &H1, &H50005
            If LastSong <> strWinampTitle Then
                winampJumpToFile = "Playing " & strWinampTitle
            Else
                winampJumpToFile = "Already playing " & strWinampTitle
            End If
        End If
    End If
    Exit Function
Erred:
    ErrorHandler "Winamp Control", "JumpToFile"
    Resume Next
End Function
Public Function winampNext() As String
    On Error GoTo Erred
    If lngWinamp = 0 Then
        winampNext = NoLoad
    Else
        PostMessageA lngWinamp, 273, 40048, 0
        winampNext = "Skipped forward."
    End If
    Exit Function
Erred:
    ErrorHandler "Winamp Control", "Next"
    Resume Next
End Function
Public Function winampPause() As String
    On Error GoTo Erred
    If lngWinamp = 0 Then
        winampPause = NoLoad
    Else
        PostMessageA lngWinamp, 273, 40046, 0
        winampPause = "Paused."
    End If
    Exit Function
Erred:
    ErrorHandler "Winamp Control", "Pause"
    Resume Next
End Function
Public Function winampPlay() As String
    On Error GoTo Erred
    If lngWinamp = 0 Then
        winampPlay = NoLoad
    Else
        PostMessageA lngWinamp, 273, 40045, 0
        winampPlay = "Playing."
    End If
    Exit Function
Erred:
    ErrorHandler "Winamp Control", "Play"
    Resume Next
End Function
Public Function winampPrevious() As String
    On Error GoTo Erred
    If lngWinamp = 0 Then
        winampPrevious = NoLoad
    Else
        PostMessageA lngWinamp, 273, 40044, 0
        winampPrevious = "Skipped back."
    End If
    Exit Function
Erred:
    ErrorHandler "Winamp Control", "Previous"
    Resume Next
End Function
Public Function winampSetVolume(intIndex As Integer) As String
    On Error GoTo Erred
    If lngWinamp = 0 Then
        winampSetVolume = NoLoad
    Else
        SendMessageA lngWinamp, &H400, Val(intIndex) * 2.55, ByVal 122
        winampSetVolume = "Volume set to " & intIndex & "."
    End If
    Exit Function
Erred:
    ErrorHandler "Winamp Control", "Volume"
    Resume Next
End Function
Public Function winampStop() As String
    On Error GoTo Erred
    If lngWinamp = 0 Then
        winampStop = NoLoad
    Else
        PostMessageA lngWinamp, 273, 40047, 0
        winampStop = "Stopped."
    End If
    Exit Function
Erred:
    ErrorHandler "Winamp Control", "Stop"
    Resume Next
End Function
Public Function winampToggleRandom() As String
    On Error GoTo Erred
    If lngWinamp = 0 Then
        winampToggleRandom = NoLoad
    Else
        PostMessageA lngWinamp, 273, 40023, 0
        winampToggleRandom = "Random toggled."
    End If
    Exit Function
Erred:
    ErrorHandler "Winamp Control", "Random"
    Resume Next
End Function
Public Function winampToggleRepeat() As String
    On Error GoTo Erred
    If lngWinamp = 0 Then
        winampToggleRepeat = NoLoad
    Else
        PostMessageA lngWinamp, 273, 40022, 0
        winampToggleRepeat = "Repeat toggled."
    End If
    Exit Function
Erred:
    ErrorHandler "Winamp Control", "Repeat"
    Resume Next
End Function
