VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsConfig"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private CFm_Username      As String
Private CFm_Password      As String
Private CFm_CDKey         As String
Private CFm_EXPKey        As String
Public Enum GameType
    DRTL
    DSHR
    D2DV
    D2XP
    STAR
    SSHR
    JSTR
    SEXP
    W2BN
    WAR3
    W3XP
End Enum
#If False Then
Private DRTL, DSHR, D2DV, D2XP, STAR, SSHR, JSTR, SEXP, W2BN, WAR3, W3XP
#End If
Private CFm_Game          As GameType
Public Enum PingType
    High
    Normal
    Low
    Zero
    Negative
End Enum
#If False Then
Private High, Normal, Low, Zero, Negative
#End If
Private CFm_Ping          As PingType
Private CFm_PingHighNum   As Long
Private CFm_UDP           As Boolean
Private CFm_VerByte       As Byte
Private CFm_EMail         As String
Private CFm_HashPath      As String
Private CFm_HomeChannel   As String
Private CFm_Change        As New clsChange
Private CFm_Proxy         As New clsProxy
Private CFm_BNLS          As New clsBNLS
Private CFm_Server        As String
Private CFm_Statstring    As String
Private CFm_Spawn         As Boolean
Private CFm_DIIRealm      As Boolean
Public Property Get BNLS() As clsBNLS
    Set BNLS = CFm_BNLS
End Property
Public Property Set BNLS(PropVal As clsBNLS)
    Set CFm_BNLS = PropVal
End Property
Public Property Get CDKey() As String
Attribute CDKey.VB_Description = "Sets the CD-Key to connect with."
    CDKey = CFm_CDKey
End Property
Public Property Let CDKey(ByVal PropVal As String)
    CFm_CDKey = PropVal
End Property
Public Property Get Change() As clsChange
Attribute Change.VB_Description = "Change E-Mail and Password."
    Set Change = CFm_Change
End Property
Public Property Set Change(PropVal As clsChange)
    Set CFm_Change = PropVal
End Property
Public Property Get DIIRealm() As Boolean
Attribute DIIRealm.VB_Description = "Enables Realm Login for Diablo II."
    DIIRealm = CFm_DIIRealm
End Property
Public Property Let DIIRealm(ByVal PropVal As Boolean)
    CFm_DIIRealm = PropVal
End Property
Public Property Get EMail() As String
Attribute EMail.VB_Description = "Set's the E-Mail the account is registered to. (OPTIONAL)"
    EMail = CFm_EMail
End Property
Public Property Let EMail(ByVal PropVal As String)
    CFm_EMail = PropVal
End Property
Public Property Get EXPKey() As String
Attribute EXPKey.VB_Description = "Sets the Expansion Key to connect with (D2XP and W3XP only)."
    EXPKey = CFm_EXPKey
End Property
Public Property Let EXPKey(ByVal PropVal As String)
    CFm_EXPKey = PropVal
End Property
Public Property Get Game() As GameType
Attribute Game.VB_Description = "Sets the game to connect with."
    Game = CFm_Game
End Property
Public Property Let Game(PropVal As GameType)
    CFm_Game = PropVal
End Property
Public Property Get HashPath() As String
Attribute HashPath.VB_Description = "Sets the path to the hash files."
    HashPath = CFm_HashPath
End Property
Public Property Let HashPath(ByVal PropVal As String)
    CFm_HashPath = PropVal
End Property
Public Property Get HomeChannel() As String
Attribute HomeChannel.VB_Description = "Sets the channel to join. If left blank, will join the default channel."
    HomeChannel = CFm_HomeChannel
End Property
Public Property Let HomeChannel(ByVal PropVal As String)
    CFm_HomeChannel = PropVal
End Property
Public Property Get Password() As String
Attribute Password.VB_Description = "Sets the password to connect with."
    Password = CFm_Password
End Property
Public Property Let Password(ByVal PropVal As String)
    CFm_Password = PropVal
End Property
Public Property Get Ping() As PingType
Attribute Ping.VB_Description = "Sets the type of ping to spoof."
    Ping = CFm_Ping
End Property
Public Property Let Ping(PropVal As PingType)
    CFm_Ping = PropVal
End Property
Public Property Get PingHighNum() As Long
Attribute PingHighNum.VB_Description = "Sets the number of miliseconds to wait on a HIGH spoof."
    PingHighNum = CFm_PingHighNum
End Property
Public Property Let PingHighNum(ByVal PropVal As Long)
    CFm_PingHighNum = PropVal
End Property
Public Property Get Proxy() As clsProxy
Attribute Proxy.VB_Description = "Sets the proxy to connect through."
    Set Proxy = CFm_Proxy
End Property
Public Property Set Proxy(PropVal As clsProxy)
    Set CFm_Proxy = PropVal
End Property
Public Property Get Server() As String
Attribute Server.VB_Description = "Sets the server to connect to."
    Server = CFm_Server
End Property
Public Property Let Server(ByVal PropVal As String)
    CFm_Server = PropVal
End Property
Public Property Get Spawn() As Boolean
Attribute Spawn.VB_Description = "Sets whether to connect as normal or spawn."
    Spawn = CFm_Spawn
End Property
Public Property Let Spawn(ByVal PropVal As Boolean)
    CFm_Spawn = PropVal
End Property
Public Property Get Statstring() As String
Attribute Statstring.VB_Description = "Sets the DRTL/DSHR StatString."
    Statstring = CFm_Statstring
End Property
Public Property Let Statstring(ByVal PropVal As String)
    CFm_Statstring = PropVal
End Property
Public Property Get UDP() As Boolean
Attribute UDP.VB_Description = "Sets the UDP Plug on or off."
    UDP = CFm_UDP
End Property
Public Property Let UDP(ByVal PropVal As Boolean)
    CFm_UDP = PropVal
End Property
Public Property Get Username() As String
Attribute Username.VB_Description = "Sets the username to connect to."
    Username = CFm_Username
End Property
Public Property Let Username(ByVal PropVal As String)
    CFm_Username = PropVal
End Property
Public Property Get VerByte() As Byte
Attribute VerByte.VB_Description = "Sets the hash VerByte."
    VerByte = CFm_VerByte
End Property
Public Property Let VerByte(ByVal PropVal As Byte)
    CFm_VerByte = PropVal
End Property
