VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsToolTip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Const WM_USER                As Long = &H400
Private Const CW_USEDEFAULT          As Long = &H80000000
Private Type RECT
    Left                                 As Long
    Top                                  As Long
    Right                                As Long
    Bottom                               As Long
End Type
Private Const TTS_NOPREFIX           As Long = &H2
Private Const TTF_CENTERTIP          As Long = &H2
Private Const TTM_ADDTOOLA           As Double = (WM_USER + 4)
Private Const TTM_UPDATETIPTEXTA     As Double = (WM_USER + 12)
Private Const TTM_SETTIPBKCOLOR      As Double = (WM_USER + 19)
Private Const TTM_SETTIPTEXTCOLOR    As Double = (WM_USER + 20)
Private Const TTM_SETTITLE           As Double = (WM_USER + 32)
Private Const TTS_ALWAYSTIP          As Long = &H1
Private Const TTF_SUBCLASS           As Long = &H10
Private Const TTF_IDISHWND           As Long = &H1
Private Const TTM_SETDELAYTIME       As Double = (WM_USER + 3)
Private Const TTDT_AUTOPOP           As Integer = 2
Private Const TTDT_INITIAL           As Integer = 3
Private Const TOOLTIPS_CLASSA        As String = "tooltips_class32"
Private Type TOOLINFO
    lSize                                As Long
    lFlags                               As Long
    hwnd                                 As Long
    lId                                  As Long
    lpRect                               As RECT
    hInstance                            As Long
    lpStr                                As String
    lParam                               As Long
End Type
Public Enum ttIconType
    TTNoIcon = 0
    TTIconInfo = 1
    TTIconWarning = 2
    TTIconError = 3
End Enum
#If False Then
Private TTNoIcon, TTIconInfo, TTIconWarning, TTIconError
#End If
Private mvarBackColor                As Long
Private mvarTitle                    As String
Private mvarForeColor                As Long
Private mvarIcon                     As ttIconType
Private mvarCentered                 As Boolean
Private mvarTipText                  As String
Private mvarVisibleTime              As Long
Private mvarDelayTime                As Long
Private m_lTTHwnd                    As Long
Private m_lParentHwnd                As Long
Private ti                           As TOOLINFO
Private Declare Sub InitCommonControls Lib "comctl32.dll" ()
Private Declare Function CreateWindowExA Lib "user32" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long
Public Property Get BackColor() As Long
    On Error GoTo Erred
    BackColor = mvarBackColor
Exit Property
Erred:
    ErrorHandler "ToolTip", "Get BackColor"
    Resume Next
End Property
Public Property Let BackColor(ByVal vData As Long)
    On Error GoTo Erred
    mvarBackColor = vData
    If m_lTTHwnd <> 0 Then SendMessageA m_lTTHwnd, TTM_SETTIPBKCOLOR, mvarBackColor, 0&
Exit Property
Erred:
    ErrorHandler "ToolTip", "Let BackColor"
    Resume Next
End Property
Public Property Get Centered() As Boolean
    On Error GoTo Erred
    Centered = mvarCentered
Exit Property
Erred:
    ErrorHandler "ToolTip", "Get Centered"
    Resume Next
End Property
Public Property Let Centered(ByVal vData As Boolean)
    On Error GoTo Erred
    mvarCentered = vData
Exit Property
Erred:
    ErrorHandler "ToolTip", "Let Centered"
    Resume Next
End Property
Private Sub Class_Initialize()
    On Error GoTo Erred
    InitCommonControls
    mvarDelayTime = 500
    mvarVisibleTime = 5000
Exit Sub
Erred:
    ErrorHandler "ToolTip", "Initialize"
    Resume Next
End Sub
Private Sub Class_Terminate()
    On Error GoTo Erred
    Destroy
Exit Sub
Erred:
    ErrorHandler "ToolTip", "Terminate"
    Resume Next
End Sub
Public Function Create(ByVal ParentHwnd As Long) As Boolean
Dim lWinStyle As Long
    On Error GoTo Erred
    If m_lTTHwnd <> 0 Then
        DestroyWindow m_lTTHwnd
    End If
    m_lParentHwnd = ParentHwnd
    lWinStyle = TTS_ALWAYSTIP Or TTS_NOPREFIX
    m_lTTHwnd = CreateWindowExA(0&, TOOLTIPS_CLASSA, vbNullString, lWinStyle, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 0&, 0&, App.hInstance, 0&)
    If mvarCentered Then
        ti.lFlags = TTF_SUBCLASS Or TTF_CENTERTIP Or TTF_IDISHWND
    Else
        ti.lFlags = TTF_SUBCLASS Or TTF_IDISHWND
    End If
    ti.hwnd = m_lParentHwnd
    ti.lId = m_lParentHwnd
    ti.hInstance = App.hInstance
    ti.lSize = Len(ti)
    SendMessageA m_lTTHwnd, TTM_ADDTOOLA, 0&, ti
    If LenB(mvarTitle) <> 0 Or mvarIcon <> TTNoIcon Then SendMessageA m_lTTHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
    If mvarForeColor <> Empty Then SendMessageA m_lTTHwnd, TTM_SETTIPTEXTCOLOR, mvarForeColor, 0&
    If mvarBackColor <> Empty Then SendMessageA m_lTTHwnd, TTM_SETTIPBKCOLOR, mvarBackColor, 0&
    SendMessageA m_lTTHwnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, ByVal mvarVisibleTime
    SendMessageA m_lTTHwnd, TTM_SETDELAYTIME, TTDT_INITIAL, ByVal mvarDelayTime
Exit Function
Erred:
    ErrorHandler "ToolTip", "Create"
    Resume Next
End Function
Public Property Get DelayTime() As Long
    On Error GoTo Erred
    DelayTime = mvarDelayTime
Exit Property
Erred:
    ErrorHandler "ToolTip", "Get DelayTime"
    Resume Next
End Property
Public Property Let DelayTime(ByVal lData As Long)
    On Error GoTo Erred
    mvarDelayTime = lData
Exit Property
Erred:
    ErrorHandler "ToolTip", "Let DelayTime"
    Resume Next
End Property
Public Sub Destroy()
    On Error GoTo Erred
    If m_lTTHwnd <> 0 Then
        DestroyWindow m_lTTHwnd
    End If
Exit Sub
Erred:
    ErrorHandler "ToolTip", "Destroy"
    Resume Next
End Sub
Public Property Get ForeColor() As Long
    On Error GoTo Erred
    ForeColor = mvarForeColor
Exit Property
Erred:
    ErrorHandler "ToolTip", "Get ForeColor"
    Resume Next
End Property
Public Property Let ForeColor(ByVal vData As Long)
    On Error GoTo Erred
    mvarForeColor = vData
    If m_lTTHwnd <> 0 Then SendMessageA m_lTTHwnd, TTM_SETTIPTEXTCOLOR, mvarForeColor, 0&
Exit Property
Erred:
    ErrorHandler "ToolTip", "Let ForeColor"
    Resume Next
End Property
Public Property Get Icon() As ttIconType
    On Error GoTo Erred
    Icon = mvarIcon
Exit Property
Erred:
    ErrorHandler "ToolTip", "Get Icon"
    Resume Next
End Property
Public Property Let Icon(ByVal vData As ttIconType)
    On Error GoTo Erred
    mvarIcon = vData
    If m_lTTHwnd <> 0 And mvarTitle <> Empty And mvarIcon <> TTNoIcon Then SendMessageA m_lTTHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
Exit Property
Erred:
    ErrorHandler "ToolTip", "Let Icon"
    Resume Next
End Property
Public Property Get TipText() As String
    On Error GoTo Erred
    TipText = mvarTipText
Exit Property
Erred:
    ErrorHandler "ToolTip", "Get TipText"
    Resume Next
End Property
Public Property Let TipText(ByVal vData As String)
    On Error GoTo Erred
    mvarTipText = vData
    ti.lpStr = vData
    If m_lTTHwnd <> 0 Then SendMessageA m_lTTHwnd, TTM_UPDATETIPTEXTA, 0&, ti
Exit Property
Erred:
    ErrorHandler "ToolTip", "Let TipText"
    Resume Next
End Property
Public Property Get Title() As String
    On Error GoTo Erred
    Title = ti.lpStr
Exit Property
Erred:
    ErrorHandler "ToolTip", "Get Title"
    Resume Next
End Property
Public Property Let Title(ByVal vData As String)
    On Error GoTo Erred
    mvarTitle = vData
    If m_lTTHwnd <> 0 And mvarTitle <> Empty And mvarIcon <> TTNoIcon Then SendMessageA m_lTTHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
Exit Property
Erred:
    ErrorHandler "ToolTip", "Let Title"
    Resume Next
End Property
Public Property Get VisibleTime() As Long
    On Error GoTo Erred
    VisibleTime = mvarVisibleTime
Exit Property
Erred:
    ErrorHandler "ToolTip", "Get VisibleTime"
    Resume Next
End Property
Public Property Let VisibleTime(ByVal lData As Long)
    On Error GoTo Erred
    mvarVisibleTime = lData
Exit Property
Erred:
    ErrorHandler "ToolTip", "Let VisibleTime"
    Resume Next
End Property
