VERSION 5.00
Begin VB.Form frmAntiFlood 
   BackColor       =   &H00000000&
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Anti-Flood Customization"
   ClientHeight    =   4215
   ClientLeft      =   150
   ClientTop       =   390
   ClientWidth     =   3135
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00FFFFFF&
   Icon            =   "frmAntiFlood.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4215
   ScaleWidth      =   3135
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   1320
      TabIndex        =   14
      ToolTipText     =   "Apply Anti-Flood Settings."
      Top             =   3840
      Width           =   855
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2280
      TabIndex        =   15
      ToolTipText     =   "Close."
      Top             =   3840
      Width           =   855
   End
   Begin VB.CommandButton cmdDefault 
      Caption         =   "Defaults"
      Height          =   375
      Left            =   0
      TabIndex        =   16
      ToolTipText     =   "Select a Default setting."
      Top             =   3840
      Width           =   975
   End
   Begin VB.Frame fraAntiFlood 
      BackColor       =   &H00000000&
      Caption         =   "Anti-Flood Values"
      ForeColor       =   &H00FFFFFF&
      Height          =   3255
      Left            =   0
      TabIndex        =   18
      Top             =   480
      Width           =   3135
      Begin VB.Frame fraRate 
         BackColor       =   &H00000000&
         Caption         =   "Credit Replenish Rate"
         ForeColor       =   &H00FFFFFF&
         Height          =   855
         Left            =   120
         TabIndex        =   20
         Top             =   1920
         Width           =   2895
         Begin VB.TextBox txtNormRate 
            Alignment       =   1  'Right Justify
            BackColor       =   &H00000000&
            ForeColor       =   &H00FFFFFF&
            Height          =   315
            Left            =   480
            MaxLength       =   2
            TabIndex        =   9
            Text            =   "10"
            ToolTipText     =   "Credit divisor for replenish rate (lower numbers are more credits)."
            Top             =   480
            Width           =   495
         End
         Begin VB.TextBox txtHighRate 
            Alignment       =   1  'Right Justify
            BackColor       =   &H00000000&
            ForeColor       =   &H00FFFFFF&
            Height          =   315
            Left            =   1920
            MaxLength       =   2
            TabIndex        =   11
            Text            =   "25"
            ToolTipText     =   "Credit divisor for replenish rate under high load (more than 8 messages in a row) (lower numbers are more credits)."
            Top             =   480
            Width           =   495
         End
         Begin VB.Label Label5 
            Alignment       =   2  'Center
            BackColor       =   &H00000000&
            BackStyle       =   0  'Transparent
            Caption         =   "High Rate:"
            ForeColor       =   &H00FFFFFF&
            Height          =   255
            Left            =   1560
            TabIndex        =   10
            Top             =   240
            Width           =   1335
         End
         Begin VB.Label Label4 
            Alignment       =   2  'Center
            BackColor       =   &H00000000&
            BackStyle       =   0  'Transparent
            Caption         =   "Normal Rate:"
            ForeColor       =   &H00FFFFFF&
            Height          =   255
            Left            =   120
            TabIndex        =   8
            Top             =   240
            Width           =   1335
         End
      End
      Begin VB.Frame fraCost 
         BackColor       =   &H00000000&
         Caption         =   "Cost Per Byte"
         ForeColor       =   &H00FFFFFF&
         Height          =   855
         Left            =   120
         TabIndex        =   19
         Top             =   960
         Width           =   2895
         Begin VB.TextBox txtCostUnder 
            Alignment       =   1  'Right Justify
            BackColor       =   &H00000000&
            ForeColor       =   &H00FFFFFF&
            Height          =   315
            Left            =   1920
            MaxLength       =   2
            TabIndex        =   7
            Text            =   "5"
            ToolTipText     =   "Amount of credits to remove per byte if under threshold."
            Top             =   480
            Width           =   495
         End
         Begin VB.TextBox txtCostOver 
            Alignment       =   1  'Right Justify
            BackColor       =   &H00000000&
            ForeColor       =   &H00FFFFFF&
            Height          =   315
            Left            =   480
            MaxLength       =   2
            TabIndex        =   5
            Text            =   "12"
            ToolTipText     =   "Amount of credits to remove per byte if over threshold."
            Top             =   480
            Width           =   495
         End
         Begin VB.Label Label1 
            Alignment       =   2  'Center
            BackColor       =   &H00000000&
            BackStyle       =   0  'Transparent
            Caption         =   "Over Threshold:"
            ForeColor       =   &H00FFFFFF&
            Height          =   255
            Left            =   120
            TabIndex        =   4
            Top             =   240
            Width           =   1335
         End
         Begin VB.Label Label2 
            Alignment       =   2  'Center
            BackColor       =   &H00000000&
            BackStyle       =   0  'Transparent
            Caption         =   "Under Threshold:"
            ForeColor       =   &H00FFFFFF&
            Height          =   255
            Left            =   1560
            TabIndex        =   6
            Top             =   240
            Width           =   1335
         End
      End
      Begin VB.TextBox txtMaxCredits 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00000000&
         ForeColor       =   &H00FFFFFF&
         Height          =   315
         Left            =   2040
         MaxLength       =   4
         TabIndex        =   13
         Text            =   "800"
         ToolTipText     =   "Maximum number of credits to store."
         Top             =   2880
         Width           =   495
      End
      Begin VB.TextBox txtThreshold 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00000000&
         ForeColor       =   &H00FFFFFF&
         Height          =   315
         Left            =   2040
         MaxLength       =   3
         TabIndex        =   3
         Text            =   "65"
         ToolTipText     =   "Byte Threshold value to determine byte credit cost."
         Top             =   600
         Width           =   495
      End
      Begin VB.TextBox txtPacketCost 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00000000&
         ForeColor       =   &H00FFFFFF&
         Height          =   315
         Left            =   2040
         MaxLength       =   4
         TabIndex        =   1
         Text            =   "200"
         ToolTipText     =   "Number of credits to remove per packet."
         Top             =   240
         Width           =   495
      End
      Begin VB.Label Label6 
         BackColor       =   &H00000000&
         BackStyle       =   0  'Transparent
         Caption         =   "Maximum Credits:"
         ForeColor       =   &H00FFFFFF&
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   2880
         Width           =   1335
      End
      Begin VB.Label Label3 
         BackColor       =   &H00000000&
         BackStyle       =   0  'Transparent
         Caption         =   "Threshold:"
         ForeColor       =   &H00FFFFFF&
         Height          =   255
         Left            =   240
         TabIndex        =   2
         Top             =   600
         Width           =   975
      End
      Begin VB.Label lblCost 
         BackColor       =   &H00000000&
         BackStyle       =   0  'Transparent
         Caption         =   "Packet Cost:"
         ForeColor       =   &H00FFFFFF&
         Height          =   255
         Left            =   240
         TabIndex        =   0
         Top             =   240
         Width           =   975
      End
   End
   Begin VB.Label lblInstructions 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "The following settings control the Anti-Flood system for your bot."
      ForeColor       =   &H00FFFFFF&
      Height          =   495
      Left            =   0
      TabIndex        =   17
      Top             =   0
      Width           =   3135
   End
   Begin VB.Menu mnuDefaults 
      Caption         =   "Defaults"
      Visible         =   0   'False
      Begin VB.Menu mnuSafe 
         Caption         =   "SAFE"
      End
      Begin VB.Menu mnuFast 
         Caption         =   "FAST"
      End
      Begin VB.Menu mnuOff 
         Caption         =   "OFF"
      End
   End
End
Attribute VB_Name = "frmAntiFlood"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public Sub ApplySkin()
    If ReadINI("Main", "OnTop", "N", "Profiles\" & Profile & "\config.ini") = "Y" Then
        OnTop Me, True
    Else
        OnTop Me, False
    End If
End Sub
Private Sub cmdCancel_Click()
    Unload Me
End Sub
Private Sub cmdDefault_Click()
    PopupMenu mnuDefaults, , cmdDefault.Left, cmdDefault.Top
End Sub
Private Sub cmdOK_Click()
Dim strConfig As String
    If Not IsNumeric(txtPacketCost.Text) Then
        Beep
        txtPacketCost.SetFocus
    ElseIf Not IsNumeric(txtThreshold.Text) Then
        Beep
        txtThreshold.SetFocus
    ElseIf Not IsNumeric(txtCostOver.Text) Then
        Beep
        txtCostOver.SetFocus
    ElseIf Not IsNumeric(txtCostUnder.Text) Then
        Beep
        txtCostUnder.SetFocus
    ElseIf Not IsNumeric(txtNormRate.Text) Then
        Beep
        txtNormRate.SetFocus
    ElseIf Not IsNumeric(txtHighRate.Text) Then
        Beep
        txtHighRate.SetFocus
    ElseIf Not IsNumeric(txtMaxCredits.Text) Then
        Beep
        txtMaxCredits.SetFocus
    ElseIf txtPacketCost.Text < 1 Or txtPacketCost.Text > 9999 Then
        Beep
        txtPacketCost.SetFocus
    ElseIf txtThreshold.Text < 1 Or txtThreshold.Text > 200 Then
        Beep
        txtThreshold.SetFocus
    ElseIf txtCostOver.Text < 1 Or txtCostOver.Text > 99 Then
        Beep
        txtCostOver.SetFocus
    ElseIf txtCostUnder.Text < 1 Or txtCostUnder.Text > 99 Then
        Beep
        txtCostUnder.SetFocus
    ElseIf txtNormRate.Text < 1 Or txtNormRate.Text > 99 Then
        Beep
        txtNormRate.SetFocus
    ElseIf txtHighRate.Text < 1 Or txtHighRate.Text > 99 Then
        Beep
        txtHighRate.SetFocus
    ElseIf txtMaxCredits.Text < 1 Or txtMaxCredits.Text > 9999 Then
        Beep
        txtMaxCredits.SetFocus
    Else
        strConfig = "Profiles\" & Profile & "\AntiFlood.ini"
        WriteINI "AntiFlood", "PACKETCOST", txtPacketCost.Text, strConfig
        WriteINI "AntiFlood", "THRESHOLDBYTES", txtThreshold.Text, strConfig
        WriteINI "AntiFlood", "BYTEOVERTHRESHOLDCOST", txtCostOver.Text, strConfig
        WriteINI "AntiFlood", "BYTEUNDERTHRESHOLDCOST", txtCostUnder.Text, strConfig
        WriteINI "AntiFlood", "HIGHRATE", txtHighRate.Text, strConfig
        WriteINI "AntiFlood", "NORMRATE", txtNormRate.Text, strConfig
        WriteINI "AntiFlood", "MAXCREDITS", txtMaxCredits.Text, strConfig
        frmMain.BNet.LoadAntiFlood strConfig
        frmMain.ChatAdd Chr$(8) & "tAnti-Flood settings saved!"
        Unload Me
    End If
End Sub
Private Sub Form_Load()
Dim strConfig As String
    strConfig = "Profiles\" & Profile & "\AntiFlood.ini"
    txtPacketCost.Text = Val(ReadINI("AntiFlood", "PACKETCOST", "200", strConfig))
    txtThreshold.Text = Val(ReadINI("AntiFlood", "THRESHOLDBYTES", "65", strConfig))
    txtCostOver.Text = Val(ReadINI("AntiFlood", "BYTEOVERTHRESHOLDCOST", "12", strConfig))
    txtCostUnder.Text = Val(ReadINI("AntiFlood", "BYTEUNDERTHRESHOLDCOST", "5", strConfig))
    txtHighRate.Text = Val(ReadINI("AntiFlood", "HIGHRATE", "25", strConfig))
    txtNormRate.Text = Val(ReadINI("AntiFlood", "NORMRATE", "10", strConfig))
    txtMaxCredits.Text = Val(ReadINI("AntiFlood", "MAXCREDITS", "800", strConfig))
End Sub
Private Sub mnuFast_Click()
    txtPacketCost.Text = "120"
    txtThreshold.Text = "65"
    txtCostOver.Text = "10"
    txtCostUnder.Text = "8"
    txtNormRate.Text = "5"
    txtHighRate.Text = "10"
    txtMaxCredits.Text = "900"
End Sub
Private Sub mnuOff_Click()
    If MessageBox("This setting will turn off the Anti-Flood, which may cause you to get IPBanned when using multi-line commands" & vbNewLine & vbNewLine & "Are you sure you want to turn off the Anti-Flood?", Question, YesNo) = "Yes" Then
        txtPacketCost.Text = "1"
        txtThreshold.Text = "200"
        txtCostOver.Text = "1"
        txtCostUnder.Text = "1"
        txtNormRate.Text = "1"
        txtHighRate.Text = "1"
        txtMaxCredits.Text = "9999"
    End If
End Sub
Private Sub mnuSafe_Click()
    txtPacketCost.Text = "200"
    txtThreshold.Text = "65"
    txtCostOver.Text = "12"
    txtCostUnder.Text = "5"
    txtNormRate.Text = "10"
    txtHighRate.Text = "25"
    txtMaxCredits.Text = "800"
End Sub
Private Sub txtCostOver_GotFocus()
    txtCostOver.SelStart = 0
    txtCostOver.SelLength = Len(txtCostOver.Text)
End Sub
Private Sub txtCostOver_KeyPress(KeyAscii As Integer)
    If Not (KeyAscii >= vbKey0 And KeyAscii <= vbKey9) And Not KeyAscii = vbKeyBack Then KeyAscii = 0
End Sub
Private Sub txtCostUnder_GotFocus()
    txtCostUnder.SelStart = 0
    txtCostUnder.SelLength = Len(txtCostUnder.Text)
End Sub
Private Sub txtCostUnder_KeyPress(KeyAscii As Integer)
    If Not (KeyAscii >= vbKey0 And KeyAscii <= vbKey9) And Not KeyAscii = vbKeyBack Then KeyAscii = 0
End Sub
Private Sub txtHighRate_GotFocus()
    txtHighRate.SelStart = 0
    txtHighRate.SelLength = Len(txtHighRate.Text)
End Sub
Private Sub txtHighRate_KeyPress(KeyAscii As Integer)
    If Not (KeyAscii >= vbKey0 And KeyAscii <= vbKey9) And Not KeyAscii = vbKeyBack Then KeyAscii = 0
End Sub
Private Sub txtMaxCredits_GotFocus()
    txtMaxCredits.SelStart = 0
    txtMaxCredits.SelLength = Len(txtMaxCredits.Text)
End Sub
Private Sub txtMaxCredits_KeyPress(KeyAscii As Integer)
    If Not (KeyAscii >= vbKey0 And KeyAscii <= vbKey9) And Not KeyAscii = vbKeyBack Then KeyAscii = 0
End Sub
Private Sub txtNormRate_GotFocus()
    txtNormRate.SelStart = 0
    txtNormRate.SelLength = Len(txtNormRate.Text)
End Sub
Private Sub txtNormRate_KeyPress(KeyAscii As Integer)
    If Not (KeyAscii >= vbKey0 And KeyAscii <= vbKey9) And Not KeyAscii = vbKeyBack Then KeyAscii = 0
End Sub
Private Sub txtPacketCost_GotFocus()
    txtPacketCost.SelStart = 0
    txtPacketCost.SelLength = Len(txtPacketCost.Text)
End Sub
Private Sub txtPacketCost_KeyPress(KeyAscii As Integer)
    If Not (KeyAscii >= vbKey0 And KeyAscii <= vbKey9) And Not KeyAscii = vbKeyBack Then KeyAscii = 0
End Sub
Private Sub txtThreshold_GotFocus()
    txtThreshold.SelStart = 0
    txtThreshold.SelLength = Len(txtThreshold.Text)
End Sub
Private Sub txtThreshold_KeyPress(KeyAscii As Integer)
    If Not (KeyAscii >= vbKey0 And KeyAscii <= vbKey9) And Not KeyAscii = vbKeyBack Then KeyAscii = 0
End Sub
