VERSION 5.00
Begin VB.Form frmError 
   BackColor       =   &H00000000&
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Error #00 - Ripple Chat Bot"
   ClientHeight    =   1620
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   6345
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmError.frx":0000
   LinkTopic       =   "Error"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   108
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   423
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdReport 
      Cancel          =   -1  'True
      Caption         =   "&Report"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   11.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   4560
      TabIndex        =   1
      ToolTipText     =   "Report the error to RealityRipple Software."
      Top             =   480
      Width           =   1695
   End
   Begin VB.TextBox txtDetails 
      BackColor       =   &H00000000&
      ForeColor       =   &H00FFFFFF&
      Height          =   1815
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   5
      Top             =   1680
      Width           =   6135
   End
   Begin VB.CommandButton cmdDetails 
      Caption         =   "&Details >>"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   11.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   4560
      TabIndex        =   3
      ToolTipText     =   "Show Error Details."
      Top             =   1200
      Width           =   1695
   End
   Begin VB.CommandButton cmdContinue 
      Caption         =   "&Continue"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   11.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   4560
      TabIndex        =   0
      ToolTipText     =   "Continue using Ripple Chat Bot."
      Top             =   120
      Width           =   1695
   End
   Begin VB.CommandButton cmdEnd 
      Caption         =   "&End"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   11.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   4560
      TabIndex        =   2
      ToolTipText     =   "Exit the program immediately."
      Top             =   840
      Width           =   1695
   End
   Begin VB.Label lblDescr 
      Alignment       =   2  'Center
      BackColor       =   &H00000000&
      Caption         =   $"frmError.frx":000C
      ForeColor       =   &H00FFFFFF&
      Height          =   855
      Left            =   960
      TabIndex        =   6
      Top             =   600
      Width           =   3495
   End
   Begin VB.Label lblError 
      Alignment       =   2  'Center
      BackColor       =   &H00000000&
      BackStyle       =   0  'Transparent
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Error 0: No Error"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   375
      Left            =   1080
      TabIndex        =   4
      Top             =   120
      Width           =   3255
   End
   Begin VB.Image imgLogo 
      Height          =   720
      Left            =   120
      Picture         =   "frmError.frx":00B9
      ToolTipText     =   "Ripple Chat Bot"
      Top             =   360
      Width           =   720
   End
End
Attribute VB_Name = "frmError"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public Sub ApplySkin()
    If ReadINI("Main", "OnTop", "N", "Profiles\" & Profile & "\config.ini") = "Y" Then
        OnTop Me, True
    Else
        OnTop Me, False
    End If
End Sub
Private Sub cmdContinue_Click()
    On Error Resume Next
    Screen.MousePointer = 13
    Err.Clear
    Unload Me
    Screen.MousePointer = 0
End Sub
Private Sub cmdDetails_Click()
    If Me.Height = 3900 Then
        Me.Height = 1950
        cmdDetails.Caption = "&Details >>"
    Else
        Me.Height = 3900
        cmdDetails.Caption = "<< &Details"
    End If
End Sub
Private Sub cmdEnd_Click()
    On Error Resume Next
    frmMain.DontAskQuit = True
    End
    Screen.MousePointer = 0
End Sub
Private Sub cmdReport_Click()
    On Error Resume Next
    cmdReport.Visible = False
    cmdEnd.Top = 45
    frmReport.Show vbModal, Me
End Sub
Private Sub Form_Load()
    On Error Resume Next
    Screen.MousePointer = 13
    ApplySkin
    OnTop Me, True
    Me.Enabled = True
    Beep
    Screen.MousePointer = 0
End Sub
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    On Error Resume Next
    Screen.MousePointer = 13
    cmdContinue_Click
    Set frmError = Nothing
    Screen.MousePointer = 0
End Sub
Public Sub GetError(ErrNumber As String, ErrDescription As String, ErrSource As String, CauseItem As String, CauseForm As String)
Dim nFile As Integer
    On Error Resume Next
    frmReport.ErrNo = ErrNumber
    frmReport.ErrDesc = ErrDescription
    frmReport.Cause = CauseItem & " on " & CauseForm & " (" & ErrSource & ") [v" & Version & "]"
    lblError.Caption = "Error " & ErrNumber & ": " & ErrDescription
    txtDetails.Text = "Error " & ErrNumber & ": " & ErrDescription & vbNewLine & _
                      "Source: " & ErrSource & vbNewLine & _
                      "Caused By: " & CauseItem & " on " & CauseForm & vbNewLine & _
                      "For details on how to fix this error," & vbNewLine & _
                      "Contact RealityRipple (http://realityripple.com/about.php)"
End Sub
