VERSION 5.00
Begin VB.Form frmPacket 
   BackColor       =   &H00000000&
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Packet Builder"
   ClientHeight    =   2535
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   3255
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmPacket.frx":0000
   LinkTopic       =   "Packet"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2535
   ScaleWidth      =   3255
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.Timer tmrOnline 
      Interval        =   100
      Left            =   0
      Top             =   0
   End
   Begin VB.CheckBox chkDII 
      BackColor       =   &H00000000&
      Caption         =   "Send MCP Packet"
      ForeColor       =   &H00FFFFFF&
      Height          =   210
      Left            =   1440
      TabIndex        =   13
      ToolTipText     =   "Send as MCP (Diablo II Realm) Packet."
      Top             =   1920
      Width           =   1815
   End
   Begin VB.CommandButton cmdClear 
      Cancel          =   -1  'True
      Caption         =   "Clear"
      Height          =   375
      Left            =   2400
      TabIndex        =   9
      ToolTipText     =   "Clear Packet."
      Top             =   2160
      Width           =   855
   End
   Begin VB.CommandButton cmdSend 
      Caption         =   "Send"
      Default         =   -1  'True
      Height          =   375
      Left            =   1440
      TabIndex        =   8
      ToolTipText     =   "Send Packet."
      Top             =   2160
      Width           =   855
   End
   Begin VB.ListBox lstData 
      BackColor       =   &H00000000&
      ForeColor       =   &H00FFFFFF&
      Height          =   1740
      Left            =   1440
      TabIndex        =   12
      TabStop         =   0   'False
      ToolTipText     =   "Packet Data."
      Top             =   120
      Width           =   1815
   End
   Begin VB.Frame fraNew 
      BackColor       =   &H00000000&
      Caption         =   "New Data"
      ForeColor       =   &H00FFFFFF&
      Height          =   2175
      Left            =   0
      TabIndex        =   11
      Top             =   360
      Width           =   1335
      Begin VB.TextBox txtValue 
         BackColor       =   &H00000000&
         ForeColor       =   &H00FFFFFF&
         Height          =   315
         Left            =   120
         TabIndex        =   6
         ToolTipText     =   "Variable Data"
         Top             =   1440
         Width           =   1095
      End
      Begin VB.CommandButton cmdAdd 
         Caption         =   "Add"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         ToolTipText     =   "Add Variable to Packet."
         Top             =   1800
         Width           =   1095
      End
      Begin VB.OptionButton optWORD 
         BackColor       =   &H00000000&
         Caption         =   " Word"
         ForeColor       =   &H00FFFFFF&
         Height          =   255
         Left            =   120
         TabIndex        =   5
         ToolTipText     =   "WORD Variable."
         Top             =   1200
         Width           =   1095
      End
      Begin VB.OptionButton optString 
         BackColor       =   &H00000000&
         Caption         =   " String"
         ForeColor       =   &H00FFFFFF&
         Height          =   255
         Left            =   120
         TabIndex        =   4
         ToolTipText     =   "String Variable."
         Top             =   960
         Width           =   1095
      End
      Begin VB.OptionButton optDWORD 
         BackColor       =   &H00000000&
         Caption         =   " DWord"
         ForeColor       =   &H00FFFFFF&
         Height          =   255
         Left            =   120
         TabIndex        =   2
         ToolTipText     =   "DWORD Variable."
         Top             =   480
         Width           =   1095
      End
      Begin VB.OptionButton optNTString 
         BackColor       =   &H00000000&
         Caption         =   " NTString"
         ForeColor       =   &H00FFFFFF&
         Height          =   255
         Left            =   120
         TabIndex        =   3
         ToolTipText     =   "Null-Terminating String Variable."
         Top             =   720
         Width           =   1095
      End
      Begin VB.OptionButton optByte 
         BackColor       =   &H00000000&
         Caption         =   " Byte"
         ForeColor       =   &H00FFFFFF&
         Height          =   255
         Left            =   120
         TabIndex        =   1
         ToolTipText     =   "Byte Variable."
         Top             =   240
         Width           =   1095
      End
   End
   Begin VB.TextBox txtPacketID 
      BackColor       =   &H00000000&
      ForeColor       =   &H00FFFFFF&
      Height          =   285
      Left            =   840
      MaxLength       =   2
      TabIndex        =   0
      ToolTipText     =   "Packet ID number in Hex"
      Top             =   0
      Width           =   495
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackColor       =   &H00000000&
      Caption         =   "Packet ID:"
      ForeColor       =   &H00FFFFFF&
      Height          =   210
      Left            =   0
      TabIndex        =   10
      Top             =   0
      Width           =   705
   End
End
Attribute VB_Name = "frmPacket"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public Sub ApplySkin()
    If ReadINI("Main", "OnTop", "N", "Profiles\" & Profile & "\config.ini") = "Y" Then
        OnTop Me, True
    Else
        OnTop Me, False
    End If
End Sub
Private Sub cmdAdd_Click()
    If optByte.Value Then
        lstData.AddItem "BYTE " & txtValue.Text
    ElseIf optDWORD.Value Then
        lstData.AddItem "DWORD " & txtValue.Text
    ElseIf optNTString.Value Then
        lstData.AddItem "NTStr " & txtValue.Text
    ElseIf optString.Value Then
        lstData.AddItem "Str " & txtValue.Text
    ElseIf optWORD.Value Then
        lstData.AddItem "WORD " & txtValue.Text
    Else
        Beep
    End If
    txtValue.Text = vbNullString
End Sub
Private Sub cmdClear_Click()
    lstData.Clear
End Sub
Private Sub cmdSend_Click()
Dim I        As Integer
Dim DataType As String
Dim DataVal  As String
Dim Conv     As New clsConvert
    If LenB(txtPacketID.Text) = 0 Then
        Beep
        Exit Sub
        If HasFocus(Me) Then txtPacketID.SetFocus
    End If
    For I = 0 To lstData.ListCount - 1
        DataType = Left$(lstData.List(I), InStr(1, lstData.List(I), " ") - 1)
        DataVal = Mid$(lstData.List(I), InStr(1, lstData.List(I), " ") + 1)
        Select Case DataType
        Case "BYTE"
            frmMain.BNet.BuildCustomPacket pByte, DataVal
        Case "DWORD"
            frmMain.BNet.BuildCustomPacket pDWord, DataVal
        Case "NTStr"
            frmMain.BNet.BuildCustomPacket pNTString, DataVal
        Case "Str"
            frmMain.BNet.BuildCustomPacket pString, DataVal
        Case "WORD"
            frmMain.BNet.BuildCustomPacket pWord, DataVal
        End Select
    Next I
    If chkDII.Value = 1 Then
        If frmMain.BNet.SendCustomPacket(CByte(Conv.ConvertHexadecimalToDecimal(txtPacketID.Text)), True) = False Then MessageBox "Packet Send Failed!", Exclamation, OKOnly, "Packet send failure"
    Else
        If frmMain.BNet.SendCustomPacket(CByte(Conv.ConvertHexadecimalToDecimal(txtPacketID.Text)), False) = False Then MessageBox "Packet Send Failed!", Exclamation, OKOnly, "Packet send failure"
    End If
    lstData.Clear
    txtPacketID.Text = vbNullString
End Sub
Private Sub Form_Load()
    ApplySkin
End Sub
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set frmPacket = Nothing
End Sub
Private Sub tmrOnline_Timer()
    If Not frmMain.BNet.IsOnline Then Unload Me
End Sub
Private Sub txtPacketID_KeyPress(KeyAscii As Integer)
    If Not (KeyAscii >= vbKey0 And KeyAscii <= vbKey9) And Not (KeyAscii >= vbKeyA And KeyAscii <= vbKeyF) And Not (KeyAscii = 22 Or KeyAscii = 24 Or KeyAscii = 3) Then
        If KeyAscii <> vbKeyBack Then KeyAscii = 0
    End If
End Sub
Private Sub txtValue_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyReturn Then cmdAdd_Click
End Sub
